import java.io.*;
import java.util.*;
import java.math.BigInteger;
import static java.math.BigInteger.*;

public class Cipher {
	static BigInteger mem[][][] = new BigInteger[81][21][2];

	static BigInteger get(int v, int w, boolean lastSpace) {
		if (v == 0 && w == 0)
			return lastSpace ? ZERO : ONE;
		if (w < 0)
			return ZERO;

		if (mem[v][w][lastSpace ? 1 : 0] != null)
			return mem[v][w][lastSpace ? 1 : 0];
		BigInteger r = ZERO;
		for (int i = 1; i <= 27; i++) {
			if (i == 1 && lastSpace)
				continue;
			if (i > v)
				break;
			r = r.add(get(v - i, w - ((i == 1) ? 1 : 0), i == 1));
		}
		return mem[v][w][lastSpace ? 1 : 0] = r;
	}

	public static void main(String[] args) throws Exception {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(
				new FileInputStream("cipher.in"))));
		PrintStream out = new PrintStream(new File("cipher.out"));
		int t = in.nextInt();
		int tt = 1;
		//System.err.println(Long.MAX_VALUE);
		BigInteger mx=ZERO;
		for(int i=1;i<=75;i++)
			for(int j=1;j<=20;j++)
			{
				if(valueOf(Long.MAX_VALUE).compareTo(get(i,j,true))<0)
					System.err.println(get(i,j,true)+" "+i+" "+j);
				
			}
		if(mx.compareTo(ZERO)>0)
		System.err.println(mx);
		while (t-- > 0) {
			int v, w;
			long idx;
			v = in.nextInt();
			w = in.nextInt();
			idx = in.nextLong();
			String msg = "";
			boolean ls = true;
			w--;
			out.print("Case #" + tt++ + ": ");
			if (valueOf(idx).compareTo(get(v, w, true)) > 0)
				out.println("Corrupted!");
			else {
				while (v > 0) {
					for (int i = 1; i <= 27; i++) {
						if (i == 1 && ls)
							continue;
						if (get(v - i, w - ((i == 1) ? 1 : 0), i == 1)
								.compareTo(valueOf(idx)) < 0)
							idx -= get(v - i, w - ((i == 1) ? 1 : 0), i == 1)
									.longValue();
						else {
							msg += (char) (i == 1 ? ' ' : i - 2 + 'a');
							if (i == 1)
								w--;
							ls = i == 1;
							v -= i;
							break;
						}
					}
				}
				out.println(msg);
			}
		}
	}

}
