/*
 TASK:
 LANG: C++
 */
#include <algorithm>
#include <sstream>
#include <cstdio>
#include <cstdlib>
#include <cctype>
#include <cmath>
#include <iterator>
#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <list>
#include <bitset>
#include <cstring>
#include <climits>
#include <deque>
#include <utility>
#include <complex>
#include <numeric>
#include <functional>
#include <stack>
#include <iomanip>
#include <ctime>
#include <valarray>
//#include "vc.h"
#ifdef _MSC_VER
#include <hash_set>
#include <hash_map>
using namespace stdext;
#else
#if __GNUC__ > 2
#include <ext/hash_set>
#include <ext/hash_map>
using namespace __gnu_cxx;
#else
#include <hash_set>
#include <hash_map>
#endif
#endif

template<class key>
struct hashtemp {

	enum {
		bucket_size = 4, min_buckets = 8
	};
	virtual size_t operator()(const key &p) const=0;

};

using namespace std;
#ifndef M_PI
const long double M_PI=acos((long double)-1);
#endif
#define rep(i,n) for(int  i=0;i<(int)(n);++i)
long double ZERO = 0;
const long double INF = 1 / ZERO, EPSILON = 1e-12;
#define all(c) (c).begin(),(c).end()
#define rep2(i,a,b) for(int i=(a);i<=((int)b);++i)
#define foreach(it,c) for(__typeof((c).begin()) it=(c).begin();it!=(c).end();++it)

#define sz(v) ((int)((v).size()))
#define let(x,y) __typeof(y) x(y)

#define rrep(i,n) for(int  i=((int)n)-1;i>=0;--i)
#define rall(c) (c).rbegin(),(c).rend()
#define rrep2(i,a,b) for(int i=(a);i>=((int)b);--i)
#define rforeach(it,c) for(__typeof((c).rbegin()) it=(c).rbegin();it!=(c).rend();++it)
#define rep2d(i, j, v) rep(i, sz(v)) rep(j, sz(v[i]))
#define foreach2d(i, j, v) foreach(i,v) foreach(j,*i)

void Factorize(long long m, vector<long long>& p, vector<long long>& q) {//m=p1^q1*p2^q2..,np=size of p,q (1-indexed)
	long long a = m;
	long long i = 2;
	while ((unsigned long long) i * i <= (unsigned long long) a) {
		if (a % i == 0) {
			p.push_back(i);
			q.push_back(1);
			a /= i;
			while (a % i == 0) {
				q.back()++;
				a /= i;
			}
		}
		i += i == 2 ? 1 : 2;
	}
	if (a > 1) {
		p.push_back(a);
		q.push_back(1);
	}
}
int main() {
	std::ios_base::sync_with_stdio(false);
#ifndef ONLINE_JUDGE
	freopen("coprime.in", "rt", stdin);
	freopen("1.out", "wt", stdout);
#endif
	int t, tt = 1;
	cin >> t;

	while (t--) {
		long long a, b, n, res;
		cin >> a >> b >> n;
		res = b - a + 1;
		vector<long long> q, p;
		Factorize(n, p, q);
		cout << "Case #" << tt++ << ": ";
		rep(i,1<<p.size())
		{
			if(i)
			{
				long long x=1;
				int pc=0;
				rep(j,sz(p))
					if((i>>j)&1)
						x*=p[j],pc++;
				int s=pc%2?-1:1;
				long long ll=(a+x-1)/x;
				long long uu=(b)/x;
				res+=(uu-ll+1)*s;
			}
		}
		cout<<res<<endl;
	}
	return 0;
}
