#include<vector>
#include<iostream>
using namespace std;

#define big long long
#define SIZE(x) ((int)(x).size())

vector<big> p;
void factor(big n){
	p.clear();
	int a=1;
	for(big i = 2; i*i <= n; i+=a,a=2){
		if(n%i)continue;
		p.push_back(i);
		while(n%i==0)
			n/=i;
	}if(n > 1)p.push_back(n);
}

big get(big n, int idx, big soFar, int sign){
	big res = sign*n/soFar;
	//cout << sign << " " << n/soFar << " " << soFar << endl;
	for(int i = idx ; i < SIZE(p) ; i++){
		if(soFar*p[i] > n)break;
		res += get(n, i+1, soFar*p[i], -1*sign);
	}
	return res;
}

big solve(big A, big B, big N){
	factor(N);
	return get(B, 0, 1, 1)-get(A-1, 0, 1, 1);
}

int main(){

	freopen("coprime.in", "rt", stdin);
	freopen("coprime.out", "wt", stdout);

	int tt; cin >> tt;
	for(int t = 1 ; t <= tt ; t++){
		big A, B, N; cin >> A >> B >> N;
		assert(A >= 1 && A <= 1e15);
		assert(B >= 1 && B <= 1e15);
		assert(N >= 1 && N <= 1e9);

		cout << "Case #" << t << ": " << solve(A, B, N) << endl;
	}
	return 0;
}
