#include<iostream>
using namespace std;

const int WIN = 3;

int A[2], B[2];
double table[8][8][4][4][2];
bool vis[8][8][4][4][2];

double get(int g1, int g2, int s1, int s2, int t){

	if(max(s1, s2) >= WIN)
		return 0;
	if(vis[g1][g2][s1][s2][t])
		return table[g1][g2][s1][s2][t];

	if(max(g1, g2) >= 7 || (max(g1, g2) >= 6 && abs(g1-g2) >= 2))
		return get(0, 0, s1+(g1>g2), s2+(g2>g1), t);

	vis[g1][g2][s1][s2][t] = true;
	double r = 1;
	r += A[t]/100.*get(g1+1, g2, s1, s2, 1-t);
	r += B[t]/100.*get(g1, g2+1, s1, s2, 1-t);
	return table[g1][g2][s1][s2][t] = r;
}

int main(){

	freopen("wimbledon.in", "rt", stdin);
	freopen("wimbledon.out", "wt", stdout);

	int tt; cin >> tt;
	for(int t = 1 ; t <= tt ; t++){
		string s;
		cin >> s >> s >> A[0] >> s >> s >> B[1];
		A[1] = 100-B[1];
		B[0] = 100-A[0];
		memset(vis, 0, sizeof vis);
		double r = get(0, 0, 0, 0, 0);
		printf("Case #%d: %.6lf\n", t, 5*r);
	}

	return 0;
}
