#include <algorithm>
#include <queue>
#include <cstdlib>
#include <vector>
#include <cstdio>
#include <vector>
using namespace std;

const int MAXN = 100*100+10;

int n;
vector<int> edge[MAXN];
int m1[MAXN], m2[MAXN], c[MAXN];

int dfs(int u) {
    if (u<0) return 1;
    if (c[u]) return 0;
    c[u] = 1;
    for(vector<int>::iterator i=edge[u].begin();i!=edge[u].end();i++) 
        if (dfs(m2[*i])) {
            m1[u] = *i;
            m2[*i] = u;
            return 1;
        }
    return 0;
}

int dfs2(int u) {
    if (u<0) return 1;
    if (c[u]) return 0;
    c[u] = 1;
    for(vector<int>::iterator i=edge[u].begin();i!=edge[u].end();i++) 
        if (dfs2(m1[*i])) {
            //m1[u] = *i;
            //m2[*i] = u;
            return 1;
        }
    return 0;
}

int side[MAXN];

void scase() {
    char board[101][101];
    int rows, cols;
    scanf("%d%d",&rows,&cols);
    if (rows==0 && cols==0)
        exit(0);
    for(int i=0;i<rows;i++)
        scanf("%s",board[i]);
    n = rows*cols;
    
    for(int i=0;i<rows;i++)
        for(int j=0;j<cols;j++)
            if (/*((i+j)%2==1) &&*/ (board[i][j]=='.')) {
                side[i*cols+j] = (i+j)%2;
                if (i>0 && board[i-1][j]=='.') edge[i*cols+j].push_back((i-1)*cols+j);
                if (j>0 && board[i][j-1]=='.') edge[i*cols+j].push_back(i*cols+(j-1));
                if (i<rows-1 && board[i+1][j]=='.') edge[i*cols+j].push_back((i+1)*cols+j);
                if (j<cols-1 && board[i][j+1]=='.') edge[i*cols+j].push_back(i*cols+(j+1));
            }
    for(int i=0;i<n;i++) m1[i]=m2[i]=-1;
    bool ch;
    do {
        ch = 0;
        for(int i=0;i<n;i++) c[i] = 0;
        for(int i=0;i<n;i++) if (side[i]==1 && m1[i]<0) if (dfs(i)) ch = 1;
    } while (ch);



    for(int i=0;i<n;i++) c[i] = 0;
    for(int i=0;i<n;i++) if (side[i]==1 && m1[i]<0) dfs(i);
    for(int i=0;i<rows;i++)
        for(int j=0;j<cols;j++)
            if (((i+j)%2==1) && (board[i][j]=='.')) 
                if (c[i*cols+j]) board[i][j]='B'; else board[i][j] = 'A';

    for(int i=0;i<n;i++) c[i] = 0;
    for(int i=0;i<n;i++) if (side[i]==0 && m2[i]<0) dfs2(i);
    for(int i=0;i<rows;i++)
        for(int j=0;j<cols;j++)
            if (((i+j)%2==0) && (board[i][j]=='.')) 
                if (c[i*cols+j]) board[i][j]='B'; else board[i][j] = 'A';



    

    for(int i=0;i<n;i++) edge[i].clear();
    for(int i=0;i<rows;i++)
        printf("%s\n",board[i]);
    printf("\n");
}

int main() {
    for(;;) scase();
}

