#include <iostream>
#include <sstream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cctype>
#include <string>
#include <vector>
#include <list>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>
using namespace std;

#define FOR(i,a,b) for (int i = (a); i < (b); ++i)
#define FOR2(i,a,b) for (int i = (a); i > (b); ++i)
#define DEBUG(x) cout << '>' << #x << ':' << x << endl;
inline bool EQ(double a, double b) { return fabs(a-b) < 1e-9; }

const int INF = 1<<29;
typedef long long ll;
//////////////////////////////////////////////////////////////////////////////

int main()
{
	while (1)
	{
		double X,Y,r;
		int N;
		scanf("%lf %lf %d %lf", &X, &Y, &N, &r);
		if (X == 0 && Y == 0 && N == 0 && r == 0) break;
		r /= 100.0;
		r /= 12.0;
		r += 1.0;
		N *= 12;
		
		bool ok = false;
		FOR(i, 0, N)
		{
			X = (X*r)-Y;
			if (X <= 1e-9)
			{
				ok = true;
				break;
			}
		}
		if (ok) printf("YES\n");
		else printf("NO\n");
	}
	return 0;
}