#include <iostream>
#include <sstream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cctype>
#include <string>
#include <vector>
#include <list>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>
using namespace std;

#define FOR(i,a,b) for (int i = (a); i < (b); ++i)
#define FOR2(i,a,b) for (int i = (a); i > (b); ++i)
#define DEBUG(x) cout << '>' << #x << ':' << x << endl;
inline bool EQ(double a, double b) { return fabs(a-b) < 1e-9; }

const int INF = 1<<29;
typedef long long ll;
//////////////////////////////////////////////////////////////////////////////

struct rec
{
	int num;
	char op;	
} input[147];

char text[147*5];

int main()
{
	while (1)
	{
		gets(text);
		int len = strlen(text);
		if (text[0] == 'E') break;
		
		int P = 0, index = 0, n = 0;
		char op = '+';
		while (index < len)
		{
			n = 0;
			while (index < len && isdigit(text[index]))
				n = n*10+text[index++]-'0';
			input[P].num = n;
			input[P].op = op;
			++P;
			if (index == len) break;
			op = text[index++];
		}
		
		ll minimum = 0, maximum = 0;
		
		// minimum
		int be = 0, en = P;
		FOR(i, 0, P)
		{
			if (input[i].num == 0 && input[i].op == '*')
				be = i+1;
			if (i+1 < P && input[i].num == 0 && input[i+1].op == '*')
				en = min(en, i+1);
		}
		if (en-be > 0)
		{
			ll temp = 1;
			FOR(i, be, en)
			{
				temp *= input[i].num;
				if (i+1 < en && input[i+1].op == '+')
				{
					minimum += temp;
					temp = 1;	
				}	
			}
			minimum += temp;
		}
		
		//maximum
		FOR(i, 0, P)
		{
			if (input[i].num == 0)
			{
				input[i].num = -1;
				
			}
		}
		int P2 = 0;
		FOR(i, 0, P)
			if (input[i].num != -1)
				input[P2++] = input[i];
		if (P2)
		{
			maximum = 1;
			ll temp = 0;
			FOR(i, 0, P2)
			{
				temp += input[i].num;
				if (i+1 < P2 && input[i+1].op == '*')
				{
					maximum *= temp;
					temp = 0;
				}
			}
			maximum *= temp;
		}
		
		cout << minimum << " " << maximum << endl;
	}
	return 0;
}