#include <iostream>
#include <cstdio>
#include <cstring>

using namespace std;

typedef unsigned int uint;

static const int MaxPoints = 40000;

struct Point
{
    Point(int x = 0, int y = 0) : x(x), y(y) {}
    int x;
    int y;
};

struct Line
{
    Point a;
    Point b;
};

Line lines[MaxPoints];
Point points[MaxPoints];
uint linesCount;
uint pointsCount;

void reset()
{
    memset(lines, 0, sizeof(lines));
    linesCount = 0;
}

bool intersects(Line const& l1, Line const& l2)
{
    
}

void solve()
{
}

int main()
{
     while (cin >> pointsCount && pointsCount != 0) {
	reset();
	Point first;
	
	Point previous(-1, -1);
	Point a;
	for (uint i = 0; i < pointsCount; ++i) {
	    cin >> a.x >> a.y;
	    points[i] = a;
	}
	
	for (uint i = 0; i < pointsCount - 1; ++i) {
	    Line l;
	    l.a = points[i];
	    l.b = points[i + 1];
	    lines[i] = l;
	}
	Line l;
	l.a = points[pointsCount - 1];
	l.b = points[0];
	lines[pointsCount - 1] = l;
	linesCount = pointsCount;
	
	/*
	for (uint i = 0; i < linesCount; ++i) {
	    cerr << lines[i].a.x << ' ' << lines[i].a.y << ',' << lines[i].b.x << ' ' << lines[i].b.y << endl;
	}
	*/
	
	bool doIntersect = false;
	for (uint i = 0; i < linesCount; ++i) {
	    if (intersects(lines[i], lines[i + 1])) {
		doIntersect = true;
		break;
	    }
	}
	if (intersects(lines[linesCount - 1], lines[0])) {
	    doIntersect = true;
	}
	
	if (doIntersect) {
	    cout << "NO" << endl;
	}
	else {
	    cout << "YES" << endl;
	}
    }
}