/*
 * CTU Open Contest 2011
 *
 * Sample solution: Ambiguous Result
 * Author: Martin Kacer
 */

import java.io.BufferedReader;
import java.io.InputStreamReader;

public class result {
	static final int MAXNUMS = 1000;
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	public static void main(String[] args) throws Exception {
		result instance = new result();
		while (instance.run()) {/*repeat*/}
	}

	int[] numbers = new int[MAXNUMS];
	char[] opers = new char[MAXNUMS-1];
	int count;
	long[][] minres = new long[MAXNUMS+1][MAXNUMS+1], maxres = new long[MAXNUMS+1][MAXNUMS+1];
	
	long compute(long a, char op, long b) {
		return (op == '+') ? a+b : a*b;
	}

	boolean run() throws Exception {
		count = 0;
		for (;;) {
			int ch = input.read();
			if (ch == 'E') return false;
			numbers[count] = 0;
			while (Character.isDigit(ch)) {
				numbers[count] = numbers[count] * 10 + ch - '0';
				ch = input.read();
			}
			++count;
			if (ch == '\r') ch = input.read();
			if (ch == '\n') break;
			opers[count] = (char) ch;
		}
		for (int i = 0; i < count; ++i) minres[i][i+1] = maxres[i][i+1] = numbers[i];
		for (int k = 2; k <= count; ++k)
			for (int i = 0; i <= count-k; ++i) {
				minres[i][i+k] = Long.MAX_VALUE; maxres[i][i+k] = -1;
				for (int j = i+1; j < i+k; ++j) {
					long x = compute(minres[i][j], opers[j], minres[j][i+k]);
					if (x < minres[i][i+k]) minres[i][i+k] = x;
					x = compute(maxres[i][j], opers[j], maxres[j][i+k]);
					if (x > maxres[i][i+k]) maxres[i][i+k] = x;
				}
				//System.err.println(" DBG: " + i + "," + k + ": " + minres[i][i+k] + "-" + maxres[i][i+k]);
			}
		System.out.println(minres[0][count] + " " + maxres[0][count]);
		return true;
	}
}
