#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include <vector>
#include <string>
#include <iostream>
#include <cmath>
#include <cctype>
#include <sstream>
#include <algorithm>
#include <iomanip>
#include <set>
#include <queue>
#include <cassert>

using namespace std;

int main()
{
	freopen("input.txt" ,"rt", stdin); freopen("output.txt", "wt", stdout);

	int i, j;
	string w, t;
	cin >> w >> t;

	int m = w.size();
	int n = t.size();
	
	assert(m <= 100);
	assert(n <= 1000);

	vector<int> a;
	for (i = 0; i < n+1-m; i++) {
		int ok = 1;
		for (j = 0; j < m; j++) {
			if (w[j] != t[i+j]) ok = 0;
		}
		if (ok) a.push_back(i);
	}

	int k = a.size();

	int last = -1;
	int ans_max = 0;
	for (i = 0; i < k; i++) {
		if (last == -1 || a[last]+m-1 < a[i]) {
			ans_max++;
			last = i;
		}
	}

	last = 0;
	int ans_min = 0;
	int mode = 1;
	for (i = 1; i < k; i++) {
		if (mode == 1) {
			if (a[last]+m-1 < a[i]) {
				mode = 2;
				last = i-1;
				ans_min++;
			}
		} 
		if (mode == 2) {
			if (a[last]+m-1 < a[i]) {
				mode = 1;
				last = i;
			}
		}
	}
	if (mode == 1 && k)
		ans_min++;

	cout << ans_min << " " << ans_max;

	fclose(stdin); fclose(stdout);
	return 0;   
}
