{$mode objfpc}{$assertions on}{$h+}{$r+}
uses
  Types, Classes, SysUtils, StrUtils;

function Cmp(A: TStringList; i, j: Integer): Integer;
begin
  Result := StrComp(PChar(A[i]), PChar(A[j]));
end;

type
  TGuess = record prob: Double; name: String; end;
var
  guesses: array of array of TGuess;
  allNames: TStringList;
  i, j, k, mi, n, g: Integer;
  s: String;
  p, mp: Double;
begin
  DecimalSeparator := '.';
  AssignFile(input, 'input.txt'); Reset(input);
  AssignFile(output, 'output.txt'); Rewrite(output);
  allNames := TStringList.Create;
  Readln(n);
  SetLength(guesses, n);
  for i := 0 to High(guesses) do begin
    Readln(g);
    SetLength(guesses[i], g);
    for j := 0 to g - 1 do begin
      Readln(s);
      s := Trim(s);
      k := Pos(' ', s);
      Assert(k > 0);
      with guesses[i, j] do begin
        prob := StrToInt(Copy(s, 1, k - 1));
        name := Trim(Copy(s, k + 1, Length(s)));
        allNames.AddObject(name, TObject(i * 10000 + j));
      end;
    end;
  end;
  allNames.AddObject(Chr(200), nil);
  allNames.CaseSensitive := false;
  allNames.CustomSort(@Cmp);
  mp := 0.0;
  mi := -1;
  p := 0.0;
  for i := 0 to allNames.Count - 1 do begin
    s := allNames[i];
    if (i > 0) and (s <> allNames[i - 1]) then begin
      //Writeln(p:0:5, ' ', allNames[i - 1]);
      if p > mp then
        mp := p;
      p := 0.0;
    end;
    k := Integer(allNames.Objects[i]);
    p += guesses[k div 10000, k mod 10000].prob;
  end;
  p := 0.0;
  for i := 0 to allNames.Count - 1 do begin
    s := allNames[i];
    if (i > 0) and (s <> allNames[i - 1]) then begin
      if p = mp then Writeln(allNames[i - 1]);
      p := 0.0;
    end;
    k := Integer(allNames.Objects[i]);
    p += guesses[k div 10000, k mod 10000].prob;
  end;
end.
