use strict;
use warnings;

open my $fi, '<input.txt';
open my $fo, '>output.txt';

my $n = <$fi>;
my %scores;
my $best = "";

for (1..$n) {
	my $k = <$fi>;
	for (1..$k) {
		<$fi> =~ /(\d+)\s+(\w+)/;
		$scores{$2} += $1;
		if ($scores{$2} > $scores{$best}) {
			$best = $2;
		}
	}
}

my @list;
$scores{$_} == $scores{$best} and push @list, $_ for keys %scores;

$, = "\n";
print $fo sort @list;

close $fi;
close $fo;
