#include <stdio.h>
#include <iostream>

#include <vector>


using namespace std;


int n;
vector<long long> ans;


struct Elem {
	long long value;
	int p;
	Elem(long long _value, int _p): value(_value), p(_p) {  }
};
vector<Elem> pos, neg, *a, *b;


long long tmp;
const long long MaxA = 10*1000;


inline long long longAbs(long long x) {
	return x < 0 ? -x : x;
}


int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	cin >> n;
	ans.resize(n);

	for (int i = 0; i < n; i++) {
		cin >> tmp;
		if (longAbs(tmp) > MaxA || !tmp) {
			cerr << "Out of range input";
			throw;
		}
		(tmp < 0 ? neg : pos).push_back(Elem(tmp, i));
	}

	a = &pos;
	b = &neg;
	if (neg.size() > pos.size()) {
		swap(a, b);
	}
	
	if (a->size() > 2 * b->size()) {
		cerr << "pos and neg differ from each other more than 2 times";
		throw;
	}
	
	int k3 = a->size() - b->size();
	for (int i = 0; i < k3; i++) {
		Elem& ea1 = (*a)[2*i];
		Elem& ea2 = (*a)[2*i+1];
		Elem& eb = (*b)[i];
		
		ans[eb.p] = longAbs(ea1.value) + longAbs(ea2.value);
		ans[ea1.p] = longAbs(eb.value);
		ans[ea2.p] = longAbs(eb.value);
	}

	for (int i = k3; i < b->size(); i++) {
		Elem& ea = (*a)[k3 + i];
		Elem& eb = (*b)[i];

		ans[ea.p] = longAbs(eb.value);
		ans[eb.p] = longAbs(ea.value);
	}

	for (int i = 0; i < n; i++) {
		cout << ans[i] << " ";
	}

	fclose(stdin);
	fclose(stdout);
	return 0;
}
