/*--------------------------------------------------------------*/
/* ACM ICPC 2011-2012, NEERC                                    */
/* Northern Subregional Contest                                 */
/* St Petersburg, October 29, 2011                              */
/*--------------------------------------------------------------*/
/* Problem A. Automated Telephone Exchange                      */
/*                                                              */
/* Original idea         Egor Kulikov                           */
/* Problem statement     Egor Kulikov                           */
/* Testset               Egor Kulikov                           */
/*--------------------------------------------------------------*/
/* Checker                                                      */
/*                                                              */
/* Author                Egor Kulikov                           */
/*--------------------------------------------------------------*/
import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;
import ru.ifmo.testlib.Outcome.Type;

import java.util.*;

public class Check implements Checker {

    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        int ja = ans.nextInt();
        int pa = ouf.nextInt();
        if (ja == pa) {
            return new Outcome(Type.OK, "ok " + pa);
        } else {
            return new Outcome(Type.WA, "ja = " + ja + "; pa = " + pa);
        }
    }
}
