/*--------------------------------------------------------------*/
/* ACM ICPC 2011-2012, NEERC                                    */
/* Northern Subregional Contest                                 */
/* St Petersburg, October 29, 2011                              */
/*--------------------------------------------------------------*/
/* Problem D. Dice                                              */
/*                                                              */
/* Original idea         Georgiy Korneev                        */
/* Problem statement     Dmitry Shtukenberg                     */
/* Testset               Anton Akhi                             */
/*--------------------------------------------------------------*/
/* Solution                                                     */
/*                                                              */
/* Author                Dmitry Shtukenberg                     */
/*--------------------------------------------------------------*/
 
#include <stdio.h>
#include <stdlib.h>

#define MAX_N 1000
#define MAX_AI 100

int a [MAX_N];
int a_ind [MAX_N];
int res [MAX_N][MAX_AI];

int a_cmp (const void* x, const void* y) {
	return a[*(int*)x] - a[*(int*)y];
}

int main () {
	FILE* f = fopen ("dice.in","rt");
	FILE* fo = fopen ("dice.out","wt");

	int i,j,n,m = 0;
	double e = 0;

	fscanf (f, "%d", &n);

	for (i = 0; i < n; i++) {
		fscanf (f, "%d", a + i);
		m += a [i];
		a_ind [i] = i;
	}

	qsort (a_ind, n, sizeof (*a_ind), a_cmp);

	for (i = 0; i < n; i++) {
		int idx = a_ind[i];
		double ei = 0;
		for (j = 0; j < a[idx]; j++) {
			ei += m;
			res [idx][j] = m--;
		}
		e += ei / a[idx];
	}

	fprintf (fo, "%f\n", e);
	for (i = 0; i < n; i++) {
		for (j = 0; j < a[i]; j++)
			fprintf (fo, "%d ",res [i][j]);
		fprintf (fo, "\n");
	}
	fclose (f);
	fclose (fo);
}
