import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;


public class F {
	private static String problem = "flat";
	
	BufferedReader in;
	PrintWriter out;
	
	private String line = null;
	private StringTokenizer st = null;
	
	public String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = in.readLine();
			st = new StringTokenizer(line);
		}
		
		return st.nextToken();		
	}
	
	public int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	public void run() throws Exception {
		Locale.setDefault(Locale.US);
		in = new BufferedReader(new FileReader(problem + ".in"));
		out = new PrintWriter(problem + ".out");
		solve();
		in.close();
		out.close();
	}
	
	public void solve() throws Exception {
		long n = nextInt();
		long c = nextInt();
		long sum = 0;
		long sr = 0;
		long sb = 0;
		for (int i = 0; i < n; ++i) {
			int s = nextInt();
			sr += s;
			String t = nextToken();
			if (t.equals("balcony")) {
				sum += s;				
			} else {
				sum += 2* s; 
			}
			
			if (t.equals("bedroom")) {
				sb += s;
			}
		}
		
		out.println(sr);
		out.println(sb);
		long cost = sum * c;
		out.print(cost / 2);
		out.println((cost % 2 == 1) ? ".5" : ".0");
		
	}
	
	public static void main(String[] args) throws Exception {
		new F().run();
	}
	

}
