import java.io.*;
import java.util.*;
import java.math.*;

public class A {
	void solve() throws IOException {
		int n = nextInt();
		int ans = 0;
		for (int i = 0; i < 100; i++) {
			int x = n - i;
			if (x >= 0 && x < 100)
				ans++;
		}
		out.print(ans);
	}

	static final String FILENAME = "ate";

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	void run() throws IOException {
		br = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		solve();
		out.close();
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null) {
				return null;
			}
			st = new StringTokenizer(s);
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	double parseDouble() throws IOException {
		return Double.parseDouble(next());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new A().run();
	}
}
