import java.io.*;
import java.util.*;
import java.math.*;

public class B {
	void solve() throws IOException {
		int m = nextInt();
		int n = nextInt();
		int s = nextInt();
		int k = nextInt();
		char[] t = br.readLine().toCharArray();
		boolean was = false;
		for (int i = 0; i < t.length; i++) {
			if (t[i] == '*') {
				if (was) {
					out.println("Impossible");
					return;
				}
				was = true;
				for (int j = 0; j < s; j++) {
					if (i + j >= n || t[i + j] != '*') {
						out.println("Impossible");
						return;
					}
				}
				i += s - 1;
			}
		}
		if (!was) {
			if ((k == s + 1) && k > m - s && s == n) {
				out.println("Unique");
			} else if (k == m - s && k <= s  && s == n) {
				out.println("Unique");
			} else if (k >= s + 1 || k <= m - s) {
				out.println("Ambiguous");
			} else {
				out.println("Impossible");
			}
			return;
		} 
		if (k == 1 || k == m || s == 1 || s == m) {
			out.println("Unique");
		} else {
			out.println("Ambiguous");
		}
	}

	static final String FILENAME = "black";

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	void run() throws IOException {
		br = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		solve();
		out.close();
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null) {
				return null;
			}
			st = new StringTokenizer(s);
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	double parseDouble() throws IOException {
		return Double.parseDouble(next());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new B().run();
	}
}
