import java.io.*;
import java.util.*;
import java.math.*;

public class F {
	void solve() throws IOException {
		int n = nextInt();
		long c = nextLong();
		long rooms = 0;
		long balcony = 0;
		long bedroom = 0;
		for (int i = 0; i < n; i++) {
			int s = nextInt();
			String name = next();
			if ("bedroom".equals(name)) {
				bedroom += s;
			}
			if ("balcony".equals(name)) {
				balcony += s;
			}
			rooms += s;
		}
		out.println(rooms);
		out.println(bedroom);
		out.println((rooms - balcony / 2.0) * c);
	}

	static final String FILENAME = "flat";

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	void run() throws IOException {
		br = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		solve();
		out.close();
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null) {
				return null;
			}
			st = new StringTokenizer(s);
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	double parseDouble() throws IOException {
		return Double.parseDouble(next());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new F().run();
	}
}
