import java.io.*;
import java.util.*;
import java.math.*;

public class H {
	Pass[] s;

	// static final int size = 22;
	// long[] values = new long[1 << 22]

	long hash(long L, long R, long pos, long rem, long mask) {
		return L /* + (R << 20) */+ (rem << 20) + ((mask | (1 << pos)) << 50);
	}

	static int prefix = 0;

	static class Pass implements Comparable<Pass> {
		char[] c;

		public Pass(String ss) {
			c = ss.toCharArray();
		}

		@Override
		public int compareTo(Pass o) {
			for (int i = prefix; i < 5; i++) {
				if (c[i] < o.c[i]) {
					return -1;
				}
				if (c[i] > o.c[i]) {
					return 1;
				}
			}
			return 0;
		}
	}

	HashMap<Long, Long> hm = new HashMap<Long, Long>();
	int count = 0;

	long calc(int L, int R, int pos, int rem, int mask) {
		if (rem < 0) {
			return 0;
		}
		if (pos == 5) {
			return (R - L) * (R - L - 1L) / 2;
		}
		int m2 = mask | (1 << pos);
		int r = rem;
		if (h[L][m2][r] != -1) {
			return h[L][m2][r];
		}
		count++;
		prefix = pos;
		Arrays.sort(s, L, R);
		long res = 0;
		int prev = L;
		for (int i = L; i < R; i++) {
			if (i > L && s[i].c[pos] != s[prev].c[pos]) {
				res += calc(prev, i, pos + 1, rem, mask);
				res -= calc(prev, i, pos + 1, rem - 1, mask);
				prev = i;
			}
		}
		res += calc(prev, R, pos + 1, rem, mask);
		res -= calc(prev, R, pos + 1, rem - 1, mask);
		res += calc(L, R, pos + 1, rem - 1, mask | (1 << pos));
		// Arrays.sort(s, L, R);
		// System.err.println(ss + " " + res);
		return h[L][m2][r] = res;
	}

	long[][][] h;

	void solve() throws IOException {
		int n = nextInt();
		h = new long[n][64][6];
		for (int i = 0; i < h.length; i++) {
			for (int j = 0; j < h[i].length; j++) {
				Arrays.fill(h[i][j], -1);
			}
		}
		String[] a = new String[n];
		for (int i = 0; i < a.length; i++) {
			a[i] = next();
		}
		Arrays.sort(a);
		// System.err.println(Arrays.toString(a));
		s = new Pass[n];
		for (int i = 0; i < a.length; i++) {
			s[i] = new Pass(a[i]);
		}
		long[] res = new long[6];
		for (int i = 0; i < res.length; i++) {
			res[i] = calc(0, n, 0, i, 0);
		}
		for (int i = res.length - 1; i > 0; i--) {
			res[i] -= res[i - 1];
		}
		for (int i = 0; i < res.length; i++) {
			out.print(res[i] + " ");
		}
		System.err.println(count);
		// System.err.println(Arrays.toString(res));
	}

	static final String FILENAME = "high";

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	void run() throws IOException {
		br = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		solve();
		out.close();
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null) {
				return null;
			}
			st = new StringTokenizer(s);
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	double parseDouble() throws IOException {
		return Double.parseDouble(next());
	}

	public static void main(String[] args) throws IOException {
		long time = System.currentTimeMillis();
		Locale.setDefault(Locale.US);
		new H().run();
		System.err.println(System.currentTimeMillis() - time);
	}
}
