#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <map>
#include <vector>
#include <algorithm>
using namespace std;

#define in "dice.in", "r", stdin
#define out "dice.out", "w", stdout

map<string, long long> m1;

int mas[1<<10];
int mas2[1<<10];
//vector< cub > vp;
struct cub{
		long gran;
		long left;
		long right;
		double E;
		int index;
};
void swap(int& a, int& b){
	int t;
	t = a;
	a = b;
	b = t;
};
int main(){
	freopen(in);
	freopen(out);
	int n;
	cin >> n;
	cub* a = new cub[n];
	long sum=0;
	for(int i=0;i<n;i++){
			cin >> a[i].gran;
			sum += a[i].gran;
			a[i].left = -1;
			a[i].right = -1;
			a[i].E = 0.0;
			a[i].index = i;
	}
	for (int i = 0; i < n-1; i++){
			for (int j = i + 1; j < n; j++ ){
				if (!(a[i].gran <= a[j].gran))
						swap(a[i],a[j]);
			}
	}
	long cur = sum;	
	long *b = new long[sum + 1];
	b[0] = 0;
	for (long i = 1; i < sum+1; i++)
		b[i] = i + b[i-1];
	for (int i = 0; i < n; i++){
		a[i].left = cur;
		a[i].right = cur -a[i].gran + 1;
		cur = a[i].right - 1;
		a[i].E = (b[a[i].left] - b[cur])/ ((a[i].left - a[i].right + 1)*1.0);
		//cout << a[i].left << " " << a[i].right << endl;
	}
	for (int i = 0; i < n-1; i++){
			for (int j = i + 1; j < n; j++ ){
				if (!(a[i].index <= a[j].index))
						swap(a[i],a[j]);
			}
	}
	//for (int i = 0; i< n; i++)cout << a[i].index<< " ";
	//cout << "\n";
	double E = 0;
	for (int i = 0; i < n; i++)
		E += a[i].E;
	printf("%.6lf\n", E);
	for (int i = 0; i < n; i++){
		for (long j = a[i].right; j <= a[i].left; j++)
				cout << j << " ";
		cout << endl;
	}
	fclose(stdout);
	return 0;
}
