#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <map>
#include <string>
#include <conio.h>
#include <math.h>
#include <cmath>

using namespace std;

const char IN[] = "dice.in";
const char OUT[] = "dice.out";

vector<pair<int,int>> F;
vector<vector<int>> C(10000);
int n;
int S;
long double M;

void load(){
	int d;
	cin >> n;
	for(int i = 0; i < n; ++i){
		cin >> d;
		F.push_back(make_pair(d,i));
		S += d;
	}

}

void algo(){
	sort(F.begin(),F.end());
	for(size_t i = 0; i < F.size() && S > 0; i++){
			long double c = 0;
			for(int j = 0; j < F[i].first; ++j){
					c += S;
					C[F[i].second].push_back(S);
					S--;
			}
			M = M+c/F[i].first;
	}
}


void write(){
	printf("%.5lf\n",M);
	for(int i = 0; i < n; ++i){
		for(size_t j = 0; j < C[i].size(); ++j)
			printf("%d ",C[i][j]);
		printf("\n");
	}
}


int main()
{
	freopen(IN, "rt", stdin);
	freopen(OUT, "wt", stdout);

	load();
	algo();
	write();

	return 0;
}