#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cstring>
#include <ctime>
#include <cstdlib>
#include <cassert>
#include <cstdio>

using namespace std;

#define forn(i, n) for (int i = 0; i < (n); i++)
#define eprintf(...) {fprintf(stderr, __VA_ARGS__); fflush(stderr);}
typedef long long LL;

#define TASK "black"

#define IMP return 0 * printf("Impossible\n");
#define AMB return 0 * printf("Ambiguous\n");
#define UNI return 0 * printf("Unique\n");

char a[100500];

int main() {
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
	
	int m, n, s, k;
	scanf("%d%d%d%d\n", &m, &n, &s, &k);
	gets(a);
	
	forn(i, n) {
		if (a[i] == '*') {
			for (int j = i; j < n - 1; j++)
				if (a[j] == '.' && a[j+1] == '*')
					IMP;
			break;
		}
	}
	
	int stars = 0;
	forn(i, n) stars += a[i] == '*';
	if (stars != s && stars != 0) IMP;
	
	if (stars == 0) {
		bool b1 = s <= n && s <= k - 1;
		bool b2 = s <= n && s <= m - k;
		if (!b1 && !b2) IMP;
		if (b1 && b2) AMB;
		if (b1 && s == n && s == k - 1) UNI;
		if (b2 && s == n && s == m - k) UNI;
		AMB;
	}
	
	if (s == 1) UNI;
	if (k == 1 || k == m) UNI;
	if (s == m) UNI;
	
	AMB;
	
	return 0;
}
