#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cstring>
#include <ctime>
#include <cstdlib>
#include <cassert>
#include <cstdio>

using namespace std;

#define forn(i, n) for (int i = 0; i < (n); i++)
#define eprintf(...) {fprintf(stderr, __VA_ARGS__); fflush(stderr);}
typedef long long LL;

#define TASK "cube"

#define IMP return 0 * printf("Impossible\n");

char a[6][6];
int cnt[26], lcnt[26];
char s[6];
char r[6];
int f[6];
int tt1[100], tt2[100];

int main() {
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
	forn(i, 6) scanf("%s", a[i]);
	forn(i, 6) {
		memset(lcnt, 0, sizeof lcnt);
		forn(j, 5) lcnt[a[i][j] - 'A']++;
		forn(j, 26) cnt[j] = max(cnt[j], lcnt[j]);
	}
	int sumcnt = 0;
	forn(i, 26) sumcnt += cnt[i];
	if (sumcnt == 5) {
		int mm = -1;
		forn(i, 26) if (cnt[i] == 5) { mm = i; break; }
		if (mm < 0) IMP;
		forn(i, 6) printf("%c", 'A' + mm);
		printf("\n");
		return 0;
	}
	if (sumcnt != 6) IMP;
	
	int sum = 0;
	forn(i, 6) sum += (s[i] = a[i][0]);
	forn(i, 6) {
		int s = 0;
		forn(j, 5) s += a[i][j];
		r[i] = char(sum - s);
		if (r[i] < 'A' || r[i] > 'Z') IMP;
	}
	
	forn(i, 6) f[i] = -1;
	forn(i, 6) if (f[i] < 0) {
		forn(j, 6) if (j != i && f[j] == -1) {
			if (r[i] == s[j] && r[j] == s[i]) {
				f[i] = j;
				f[j] = i;
				break;
			}
		}
		if (f[i] < 0) IMP;
	}
	
	forn(i, 6) {
		set<int> s1, s2;
		forn(j, 6) if (j != i && j != f[i]) s1.insert(s[j]);
		forn(j, 4) s2.insert(a[i][j+1]);
		if (s1 != s2) IMP;
	}
	
	
	int p2 = 0;
	forn(_, 4) {
		tt2[p2++] = s[2];
		tt2[p2++] = s[1];
		tt2[p2++] = s[f[2]];
		tt2[p2++] = s[f[1]];
	}
	
	bool one = false;
	forn(i, 12) if (tt2[i]==s[1] && tt2[i+1]==s[2] && tt2[i+2]==s[f[1]] && tt2[i+3]==s[f[2]]) one = true;
	
	
	for (int i = 1; i < 6; i++) if (i != f[0]) {
		for (int j = 1; j < 6; j++) if (j != i && j != f[0] && j != f[i]) {
			putchar(s[0]);
			putchar(s[i]);
			putchar(s[j]);
			putchar(s[f[i]]);
			putchar(s[f[j]]);
			putchar(s[f[0]]);
			break;
		}
		break;
	}
	printf("\n");
	
	if (one) return 0;
	
	for (int i = 1; i < 6; i++) if (i != f[0]) {
		for (int j = 1; j < 6; j++) if (j != i && j != f[0] && j != f[i]) {
			putchar(s[0]);
			putchar(s[j]);
			putchar(s[i]);
			putchar(s[f[j]]);
			putchar(s[f[i]]);
			putchar(s[f[0]]);
			break;
		}
		break;
	}
	printf("\n");
	
	return 0;
}
