#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <cstring>
#include <cassert>
#include <cstdlib>
#include <ctime>

#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <utility>

#define sz(c) ((int)(c).size())
#define ALL(c) (c).begin(), (c).end()
#define REP(i, n) for (int i = 0; i < (n); ++i)
#define FOR(i, s, n) for (int i = (s); i < (n); ++i)

using namespace std;
typedef long long ll;

void right( string& s )
{
  static int rot[6] = {0, 2, 3, 4, 1, 5};

  static string a;
  a = s;
  REP(i, 6)
    s[i] = a[rot[i]];
}
void up( string& s )
{
  static int rot[6] = {4, 1, 0, 3, 5, 2};

  static string a;
  a = s;
  REP(i, 6)
    s[i] = a[rot[i]];
}

string minString1( string& s, string& ans )
{
  REP(i, 4)
  {
    ans = min(ans, s);
    right(s);
  }
  return ans;
}

string minString( string& s )
{
  string ans = s;
  REP(i, 4)
  {
    minString1(s, ans);
    up(s);
  }
  right(s);
  up(s);
  minString1(s, ans);
  up(s);
  up(s);
  minString1(s, ans);
  return ans;
}

bool testCase()
{
  static char buf[12];

  if (scanf("%s", buf) != 1)
    return false;
  vector<string> col(6);
  col[0] = buf;
  REP(i, 5)
  {
    scanf("%s", buf);
    col[i + 1] = buf;
  }

  string colSides = "******";
  vector<string> col1(6);
  REP(i, 6)
  {
    colSides[i] = col[i][0];
    col1[i] = col[i].substr(1);
    sort(ALL(col1[i]));
  }

  vector<int> p(6);
  int sides[6][4] =
  {
    {1, 2, 3, 4},
    {0, 2, 4, 5},
    {0, 1, 3, 5},
    {0, 2, 5, 4},
    {0, 1, 3, 5},
    {1, 2, 3, 4}
  };

  REP(i, 6)
    p[i] = i;

  vector<string> ans;
  string orien = "****";
  do {
    string s = "******";
    REP(i, 6)
      s[i] = colSides[p[i]];

	  bool can = true;
    REP(i, 6)
    {
      REP(j, 4)
        orien[j] = colSides[p[sides[i][j]]];
      sort(ALL(orien));
      if (orien != col1[p[i]])
      {
        can = false;
        break;
      }
    }

    if (can)
    {
      s = minString(s);
      if (sz(ans) == 0 || ans.back() != s)
        ans.push_back(s);
      if (sz(ans) > 1)
        break;
    }
      
  } while (next_permutation(ALL(p)));

 
  if (sz(ans) == 0)
    printf("Impossible\n");
  else
  {
    REP(i, sz(ans))
    printf("%s\n", ans[i].c_str());
  }
  

  return true;
}

int main()
{
  freopen("cube.in",  "rt", stdin);
  freopen("cube.out", "wt", stdout);

  while (testCase())
    ;
  return 0;
}