#include <cstdio>
#include <cstring>
#include <cassert>
#include <cstdlib>
#include <ctime>

#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <utility>

#define sz(c) ((int)(c).size())
#define ALL(c) (c).begin(), (c).end()
#define REP(i, n) for (int i = 0; i < (n); ++i)
#define FOR(i, s, n) for (int i = (s); i < (n); ++i)

using namespace std;
typedef long long ll;

typedef pair<int, int> pii;
vector<pii> all;

inline bool myLess( int a, int b )
{
  return all[a].second > all[b].second;
}

bool testCase()
{
  int n;
  if (scanf("%d", &n) != 1)
    return false;

  all.resize(n);
  REP(i, n)
    scanf("%d%d", &all[i].first, &all[i].second);
  sort(ALL(all));

  vector<int> perm(n);
  REP(i, n)
    perm[i] = i;

  sort(ALL(perm), myLess);

  vector<int> f(n, 0);
  ll ans = 0;
  REP(i, n)
  {
    int r = perm[i] - 1;
    for (; r >= 0; r = (r & (r + 1)) - 1)
      ans += f[r];
    for (int j = perm[i]; j < n; j |= (j + 1))
      f[j]++;
  }

  printf("%I64d\n", ans);
  return true;
}

int main()
{
  freopen("john.in",  "rt", stdin);
  freopen("john.out", "wt", stdout);

  while (testCase())
    ;
  return 0;
}