#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

string fname = "dice";
string fin = fname + ".in";
string fout = fname + ".out";

int main()
{
	freopen(fin.c_str(), "r", stdin);
	freopen(fout.c_str(), "w", stdout);
	int n;
	cin >> n;
	vector<pair<long long, long long> > v(n);
	long long s = 0;
	for (int i = 0; i < n; i++)
	{
		int t;
		cin >> t;
		v[i] = make_pair(t, i);
		s += t;
	}
	sort(v.begin(), v.end());
	long long ci = s;
	double d = 0.0;
	vector<vector<long long> > res(n);
	for (int i = 0; i < v.size(); i++)
	{
		long long c = v[i].first;
		long long cn = v[i].second;
		long long a = ci;
		long long b = ci - c + 1;
		long long ss = ((a + b) * (a - b + 1)) / 2;
		d += ss * 1.0 / c;
		for (int j = 0; j < c; j++)
		{
			res[cn].push_back(ci - j);
		}
		ci -= c;
	}
	cout << d << endl;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < res[i].size(); j++)
			cout << res[i][j] << " ";
		cout << "\n";
	}
	return 0;
}