#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <cassert>
#include <ctime>
#include <stdarg.h>

#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define nextLine() {for(int c = getchar(); c != '\n' && c != EOF; c = getchar());}
#define sqr(a) ((a)*(a))
using namespace std;

typedef long long LL;
typedef long double ldb;
typedef pair<int, int> pii;

int m, n, s, k;
char line[5005];

void Load()
{
	scanf("%d%d%d%d\n", &m, &n, &s, &k);
	gets(line);
}

void Solve()
{
	int cs = 0;
	int cc = 0;
	int pos = -1;

	for (int i = 0; i < n; i++)
	{
		if (line[i] == '*')
		{
			pos = i + 1;
			cc++;
			int j = i;
			while (j < n && line[j] == '*')
			{
				j++;
				cs++;
			}
			i = j - 1;
		}
	}

	if (cs > s || (cs < s &&  cs > 0) || cc > 1)
	{
		printf("Impossible");
		return;
	}

	int cnt = 0;
	for (int i = 1; i <= n - s + 1; i++)
	{
		for (int j = 1; j <= m - s + 1; j++)
		{
			if (i <= k && k <= i + s - 1)
			{
				if (pos == j && cs == s)
					cnt++;
			}
			else
			{
				if (cs == 0)
					cnt++;
			}
		}	
	}

	if (cnt == 0)
	{
		printf("Impossible");
	} else if (cnt == 1)
	{
		printf("Unique");
	} else
	{
		printf("Ambiguous");
	}
}

#define task "black"
int main()
{
	freopen(task".in", "r", stdin);
	freopen(task".out", "w", stdout);
	Load();
	Solve();
	return 0;
}