#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <cassert>
#include <ctime>
#include <stdarg.h>

#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define nextLine() {for(int c = getchar(); c != '\n' && c != EOF; c = getchar());}
#define sqr(a) ((a)*(a))
using namespace std;

typedef long long LL;
typedef long double ldb;
typedef pair<int, int> pii;

int n;
pii face[1005];
int all = 0;

void Load()
{
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
	{
		int a;
		scanf("%d", &a);
		all += a;
		face[i] = mp(a, i);
	}
	sort(face + 0, face + n);
}

vector <int> ans[1005];

void Solve()
{
	ldb e = 0.0;
	for (int i = 0; i < n; i++)
	{
		int id = face[i].se;
		for (int j = 0; j < face[i].fi; j++)
			ans[id].pb(all--);
		sort(ans[id].begin(), ans[id].end());
		for (int j = 0; j < face[i].fi; j++)
			e += (ldb)ans[i][j] / face[i].fi;
	}
	printf("%.10lf\n", (double)e);
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < (int)ans[i].size(); j++)
			printf("%d ", ans[i][j]);
		printf("\n");	
	}
}

#define task "dice"
int main()
{
	freopen(task".in", "r", stdin);
	freopen(task".out", "w", stdout);
	Load();
	Solve();
	return 0;
}