#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <cassert>
#include <cstdlib>

using namespace std;


#define fori(i, l, r) for(int i = (l); i < (int)(r); ++i)
#define rep(i,n) fori(i, 0, n)

#define TASKNAME "black"

int main()
{
	assert(freopen(TASKNAME ".in", "rt", stdin));
	assert(freopen(TASKNAME ".out", "wt", stdout));

	int n, m, s, k;

	scanf("%d%d%d%d\n", &n, &m, &s, &k);

	int cnt = 0;
	char ch;

	bool was = 0;

	rep(i, m)
	{
		scanf("%c", &ch);
		if(ch == '*') 
		{
			if(was) 
			{
				printf("Impossible");
				return 0;
			}
			cnt++;
		}
		else 
		{
			if(cnt) was = 1;
		}
    }


    if(cnt == 0)
    {
    	cnt = 0;
    	if(k > s + 1) cnt+=2;
    	if(k == s + 1) {
    		if (s == m) cnt += 1;
    		else cnt += 2;
    	}
    	if(n - k > s) cnt+=2;
    	if(n - k == s) {
    		if (s == m) cnt += 1;
    		else cnt += 2;
    	}
    	
    	if(cnt > 1) printf("Ambiguous");
    	else if(cnt == 0) printf("Impossible"), cerr <<"!";
    	else printf("Unique");
    }
    else
    {
    	if(cnt != s) 
    	{
    		printf("Impossible");
    		return  0;
    	}
        if((k == 1 || k == n || s == n || s == 1)) printf("Unique");
        else printf("Ambiguous");
    }

	return 0;
}