#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <cassert>
#include <cstdlib>

using namespace std;

#define TASKNAME "high"
#define pb push_back
#define mp make_pair
#define fori(i,b,e) for(int i = (b); i < (e); ++i)
#define sz(a) (int)(a).size()

typedef long long int64;

const int maxn = 50000;
char str[maxn][6];
int n;
int64 cnt[7];
int64 ans[7];
int64 res[7];
int a[maxn];
bool good[5];

inline int code(char c) {
	if ('A' <= c && c <= 'Z') {
		return c - 'A';
	}
	if ('a' <= c && c <= 'z') {
		return c - 'a' + 26;
	}
	if ('0' <= c && c <= '9') {
		return c - '0' + 52;
	}
	assert(false);
}

int main()
{
	assert(freopen(TASKNAME ".in", "rt", stdin));
	assert(freopen(TASKNAME ".out", "wt", stdout));

	scanf("%d", &n);
	fori(i,0,n) {
		scanf("%s", str[i]);
	}
	fori(m,0,1 << 5) {
		int num = 0;
		fori(i,0,5) {
			good[i] = (m >> i) & 1;
			num += good[i];
		}
		fori(i,0,n) {
			int cur = 0;
			fori(j,0,5) {
				if (good[j]) {
					cur = (cur << 6) + code(str[i][j]);
				}
			}
			a[i] = cur;
		}
		sort(a, a+n);
		fori(i,0,n) {
			int j = i+1;
			while (j < n && a[j] == a[i]) {
				j++;
			}
			cnt[num] += ((int64)(j-i) * (j-i-1)) >> 1;
			i = j-1;
		}
	}
	ans[6] = 0;
	ans[5] = cnt[5];
	ans[4] = cnt[4] - 5 * ans[5];
	ans[3] = cnt[3] - 4 * ans[4] - 10 * ans[5];
	ans[2] = cnt[2] - 3 * ans[3] - 6 * ans[4] - 10 * ans[5];
	ans[1] = cnt[1] - 2 * ans[2] - 3 * ans[3] - 4 * ans[4] - 5 * ans[5];
	ans[0] = cnt[0];
	fori(i,1,6) {
		ans[0] -= ans[i];
	}
	fori(i,0,6) {
		printf ("%I64d ", ans[5-i]);
	}
	return 0;
}