#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <cassert>
#include <cstdlib>

using namespace std;

#define TASKNAME "john"
#define pb push_back
#define mp make_pair
#define fori(i,b,e) for(int i = (b); i < (e); ++i)
#define sz(a) (int)(a).size()

typedef long long int64;
typedef pair<int, int> pii;
typedef long long ll;

int n;
const int maxn = 100000;
pii a[maxn];
int s[maxn];

int buff[maxn];
ll ans;

void merge_sort(pii *a, int l, int r)
{
  if (l == r - 1)
    return;
  int m = (l + r) / 2;
  merge_sort(a, l, m);
  merge_sort(a, m, r);
  int i = l, j = m;
  int cur = l;
  while (cur != r)
  {
    if (i == m)
    {
      buff[cur++] = a[j++].second;
      continue;
    }
    if (j == r)
    {
      buff[cur++] = a[i++].second;
      continue;
    }
    if (a[i].second > a[j].second)
    {
      ans += m - i;
      buff[cur++] = a[j++].second;
    }
    else
      buff[cur++] = a[i++].second;
  }
  for (int i = l; i < r; i++)
    a[i].second = buff[i];
}

int main()
{
	assert(freopen(TASKNAME ".in", "rt", stdin));
	assert(freopen(TASKNAME ".out", "wt", stdout));
	scanf ("%d", &n);
	fori(i,0,n) {
		scanf ("%d%d", &a[i].first, &a[i].second);
	}
	sort(a,a+n);
	merge_sort(a, 0, n);
	printf("%I64d\n", ans);
	return 0;
}
