import java.util.*;
import java.io.*;

public class F implements Runnable {
	private MyScanner in;
	private PrintWriter out;
	private final String fileName = "flat";

	private void solve() {
		int n = in.nextInt();
		int cost = in.nextInt();
		int s = 0;
		int beds = 0;
		int s1 = 0, s2 = 0;		
		for (int i = 0; i < n; ++i) {
			int a = in.nextInt();
			String str = in.next();
			s += a;
			if (str.compareTo("bedroom") == 0) {
				beds += a;
			}
			if (str.compareTo("balcony") == 0) {
				s1 += cost * a;
			} else {
				s2 += cost * a;
			}
		}
		out.println(s);
		out.println(beds);
		out.println(s2 + 0.5 * s1);
	}

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			in = new MyScanner(fileName);
			out = new PrintWriter(new File(fileName + ".out"));
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new F().run();
	}

	static class MyScanner {
		private BufferedReader br;
		private StringTokenizer st;

		public MyScanner(String fn) {
			try {
				br = new BufferedReader(new FileReader(fn + ".in"));
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

		private String nextToken() {
			try {
				while (st == null || !st.hasMoreTokens()) {
					st = new StringTokenizer(br.readLine());
				}
				return st.nextToken();
			} catch (IOException e) {
				e.printStackTrace();
				return null;
			}
		}

		public String next() {
			return nextToken();
		}

		public String nextLine() {
			try {
				return br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
				return null;
			}
		}

		public int nextInt() {
			return Integer.parseInt(nextToken());
		}

		public long nextLong() {
			return Long.parseLong(nextToken());
		}

		public double nextDouble() {
			return Double.parseDouble(nextToken());
		}
	}
}
