import java.util.*;
import java.io.*;

public class K implements Runnable {
	private MyScanner in;
	private PrintWriter out;
	private final String fileName = "kids";

	int[] x, y;
	long[] small;
	int[][] sparce;
	int[] pow;
	int[] lg;
	int n;

	public long calc(int a, int b, int c) {
		int f1 = ((a + n) % n);
		int f2 = ((b + n) % n);
		int f3 = ((c + n) % n);
		return Math.abs((x[f1] - x[f2]) * (y[f3] - y[f2]) - (x[f3] - x[f2])
				* (y[f1] - y[f2]));
	}

	public int get(int l, int r) {
		int v1;
		int v2;
		if (l > r)
			r += n;
		// int l1 = l;
		// int r1 = n - 1;
		// int l2 = 0;
		// int r2 = r;
		// v1 = get(l1, r1);
		// v2 = get(l2, r2);
		//
		// } else {
		int len = lg[r - l + 1];
		v1 = sparce[l][lg[r - l + 1]];
		v2 = sparce[r - pow[len] + 1][len];

		if (small[v1] < small[v2])
			return v1;
		else
			return v2;
	}

	public void solve() {
		n = in.nextInt();
		x = new int[n];
		y = new int[n];
		for (int i = 0; i < n; i++) {
			x[i] = in.nextInt();
			y[i] = in.nextInt();
		}
		small = new long[2 * n];
		for (int i = 0; i < n; i++) {
			small[i] = calc(i, i + 1, i + 2);
			small[i + n] = small[i];
		}
		pow = new int[2 * n];
		lg = new int[2 * n];
		pow[0] = 1;
		lg[1] = 0;
		for (int i = 1; i < 2 * n; i++) {
			pow[i] = pow[i - 1] * 2;
			if (pow[i] > 2 * n)
				break;
		}
		int curLg = 0;
		for (int i = 1; i < 2 * n; i++) {
			if (pow[curLg + 1] == i)
				curLg++;
			lg[i] = curLg;
		}
		sparce = new int[2 * n][lg[n - 1] + 4];
		for (int i = 0; i < 2 * n; i++) {
			sparce[i][0] = i;
		}
		for (int i = 1; pow[i] <= 2 * n; i++) {
			for (int j = 0; j < 2 * n; j++) {
				if (j + pow[i - 1] >= n)
					continue;
				int v1 = sparce[j][i - 1];
				int v2 = sparce[j + pow[i - 1]][i - 1];
				if (small[v1] < small[v2])
					sparce[j][i] = v1;
				else
					sparce[j][i] = v2;
			}
		}
		int bestI = -1;
		int bestJ = -1;
		int bestCur = -1;
		int smallFirst = -1;
		long maxVal = -1;
		for (int i = 0; i < n; i++) {
			int cur = i + 3;
			for (int j = i + 2; j < n; j++) {
				while (calc(i, j, cur + 1) > calc(i, j, cur))
					cur++;
				if (maxVal == -1
						|| maxVal < calc(i, j, cur) - small[get(i, j - 2)]) {
					bestI = i;
					bestJ = j;
					bestCur = cur;
					smallFirst = get(i, j - 2);
					maxVal = calc(i, j, cur) - small[get(i, j - 2)];
				}

			}

		}
		out.println(maxVal / 2.0);
		out.println((bestI % n + 1) + " " + (bestJ % n + 1) + " "
				+ (bestCur % n + 1));
		out.println((smallFirst % n + 1) + " " + (smallFirst % n + 1 + 1) + " "
				+ (smallFirst % n + 1 + 2));
	}

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			in = new MyScanner(fileName);
			out = new PrintWriter(new File(fileName + ".out"));
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new K().run();
	}

	static class MyScanner {
		private BufferedReader br;
		private StringTokenizer st;

		public MyScanner(String fn) {
			try {
				br = new BufferedReader(new FileReader(fn + ".in"));
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

		private String nextToken() {
			try {
				while (st == null || !st.hasMoreTokens()) {
					st = new StringTokenizer(br.readLine());
				}
				return st.nextToken();
			} catch (IOException e) {
				e.printStackTrace();
				return null;
			}
		}

		public String next() {
			return nextToken();
		}

		public String nextLine() {
			try {
				return br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
				return null;
			}
		}

		public int nextInt() {
			return Integer.parseInt(nextToken());
		}

		public long nextLong() {
			return Long.parseLong(nextToken());
		}

		public double nextDouble() {
			return Double.parseDouble(nextToken());
		}
	}
}
