#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cstdlib>
#include <vector>
#include <set>
using namespace std;
#define ll long long
#define mp(a, b) make_pair(a, b)
#define pb(a) push_back(a)
#define ss second
#define ff first
const int inf = 1 << 28;


int nxt[18 * 18 * 2], fst[22], end[18 * 18 * 2], cost[18 * 18 * 2], edgs;


void addEdge(int i, int j, int cst)
{
	nxt[edgs] = fst[i];
	fst[i] = edgs;
	end[edgs] = j;
	cost[edgs] = cst;
	edgs++;
}

int n, m;

void load()
{
	cin >> n >> m;
	int a, b, c;
	memset(fst, -1, sizeof fst);
	for (int i = 0; i < m; i++)
	{
		scanf("%d%d%d", &a, &b, &c);
		a--;
		b--;
		addEdge(a, b, c);
		addEdge(b, a, c);
	}
}

int d[1 << 18][18];

class compare
{
	public:
		inline bool operator () (const pair <int, int> &p1, const pair <int, int> &p2)
		{
			return d[p1.ff][p1.ss] < d[p2.ff][p2.ss]
			|| d[p1.ff][p1.ss] == d[p2.ff][p2.ss] && p1 < p2;
		}
};
set <pair <int, int>, compare> was;
int cnt[1 << 18];
int masked[1 << 18];
int maskedi[1 << 18];
int type[1 << 18];
int pmask[1 << 18][18];
int pi[1 << 18][18];
vector <int> path;

void out(int mask, int i)
{
	path.resize(0);
	int _mask;
	while (mask != 1)
	{
		path.pb(i);
		_mask = pmask[mask][i];
		i = pi[mask][i];
		mask = _mask;
	}
	path.pb(0);
	printf("%d ", path.size() - 1);
	for (int i = path.size() - 1; i >= 0; i--)
		printf("%d ", path[i] + 1);
	printf("\n");
}

void solve()
{
	if (n == 1)
	{
		cout << "0\n1 1\n1 1\n";
		return;
	}
	for (int i = 0; i < (1 << n); i++)
	{
		cnt[i] = inf;
		for (int j = 0; j < n; j++)
			d[i][j] = inf;
	}
	d[1][0] = 0;
	was.insert(mp(1, 0));
	int mask, i;
	while (!was.empty())
	{
		mask = (*was.begin()).ff;
		i = (*was.begin()).ss;
		was.erase(was.begin());
		if (cnt[mask] > d[mask][i])
		{
			masked[mask] = mask;
			maskedi[mask] = i;
			cnt[mask] = d[mask][i];
		}
	//	cerr << mask << " " << i << " : " << d[mask][i] << "\n";
		for (int j = fst[i]; j != -1; j = nxt[j])
		{
			if (d[mask | (1 << end[j])][end[j]] > d[mask][i] + cost[j])
			{
				if (was.find(mp(mask | (1 << end[j]), end[j])) != was.end())
					was.erase(mp(mask | (1 << end[j]), end[j]));
				d[mask | (1 << end[j])][end[j]] = d[mask][i] + cost[j];
				pmask[mask | (1 << end[j])][end[j]] = mask;
				pi[mask | (1 << end[j])][end[j]] = i;
				was.insert(mp(mask | (1 << end[j]), end[j]));
			}
		}
	}
	for (int i = 0; i < (1 << n); i++)
	{
		if (cnt[i] == inf) continue;
		for (int s = i; s; s = s & (s - 1))
			if (cnt[s] == inf || type[s] == 1 && cnt[s] > cnt[i])
			{
				type[s] = 1;
				cnt[s] = cnt[i];
				masked[s] = masked[i];
				maskedi[s] = maskedi[i];
			}
		
	}
	int res = inf;
	int mask1, mask2;
	for (int i = 0; i < (1 << n); i++)
	{
		if (max(cnt[i], cnt[i ^ ((1 << n) - 1)]) < res)
		{
			res = max(cnt[i], cnt[i ^ ((1 << n) - 1)]);
			mask1 = i;
			mask2 = i ^ ((1 << n) - 1);
		}
	}
	cout << res << "\n";
	out(masked[mask1], maskedi[mask1]);
	out(masked[mask2], maskedi[mask2]);
}
#define file "immediate"
int main()
{
	freopen(file".in", "rt", stdin);
	freopen(file".out", "wt", stdout);
	load();
	solve();
	return 0;
}                   

