#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cstdlib>
#include <vector>
#include <set>
using namespace std;
#define ll long long
#define mp(a, b) make_pair(a, b)
#define pb(a) push_back(a)
#define ss second
#define ff first
const int inf = 1 << 28;


int nxt[18 * 18 * 2], fst[22], end[18 * 18 * 2], cost[18 * 18 * 2], edgs;


void addEdge(int i, int j, int cst)
{
	nxt[edgs] = fst[i];
	fst[i] = edgs;
	end[edgs] = j;
	cost[edgs] = cst;
	edgs++;
}

int n, m;
int a[18][18];
int p[18][18];

void load()
{
	cin >> n >> m;
	int a, b, c;
	memset(fst, -1, sizeof fst);
	memset(p, -1, sizeof p);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			::a[i][j] = inf;
		for (int i = 0; i < n; i++)
			::a[i][i] = 0;
	for (int i = 0; i < m; i++)
	{
		scanf("%d%d%d", &a, &b, &c);
		a--;
		b--;
		::a[a][b] = c;
		::a[b][a] = c;
	}
}

int d[1 << 18][18];
int pi[1 << 18][18];
int cnt[1 << 18];
int masked[1 << 18];
int maskedi[1 << 18];
vector <int> path;

int f(int mask, int i)
{
	if ((mask & (1 << i)) == 0) return inf;
	if ((mask & -mask) == mask)
	{
		if (i == 0) return 0;
		else return inf;
	}
	if (d[mask][i] != -1) return d[mask][i];
	d[mask][i] = inf;
	for (int j = 0; j < n; j++)
	{
		if (d[mask][i] > f(mask & ~(1 << i), j) + a[j][i])
		{
			d[mask][i] = f(mask & ~(1 << i), j) + a[j][i];
			pi[mask][i] = j;
		}
	}
	return d[mask][i];
}

void add(int i, int j)
{
	if (p[i][j] == -1)
	{
		path.pb(j);
		return;
	}
	add(p[i][j], j);
	add(i, p[i][j]);
}

void out(int mask, int i)
{
	path.resize(0);
	int _i;
	while (mask != 1)
	{
		add(pi[mask][i], i);
		_i = pi[mask][i];
		mask &= ~(1 << i);
		i = _i;
	}
	path.pb(0);
	printf("%d ", path.size() - 1);
	for (int i = path.size() - 1; i >= 0; i--)
		printf("%d ", path[i] + 1);
	printf("\n");
}

void solve()
{
	if (n == 1)
	{
		cout << "0\n0 1\n0 1\n";
		return;
	}
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < n; j++)
		{
			for (int k = 0; k < n; k++)
			{
				if (a[j][k] > a[j][i] + a[i][k])
				{
					p[j][k] = i;
					a[j][k] = a[j][i] + a[i][k];
				}
			}
		}
	}
	memset(d, -1, sizeof d);
	for (int i = 0; i < (1 << n); i++)
		cnt[i] = inf;

	for (int j = 0; j < (1 << n); j++)
	{
		for (int k = 0; k < n; k++)
		{
			if (cnt[j] > f(j, k))
			{
				cnt[j] = f(j, k);
				masked[j] = j;
				maskedi[j] = k;
			}
		}
	}

	for (int i = 0; i < (1 << n); i++)
	{
		if (cnt[i] == inf) continue;
		for (int s = i; s; s = i & (s - 1))
			if (cnt[s] > cnt[i])
			{
				cnt[s] = cnt[i];
				masked[s] = masked[i];
				maskedi[s] = maskedi[i];
			}
		
	}
	int res = inf;
	int mask1, mask2;
	for (int i = 0; i < (1 << n); i++)
	{
		if (max(cnt[i], cnt[i ^ ((1 << n) - 1)]) < res)
		{
			res = max(cnt[i], cnt[i ^ ((1 << n) - 1)]);
			mask1 = i;
			mask2 = i ^ ((1 << n) - 1);
		}
	}
	cout << res << "\n";
	out(masked[mask1], maskedi[mask1]);
	out(masked[mask2], maskedi[mask2]);
}
#define file "immediate"
int main()
{
	freopen(file".in", "rt", stdin);
	freopen(file".out", "wt", stdout);
	load();
	solve();
	return 0;
}                   

