import java.io.*;
import java.util.StringTokenizer;

public class F {

	static void solve() throws Exception {
		int n = nextInt();
		int cost = nextInt();
		int all = 0;
		int bedroom = 0;
		double costAll = 0;
		for (int i = 0; i < n; i++) {
			int area = nextInt();
			String type = next();
			all += area;
			if (type.equals("bedroom")) {
				bedroom += area;
			}
			if (type.equals("balcony")) {
				costAll += 0.5 * cost * area;
			} else {
				costAll += 1. * area * cost;
			}
		}
		out.println(all);
		out.println(bedroom);
		out.println(costAll);		
	}

	static int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	static String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = br.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}

	static BufferedReader br;
	static PrintWriter out;
	static StringTokenizer st;

	public static void main(String[] args) throws Exception {
		br = new BufferedReader(new FileReader("flat.in"));
		out = new PrintWriter("flat.out");
		solve();
		out.close();
	}
}
