#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
using namespace std;
typedef multiset<char> ms; 

bool eq(const ms &a, const ms &b) {
	ms c = b;
	for (multiset<char>::iterator it = a.begin(); it != a.end(); it++) {
		if (c.find(*it) == c.end()) {
			return false;
		}
		c.erase(c.find(*it));
	}
	return c.size() == 0;
}
bool eqs(string s1, string s2) {
	int k = s1.length();
	s1 += s1;
	string sl;
	for (int i = 0; i < k; i++) {
		sl = "";
		for (int j = i; j < i + k; j++) {
			sl += s1[j];
		}
		if (sl == s2) return true;
	}
	return false;
}
int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	freopen("cube.in", "r", stdin);
	freopen("cube.out", "w", stdout);
	string data[6];
	ms let[6];
	int get[6];
	for (int i = 0; i < 6; i++) {
		cin >> data[i];
		for (int j = 1; j < data[i].length(); j++) let[i].insert(data[i][j]);
	}
	string s = "123456", curs, ans = "";
	while (true) {
		curs = "";
		for (int i = 0; i < s.length(); i++) 
			for (int j = 0; j < s.length(); j++)
				if (i == s[j] - '1') {
					curs += data[j][0];
					get[j] = i + 1;
					break;
				}
		ms s1, s2, s3;
		s1.insert(curs[1]);
		s1.insert(curs[2]);
		s1.insert(curs[3]);
		s1.insert(curs[4]);

		s2.insert(curs[0]);
		s2.insert(curs[2]);
		s2.insert(curs[4]);
		s2.insert(curs[5]);

		s3.insert(curs[0]);
		s3.insert(curs[1]);
		s3.insert(curs[3]);
		s3.insert(curs[5]);
		bool f = true;
		for (int i = 0; i < 6; i++) {
			if (get[i] == 1 || get[i] == 6) {
				bool f1 = true;

				if (!eq(s1, let[i])) f = false;
			}
			if (get[i] == 2 || get[i] == 4) {
				if (!eq(s2, let[i])) f = false;
			}
			if (get[i] == 3 || get[i] == 5) {
				if (!eq(s3, let[i])) f = false;
			}
		}
		if (f && ans != "" && !eqs(ans, curs) ) {
			int kk = 0;
		}
		if (f && ans != "" && !eqs(ans, curs)) {
			cout << ans << endl << curs;
			return 0;
		}
		if (f) ans = curs;
		if (!next_permutation(s.begin(), s.end())) break;
	}
	if (ans != "") cout << ans; else cout << "Impossible";


	return 0;
}