#include <iostream>
#include <cstdio>
#include <string>
#include <algorithm>
#include <vector>
#include <ctime>
#include <cstdlib>

#define px first
#define py second
#define mp make_pair

using namespace std;

int n;
vector<pair<int, int> > a, c;
vector<int> b;
long long ans = 0;

void merge_sort(int l, int r) {
	int x = (l + r) / 2;
	if (l < r) {
		merge_sort(l, x);
		merge_sort(x + 1, r);
	} else {
		return;
	}
	int lb = l;
	int rb = x + 1;
	int cp = l;
	while (cp <= r) {
		if (a[lb].py < a[rb].py) {
			b[cp++] = a[lb++].py;
		} else {
			b[cp++] = a[rb++].py;
			ans += rb - cp;
		}
		if (lb == x + 1) {
			for (int i = rb; i <= r; ++i) {
				ans += i - cp;
				b[cp++] = a[i].py;
			}
			break;
		}
		if (rb == r + 1) {
			for (int i = lb; i <= x; ++i) {
				b[cp++] = a[i].py;
			}
		}
	}
	for (int i = l; i <= r; ++i) {
		a[i].py = b[i];
	}
}

int random(int a) {
	return int(1.0 * rand() / RAND_MAX * a) + 1;
}

int main() {
	freopen("john.in", "r", stdin);
	freopen("john.out", "w", stdout);
	scanf("%d", &n);
	srand(time(NULL));
	a.resize(n);
	b.resize(n);
	for (int i = 0; i < n; ++i) {
		scanf("%d%d", &a[i].px, &a[i].py);
	}
	/*for (int i = 0; i < n; ++i) {
		a[i] = mp(random(1000), random(1000));
	}*/
	c = a;
	sort(a.begin(), a.end());
	for (int i = 0; i < n; ++i) {
		b[i] = a[i].py;
	}
	merge_sort(0, n - 1);
	long long old_ans = ans;
	ans = 0;
	a = c;
	for (int i = 0; i < n; ++i) {
		swap(a[i].px, a[i].py);
	}
	sort(a.begin(), a.end());
	for (int i = 0; i < n; ++i) {
		b[i] = a[i].py;
	}
	merge_sort(0, n - 1);
	//cerr << old_ans << ' ' << ans << endl;
	cout << min(old_ans, ans) << endl;
	return 0;
}