import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.StringTokenizer;

public class H {
	private static final String TASKNAME = "high";

	private void solve() throws Exception {
		long[] ans = new long[6];
		int n = nextInt();
		String[] str = new String[n];
		for (int i = 0; i < str.length; ++i) {
			str[i] = nextToken();
		}
		HashMap<String, Integer> mapSame = new HashMap<String, Integer>();
		for (int i = 0; i < n; ++i) {
			String s = str[i];
			Integer value = mapSame.get(s);
			if (value == null) {
				value = 0;
			}
			++value;
			mapSame.put(s, value);
		}
//		System.err.println(mapSame);
//		for (Map.Entry<String, Integer> entry : mapSame.entrySet()) {
//			ans[0] += entry.getValue() * (entry.getValue() - 1) / 2;
//		}

		long[][] c = new long[10][10];
		for (int i = 0; i < 10; ++i) {
			c[i][0] = 1;
			for (int j = 1; j <= i; ++j) {
				c[i][j] = c[i - 1][j - 1] + c[i - 1][j];
			}
		}

		long[] dp = new long[1 << 5];
		for (int mask = 0; mask < (1 << 5); ++mask) {
			HashMap<String, Integer> map = new HashMap<String, Integer>();
			for (int i = 0; i < n; ++i) {
				String s = "";
				for (int j = 0; j < 5; ++j) {
					if ((mask & (1 << j)) != 0) {
						s += '#';
					} else {
						s += str[i].charAt(j);
					}
				}
				Integer value = map.get(s);
				if (value == null) {
					value = 0;
				}
				++value;
				map.put(s, value);
			}
			long tans = 0l;
			for (Map.Entry<String, Integer> entry : map.entrySet()) {
				tans += 1l * entry.getValue() * (entry.getValue() - 1) / 2;
			}
			for (int subMask = (mask - 1) & mask; ; subMask = (subMask - 1) & mask) {
				tans -= dp[subMask];
				if (subMask == 0) {
					break;
				}
			}
			dp[mask] = tans;
			ans[Integer.bitCount(mask)] += tans;
		}
		
//		System.err.println(Arrays.toString(ans));
		for (int i = 0; i < 6; ++i) {
			long t = ans[i];
			print(t + " ");
//			for (int j = 0; j < i; ++j) {
//				t -= ans[j];
//			}
//			System.err.print(t + " ");
		}
		println("");
	}

	public static void main(String[] args) throws FileNotFoundException {
		long time = System.currentTimeMillis();
		Locale.setDefault(Locale.US);
		new H().run();
		System.err.printf("%.3f\n", 1e-3 * (System.currentTimeMillis() - time));
	}

	BufferedReader reader;
	PrintWriter writer;
	StringTokenizer tokenizer;

	String nextToken() throws IOException {
		while (tokenizer == null || !tokenizer.hasMoreTokens()) {
			tokenizer = new StringTokenizer(reader.readLine());
		}
		return tokenizer.nextToken();
	}

	int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	void print(Object o) {
		writer.print(o);
	}

	void println(Object o) {
		writer.println(o);
	}

	void printf(String format, Object... o) {
		writer.printf(format, o);
	}

	private void run() {
		try {
			reader = new BufferedReader(new FileReader(TASKNAME + ".in"));
			writer = new PrintWriter(TASKNAME + ".out");

			solve();

			reader.close();
			writer.close();
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

}
//if (tans % 2 == 1) {
//throw new AssertionError();
//}
//tans /= 2;

//tans = 0;
//for (int subMask = mask/*(mask - 1) & mask*/; subMask > 0; subMask = (subMask - 1) & mask) {
//int mul = (Integer.bitCount(mask ^ subMask) % 2) == 0 ? 1 : -1;
//tans += dp[subMask] * mul;
//}
//ans[Integer.bitCount(mask)] += tans / 2;
