#include <cstdio>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <iostream>
#include <queue>
#include <algorithm>
#include <ctime>
#include <cassert>

using namespace std;

#define pb push_back
#define mp make_pair
#define x first
#define y second
#define fs x
#define sc y
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
vector <int> vi;

#define FILENAME "black"


int m, n, s, k;

char buf[5010];

int main() {
    freopen(FILENAME".in", "r", stdin);
    freopen(FILENAME".out", "w", stdout);

    scanf("%d %d %d %d", &m, &n, &s, &k);

    scanf("%s", buf);

    int maxs = 0, last = 0;
    for (int i = 0; i < n; i++) {
        if (buf[i] == '*') {
            if (i == 0 || buf[i - 1] != '*') {
                if (maxs != 0) {
                    puts("Impossible");
                    return 0;
                }
                last = i;
            }
            maxs = max(maxs, i - last + 1);
        }
    }

    if (maxs == 0) {
        int num = 0;
        num += max(0, k - 1 - s + 1) * (n - s + 1);
        num += max(0, m - k - s + 1) * (n - s + 1);

        if (num == 0) {
            puts("Impossible");
        } else if (num == 1) {
            puts("Unique");
        } else {
            puts("Ambiguous");
        }
        return 0;
    }

    if (maxs != s) {
        puts("Impossible");
        return 0;
    }

    if (k == 1 || k == m || s == m || s == 1) {
        puts("Unique");
    } else {
        puts("Ambiguous");
    }


    return 0;
}