#include <cstdio>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <iostream>
#include <queue>
#include <algorithm>
#include <ctime>
#include <cassert>

using namespace std;

#define pb push_back
#define mp make_pair
#define x first
#define y second
#define fs x
#define sc y
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
vector <int> vi;

#define FILENAME "dice"

#define maxn 1010

int n;
int a[maxn], p[maxn];
vector <int> rs[maxn];


bool cmp(int x, int y) {
    return a[x] > a[y];
}

int main() {
    freopen(FILENAME".in", "r", stdin);
    freopen(FILENAME".out", "w", stdout);

    scanf("%d", &n);
    for (int i = 0; i < n; i++) {
        scanf("%d", &a[i]);
        p[i] = i;
    }

    sort(p, p + n, cmp);

    double ans = 0;

    int lastM = 0;
    for (int i = 0; i < n; i++) {
        int curs = 0;
        for (int j = 0; j < a[p[i]]; j++) {
            int Q = ++lastM;
            curs += Q;
            rs[p[i]].pb(Q);
        }
        ans += 1. * curs / a[p[i]];
    }

    printf("%.10lf\n", ans);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < a[i]; j++) {
            printf("%d%c", rs[i][j], " \n"[j + 1 == a[i]]);
        }
    }

    return 0;
}