#include <cstdio>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <iostream>
#include <queue>
#include <algorithm>
#include <ctime>
#include <cassert>

using namespace std;

#define pb push_back
#define mp make_pair
#define x first
#define y second
#define fs x
#define sc y
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
vector <int> vi;

#define FILENAME "kids"

int tk,n,n0;
const ll inf=(ll)1e18;
ll ans,sqm;
int mn1,mn2,mn3;
int ansn[2][3];
struct pnt{
    int x,y;
    pnt(){
    }
    pnt(const int& _x,const int& _y){
        x=_x;
        y=_y;
    }
};
pnt p[20000];

pnt p0[20000];
ll sq(const pnt& a,const pnt& b,const pnt& c){
    return abs((ll)(b.x-a.x)*(c.y-a.y)-(ll)(b.y-a.y)*(c.x-a.x));
}                                       
void solve2(int del){
    sqm=sq(p[del+n-1],p[del],p[del+1]);
    mn1=(del+n-1)%n;
    mn2=(del)%n;
    mn3=(del+1)%n;
    vector<pnt> p;
    for (int i=0;i<n;i++)if (i!=del){
        p.pb(p0[i]);
    }           
    for (int i=0;i<n;i++)if (i!=del){
        p.pb(p0[i]);
    }           
    for (int i=0;i<n;i++)if (i!=del){
        p.pb(p0[i]);
    }
    int n=n0-1;               
    for (int i=0;i<n;i++){
        tk=i+1;
        for (int j=i+2;j<i+n;j++){
            while((sq(p[i],p[tk],p[j])<sq(p[i],p[tk+1],p[j]))){
                tk++;
            }            
            if (ans<sq(p[i],p[tk],p[j])-sqm){
                ans=sq(p[i],p[tk],p[j])-sqm;
                ansn[0][0]=i%n;
                ansn[0][1]=tk%n;
                ansn[0][2]=j%n;
                for (int k=0;k<3;k++){
                    if (ansn[0][k]>=del) ansn[0][k]++;
                }
                ansn[1][0]=mn1;
                ansn[1][1]=mn2;
                ansn[1][2]=mn3;
            }
        }
    }
}

void solve1(){
    int mx1=-1,mx2=-1,mx3=-1;
    ll mx=-1;
    for (int i=0;i<n;i++){
        tk=i+1;
        for (int j=i+2;j<i+n;j++){
            while((sq(p[i],p[tk],p[j])<sq(p[i],p[tk+1],p[j]))){
                tk++;
            }
            if (mx<sq(p[i],p[tk],p[j])){
                mx=sq(p[i],p[tk],p[j]);
                mx1=i%n;
                mx2=tk%n;
                mx3=j%n;
            }        
        }
    }
    solve2(mx1);
    solve2(mx2);
    solve2(mx3);
    for (int i=0;i<n;i++)if (i!=mx1 && i!=mx2 && i!=mx3){
        if (ans<sq(p[mx1],p[mx2],p[mx3])-sq(p[i+n-1],p[i],p[i+1])){
           ans=sq(p[mx1],p[mx2],p[mx3])-sq(p[i+n-1],p[i],p[i+1]);
           ansn[0][0]=mx1;
           ansn[0][1]=mx2;
           ansn[0][2]=mx3;
           ansn[1][0]=(i+n-1)%n;
           ansn[1][1]=i;
           ansn[1][2]=(i+1)%n;
        }
    }
}

int main() {
    freopen(FILENAME".in", "r", stdin);
    freopen(FILENAME".out", "w", stdout);
    scanf("%d",&n);
    int xx,yy;
    for (int i=0;i<n;i++){
        scanf("%d %d",&xx,&yy);
        p[i]=pnt(xx,yy);
    }
    assert(n>3);
    for (int i=0;i<n;i++){
        p0[i]=p[i];    
        p0[i+n]=p[i];
        p0[i+n*2]=p[i];
        p[i+n]=p[i];
        p[i+2*n]=p[i];
        assert(sq(p[i],p[i+1],p[i+2])!=0);
    }
    n0=n;
    ans=-1;
    solve1();

    printf("%I64d.%I64d\n",ans/2,(ans%2)*5);
    for (int i=0;i<2;i++){
        for (int j=0;j<3;j++){
            printf("%d ",ansn[i][j]%n+1);
        }
        printf("\n");
    }         
    return 0;
}