#include <iostream>
#include <fstream>
#include <cmath>
#include <string>

using namespace std;

#define IN_FILE  "black.in"
#define OUT_FILE "black.out"
/**/
#ifdef IN_FILE
	ifstream in;
	ofstream out;
#else
#define in cin
#define out cout
#endif

int main() {
#ifdef IN_FILE
	in.open(IN_FILE);
	out.open(OUT_FILE);
#endif

	int m,n,s,k;
	in >> m >> n >> s >> k;

	int min = m < n ? m : n;
	int star = 0;
	int max = 0;
	int stars = 0;
	for(int i = 0; i < n; i++) {
		char c;
		in >> c;
		if(c == '.') { if(star > max) max = star; if(star != 0) { star = 0; stars++; } }
		else star++;
	}
	if(star > 0) stars++;
	if(star > max) max = star;
	
	if((max != s && max != 0) || stars > 1 || ((m-s < k && k <= s) && max == 0)) out << "Impossible";
	else if((max == s && (s == 1 || (s == n && s == m) || k == 1 || k == m)) || 
			(max == 0 && (s == m-k || k == s+1) && s == n)) out << "Unique";
	else out << "Ambiguous";

#ifdef IN_FILE
	in.close();
	out.close();
#else
	char hsvgsdvbsd;
	in >> hsvgsdvbsd;
#endif
	return 0;
}