#include <iostream>
#include <fstream>
#include <cmath>
#include <string>

using namespace std;

#define IN_FILE  "high.in"
#define OUT_FILE "high.out"
/**/
#ifdef IN_FILE
	ifstream in;
	ofstream out;
#else
#define in cin
#define out cout
#endif

int main() {
#ifdef IN_FILE
	in.open(IN_FILE);
	out.open(OUT_FILE);
#endif

	long diff[5][256];
	memset(diff, 0, sizeof(diff));

	long on;
	long one = 0;
	in >> on;
	long n = on;
	char **pass = new char*[n];

	for(int i = 0; i < n; i++) {
		pass[i] = new char[6];
		in >> pass[i];

		bool eq = false;
		for(int k = 0; k < i && !eq; k++) {
			if(strcmp(pass[i], pass[k]) == 0) eq = true; break;
		}
		if(eq) { one++; i--; n--; continue; }

		for(int j = 0; j < 5; j++) {
			diff[j][pass[i][j]] = 1;
		}
		
	}

	for(int i = 0; i < 5; i++) {
		int sum = 0;
		for(char c = '0'; c <= '9'; c++) /*if (diff[i][c] > 1) sum -= diff[i][c];*/ sum += diff[i][c];
		for(char c = 'a'; c <= 'z'; c++) /*if (diff[i][c] > 1) sum -= diff[i][c];*/ sum += diff[i][c];
		for(char c = 'A'; c <= 'Z'; c++) /*if (diff[i][c] > 1) sum -= diff[i][c];*/ sum += diff[i][c];
		out << (sum == on ? 0 : sum-1) << " ";
	}
	out << n << endl;

#ifdef IN_FILE
	in.close();
	out.close();
#else
	char hsvgsdvbsd;
	in >> hsvgsdvbsd;
#endif
	return 0;
}