#include <fstream>
#include <iostream>
using namespace std;

int countBlack(char * ch, int n)
{
	int c = 0;
	for (int i = 0; i<n; i++)
		if (ch[i] == '*')
			c++;
	return c;
}

bool correctLine(char * ch, int n)
{
//	int c = 0;
//	for (int i = 1; i < n; i++)
//	{
//		if (ch[i-1] == '.' && ch[i] == '*')
//			c++;
//		if (ch[i-1] == '*' && ch[i] == '.')
//			c++;
//	}
	int st = -1;
	if (ch[0] == '.')
		st = 0;
	else
		st = 1;
	for (int i = 1; i<n; i++)
	{
		if (st == 0 && ch[i] == '*')
			st++;
		if (st == 1 && ch[i] == '.')
			st++;
		if (st == 2 && ch[i] == '*')
			st++;
	}
	
	return st < 3;
}

int position(char * ch, int n)
{
	for (int i = 0; i<n; i++)
		if (ch[i] == '*')
			return i;
}

int main()
{
	ifstream fin("black.in");
	int n, m, s, k;
	fin>>m>>n>>s>>k;
//	s--;
//	k--;
	char *line = new char [n+2];
	fin>>line;
	int status = -1;

	int cbl = countBlack(line,n);

	if (!correctLine(line,n))
		status = 2;
	else
		if (cbl != s || s > m || s>n || k > m || k > n)
			status = 2;
		else
		{
			if (s == 1 || k == 1 || k == m || m == s)
				status = 1;
			else
				status = 0;
		}

	if(cbl == 0)
	{
		if(k - 1 < s && m - k < s)
			status = 2;
		else
			if(( (k - 1 == s && m - k != s) || (k - 1 != s && m - k == s) )&&(s==n))
				status = 1;
			else 
				status = 0;
	}

	fin.close();

	ofstream fout("black.out");
	switch(status)
	{
	case 0: fout<<"Ambiguous"; break;
	case 1: fout<<"Unique"; break;
	case 2: fout<<"Impossible"; break;
	}
	fout.close();
		
	return 0;
}