#include <fstream>
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

long long result = 0;

int buffer[100001];

void merge (int a[], int num1, int l1, int l2){

	int num2 = num1 + l1, i = num1, j = num2, cur = 0, k;
	while (i < num2 && j < num2 + l2){
	    if (a[i] <= a[j]){
			buffer[cur++] = a[i];
			i++;
		}
		else{
			buffer[cur++] = a[j];
			j++; 
			result += num2 - i;
		}	
	}
	if (i < num2){
		for (k = i; k < num2; k++)
			buffer[cur++] = a[k]; 
	}
	else{
		for (k = j; k < num2 + l2; k++)
			buffer[cur++] = a[k]; 
	}
	for (k = 0; k < l1 + l2; k++){
		a[k + num1] = buffer[k]; 
	}
}

void mSort(int a[], int n){
	int bSize = 1, i;
	while (bSize < n){
		for (i = 0; i + 2 * bSize < n; i += bSize * 2){
		//	 cout << i << ' ' << i + bSize << ' ' << i + 2 * bSize << endl;
		//	 cin.get();
		     merge(a, i, bSize, bSize);
		}
		if (n - i > bSize){
		//	 cout << i << ' ' << i + bSize << ' ' << n << endl;
			merge(a, i, bSize, n - i - bSize);
		}
	    bSize *= 2;
	}
}
	
int b[100001];
int main(){
	ifstream inFile("john.in");
	ofstream outFile("john.out");

	int i, j, n;
	inFile >> n;
	vector<pair<int, int> > a(n);
	for (i = 0; i < n; ++i)
		inFile >> a[i].first >> a[i].second;

	sort(a.begin(), a.end());

	//reverse(a.begin(), a.end());


	/*int f[] = {1, 4, 5, 7, -2, -1, 1, 5, -1500, 8};
	mSort(f, 10);
	for (int i = 0; i < 10; i++)
		cout << f[i] << ' ';
	cin.get();
	*/
	//for (i = 0; i < n; ++i)
	//	cout << a[i].first << ' ' << a[i].second << endl;

	/*
	for (i = 0; i < n; ++i)
		for (j = i + 1; j < n; ++j){
			if (a[i].second > a[j].second)
				result++;
		}
	*/
	
	for (i = 0; i < n; ++i)
		b[i] = a[i].second;

	mSort(b, n);
	/*for (i = 0; i < n; ++i)
		cout << b[i] << ' ';
	cin.get();*/
	outFile << result;

	//cin.get();
	return 0;
}