#include <cstdio>
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>

using namespace std;

const int p = 67;
vector <int> M[6];

void genMask(int mask, int kol, int iteration) {
	if(iteration == 4) {
		M[kol].push_back(mask);
		return;
	}
	genMask((mask << 1), kol, iteration+1);
	genMask((mask << 1)+1, kol+1, iteration+1);
}

int main() {
	freopen("high.in", "r", stdin); freopen("high.out", "w", stdout);
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);

	int n;
	cin >> n;
	vector <string> S(n);
	vector <long long> ans(6);
	for(int i=0; i<n; ++i)
		cin >> S[i];

	genMask(0, 0, 0);
	genMask(1, 1, 0);
	long long sum = 0;

	for(int q=5; q>=0; --q) {
		for(int mask=0; mask<M[q].size(); ++mask) {
			map<int, long long> Map;
			for(int i=0; i<n; ++i) {
				int hash = 0, t = 1;
				for(int j=0; j<5; ++j) {
					if(M[q][mask] & (1<<j))
						hash = (hash*p) + S[i][j];
					t *= p;
				}
				Map[hash]++;
			}
			for(map<int,long long>::iterator it=Map.begin(); it!=Map.end(); ++it) {
				long long kol = (*it).second;
				kol = (kol)*(kol-1)/2 - sum;
				ans[q] += max(kol, 1ll*0);
			}
		}
		sum += ans[q];
	}
	
	for(int i=5; i>=0; --i)
		cout << ans[i] << " ";
	cout << endl;

	return 0;
}