#include <cstdio>
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const int maxN = 300 * 1000, inf = 1000 * 1000 * 1000;
int a, b, c, n, m, ans, i, j, k, maxMask, d[maxN][20], p1[maxN], Prev[maxN][20], v[20][20], p[20][20], mask[20];
vector <int> way[20][20], r;

void pr(int a, int b) {
	if (b != a && p[a][b] != a) {
		//cout << a << " " << b << " " << p[a][b] << endl;
		pr(a, p[a][b]);
		pr(p[a][b], b);
	} else if (p[a][b] != i && p[a][b] != j){
		way[i][j].push_back(p[a][b]);
	}
}

void write(int m, int i) {
	if (i == 0) {
		r.push_back(1);
	} else {
		write(m ^ mask[Prev[m][i]], Prev[m][i]);
		j = Prev[m][i];
		for (int k = 0; k < way[i][j].size(); ++k) {
			r.push_back(way[i][j][k] + 1);
		}
		r.push_back(i + 1);
	}
}

int main() {
	freopen("immediate.in", "r", stdin); freopen("immediate.out", "w", stdout);
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);

	cin >> n >> m;
	for (i = 0; i < n; ++i)
		for (j = 0; j < n; ++j) {
			v[i][j] = inf;
			p[i][j] = i;
		}
	for(i=0; i<m; ++i) {
		cin >> a >> b >> c;
		--a; --b;
		v[a][b] = c;
		v[b][a] = c;
	}
	mask[0] = 1;
	maxMask = 1;
	for (i = 1; i < n; ++i) {
		mask[i] = mask[i - 1] * 2;
		maxMask += mask[i]; 
	}
	for (i = 0; i < n; ++i) {
		p[i][i] = i;
		v[i][i] = 0;
	}
	for (k = 0; k < n; ++k)
		for (i = 0; i < n; ++i)
			for (j = 0; j < n; ++j) {
				if (v[i][j] > v[i][k] + v[k][j]) {
					v[i][j] = v[i][k] + v[k][j];
					p[i][j] = k;
				}
			}

	/*for (i = 0; i < n; ++i) {
		for (j = 0; j < n; ++j)
			cout << v[i][j] << " ";
		cout << endl;
	}*/

	for (i = 0; i < n; ++i) {
		for (j = 0; j < n; ++j)
				pr(i, j);
	}

	for (i = 1; i <= maxMask; ++i)
		for (j = 0; j < n; ++j)
			d[i][j] = inf;
	
	d[1][0] = 0;
	
	for (i = 1; i <= maxMask; ++i) {
		for (j = 0; j < n; ++j)
			for (k = 0; k < n; ++k) if ((i | mask[j]) == i) {
				if (d[i][j] + v[j][k] < d[i | mask[k]][k]) {
					d[i | mask[k]][k] = d[i][j] + v[j][k];
					Prev[i | mask[k]][k] = j;
				}
			}
	}
	/*for (i = 1; i <= maxMask; ++i) {
		for (j = 0; j < n; ++j)
			cout << d[i][j] << endl;
	}*/

	k = 0;
	ans = inf;
	for (i = 1; i <= maxMask; ++i) {
		p1[i] = 0;
		for (j = 1; j < n; ++j)
			if (d[i][p1[i]] > d[i][j]) {
				p1[i] = j;
			}
	}

	for (i = 1; i <= maxMask; ++i) {
		for (j = 0; j < n; ++j) {
			if (max(d[i][p1[i]], d[(maxMask ^ i) | 1][p1[(maxMask ^ i) | 1]]) < ans) {
				ans = max(d[i][p1[i]], d[(maxMask ^ i) | 1][p1[(maxMask ^ i) | 1]]);
				k = i;
			}
		}
	}

	cout << ans << endl;
	write(k, p1[k]);
	cout << r.size() - 1 << " ";
	for (i = 0 ; i < r.size(); ++i)
		cout << r[i] << " ";
	cout << endl;
	r.clear();
	write((maxMask^k)|1, p1[(maxMask^k)|1]);
	cout << r.size() - 1 << " ";
	for (i = 0 ; i < r.size(); ++i)
		cout << r[i] << " ";
	cout << endl;

	return 0;
}