//Flash.cc
//ECNA 2012 - Flash Mob

#include <vector>
#include <algorithm>
#include <iostream>
using namespace std;

#define IFDB if(DEBUG)

const bool DEBUG = false;

#define FOR(i,n) for(int i=0;i<n;i++)

const int MAX=1001;

int n;
vector <int> Hor, Ver;

void Print(){
  int h,v;

  cout<<"Hor:";
  FOR(i,n) { h=Hor[i]; cout<<h<<' ';}
  cout<<endl;
  cout<<"Ver:";
  FOR(i,n) { v=Ver[i]; cout<<v<<' ';}
  cout<<endl;
  cout<<"--"<<endl;
}

int main(){
  int caseno=1, distance;
  int EW, NS;
  int h, v, hmid, vmid;

  cin>>n;
  while(n>0){
    FOR(i,n){
      cin>>h>>v;
      Hor.push_back(h);
      Ver.push_back(v);
    }

IFDB Print();
  sort(Hor.begin(), Hor.end());
  sort(Ver.begin(), Ver.end());
IFDB Print();

    // if n odd, find middle spot
    if (n % 2 == 1){
      hmid = Hor[n/2];
      vmid = Ver[n/2];
      //now get lowest E-W loc
      EW = n/2;
      while(Hor[EW]==hmid) EW--;
      EW++;
      //get lowest N-S loc
      NS=n/2;
      while(Ver[NS]==vmid) NS--;
      NS++;
IFDB cout<<"*** "<<hmid<<" "<<vmid<<endl;
    }
    else {   //n is even, take n/2
      hmid = Hor[n/2-1];
      vmid = Ver[n/2-1];
      //now get lowest E-W loc
      EW = n/2-1;
      while(Hor[EW]==hmid) EW--;
      EW++;
      //get lowest N-S loc
      NS=n/2-1;
      while(Ver[NS]==vmid) NS--;
      NS++;
IFDB cout<<"** "<<hmid<<" "<<vmid<<endl;
    }

    //now find total distance traveled
    distance = 0;
    FOR(i,n) {
      distance += abs(Hor[i] - hmid) + abs(Ver[i] - vmid);
IFDB cout<<i<<" "<<Hor[i]<<" "<<Ver[i]<<" "<<distance<<endl;
    }
    cout<<"Case "<<caseno++<<": ("<<Hor[EW]<<','<<Ver[NS]<<") "<<distance<<endl;

    // get next test case
    Hor.clear(); Ver.clear();
    cin>>n;
  }


  return 0;
}
