/*
TASK:
LANG: C++
*/
#include <algorithm>
#include <sstream>
#include <cstdio>
#include <cstdlib>
#include <cctype>
#include <cmath>
#include <iterator>
#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <list>
#include <bitset>
#include <cstring>
#include <climits>
#include <deque>
#include <utility>
#include <complex>
#include <numeric>
#include <functional>
#include <stack>
#include <iomanip>
#include <ctime>
#include <valarray>
//#include "vc.h"
#ifdef _MSC_VER
#include <hash_set>
#include <hash_map>
using namespace stdext;
#else
#if __GNUC__ > 2
#include <ext/hash_set>
#include <ext/hash_map>
using namespace __gnu_cxx;
#else
#include <hash_set>
#include <hash_map>
#endif
#endif

template<class key>
struct hashtemp {

	enum {
		bucket_size = 4, min_buckets = 8
	};
	virtual size_t operator()(const key &p) const=0;

};

using namespace std;
#ifndef M_PI
const long double M_PI=acos((long double)-1);
#endif
#define rep(i,n) for(int  i=0;i<(int)(n);++i)
long double ZERO = 0;
const long double INF = 1 / ZERO, EPSILON = 1e-12;
#define all(c) (c).begin(),(c).end()
#define rep2(i,a,b) for(int i=(a);i<=((int)b);++i)
#define foreach(it,c) for(__typeof((c).begin()) it=(c).begin();it!=(c).end();++it)

#define sz(v) ((int)((v).size()))
#define let(x,y) __typeof(y) x(y)

#define rrep(i,n) for(int  i=((int)n)-1;i>=0;--i)
#define rall(c) (c).rbegin(),(c).rend()
#define rrep2(i,a,b) for(int i=(a);i>=((int)b);--i)
#define rforeach(it,c) for(__typeof((c).rbegin()) it=(c).rbegin();it!=(c).rend();++it)
#define rep2d(i, j, v) rep(i, sz(v)) rep(j, sz(v[i]))
#define foreach2d(i, j, v) foreach(i,v) foreach(j,*i)

long long mem[81][21][2];
long long get(int v, int w, bool lastSpace) {
	if (v == 0 && w == 0)
		return !lastSpace;
	if(w<0)
		return 0;
	long long &r = mem[v][w][lastSpace];
	if (r != -1)
		return r;
	r = 0;
	rep2(i,1,27) {
		if (i == 1 && lastSpace)
			continue;
		if (i > v)
			break;
		r += get(v - i, w - (i == 1), i == 1);
	}
	return r;
}
int main() {
	std::ios_base::sync_with_stdio(false);
#ifndef ONLINE_JUDGE
	freopen("cipher.in", "rt", stdin);
	freopen("1.out", "wt", stdout);
#endif
	int t,tt=1;
	cin >> t;
	memset(mem,-1,sizeof mem);
	while (t--) {

		long long v, w, idx;
		cin >> v >> w >> idx;
		string msg;
		bool ls = 1;
		w--;
		cout<<"Case #"<<tt++<<": ";
		if(idx>get(v,w,1))
			cout<<"Corrupted!"<<endl;
		else
		{
			while (v) {
				rep2(i,1,27) {
					if (i == 1 && ls)
						continue;
					if(get(v-i,w-(i==1),i==1)<idx)
						idx-=get(v-i,w-(i==1),i==1);
					else
					{
						msg+=i==1?' ':i-2+'a';
						if(i==1)
							w--;
						ls=i==1;
						v-=i;
						break;
					}
				}
			}
			cout<<msg<<endl;
		}
	}
	return 0;
}
