#include<iostream>
using namespace std;

#define big long long

big table[100][100][2];
string str;

big get(int V, int W, int isLastSpace){

	if(V < 0 || W < 0)
		return false;

	if(V == 0 && W == 1)
		return !isLastSpace;

	if(table[V][W][isLastSpace] != -1)
		return table[V][W][isLastSpace];

	big res = isLastSpace ? 0 : get(V-1, W-1, true);
	for(int i = 2 ; i <= 27; i++)
		res += get(V-i, W, false);
	return table[V][W][isLastSpace] = res;
}

void navigate(int V, int W, int isLastSpace, big I){

	if(V == 0 && W == 1)
		return;

	big res = isLastSpace ? 0 : get(V-1, W-1, true);
	if(res >= I){
		str += " ";
		return navigate(V-1, W-1, true, I);
	}

	for(int i = 2 ; i <= 27; i++){
		big c = get(V-i, W, false);
		if(res+c >= I){
			str += (char)('a'+i-2);
			return navigate(V-i, W, false, I-res);
		}
		res += c;
	}
}

int main(){

	freopen("cipher.in", "rt", stdin);
	freopen("cipher.out", "wt", stdout);

	memset(table, -1, sizeof table);

	int tt; cin >> tt;
	assert(1 <= tt && tt <= 200);
	for(int t = 1 ; t <= tt ; t++){

		big V, W, I;
		cin >> V >> W >> I;
		assert(1 <= V && V <= 75);
		assert(1 <= W && W <= 20);
		assert(1 <= I && I <= 1e18);

//		big B = get(V, W, true);
//		cout << B << endl;

		cout << "Case #" << t << ": ";

		if(I > get(V, W, true))
			cout << "Corrupted!" << endl;
		else{
			str = "";
			navigate(V, W, true, I);
			cout << str << endl;
		}
	}

	return 0;
}
