/*
 TASK:
 LANG: C++
 */
#include <algorithm>
#include <sstream>
#include <cstdio>
#include <cstdlib>
#include <cctype>
#include <cmath>
#include <iterator>
#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <list>
#include <bitset>
#include <cstring>
#include <climits>
#include <deque>
#include <utility>
#include <complex>
#include <numeric>
#include <functional>
#include <stack>
#include <iomanip>
#include <ctime>
#include <valarray>
//#include "vc.h"
#ifdef _MSC_VER
#include <hash_set>
#include <hash_map>
using namespace stdext;
#else
#if __GNUC__ > 2
#include <ext/hash_set>
#include <ext/hash_map>
using namespace __gnu_cxx;
#else
#include <hash_set>
#include <hash_map>
#endif
#endif

template<class key>
struct hashtemp {

	enum {
		bucket_size = 4, min_buckets = 8
	};
	virtual size_t operator()(const key &p) const=0;

};

using namespace std;
#ifndef M_PI
const long double M_PI=acos((long double)-1);
#endif
#define rep(i,n) for(int  i=0;i<(int)(n);++i)
long double ZERO = 0;
const long double INF = 1 / ZERO, EPSILON = 1e-12;
#define all(c) (c).begin(),(c).end()
#define rep2(i,a,b) for(int i=(a);i<=((int)b);++i)
#define foreach(it,c) for(__typeof((c).begin()) it=(c).begin();it!=(c).end();++it)

#define sz(v) ((int)((v).size()))
#define let(x,y) __typeof(y) x(y)

#define rrep(i,n) for(int  i=((int)n)-1;i>=0;--i)
#define rall(c) (c).rbegin(),(c).rend()
#define rrep2(i,a,b) for(int i=(a);i>=((int)b);--i)
#define rforeach(it,c) for(__typeof((c).rbegin()) it=(c).rbegin();it!=(c).rend();++it)
#define rep2d(i, j, v) rep(i, sz(v)) rep(j, sz(v[i]))
#define foreach2d(i, j, v) foreach(i,v) foreach(j,*i)
int h[100][100];
int vis[100][100];
int r,c;

int dir[4][2]={{0,1},{1,0},{0,-1},{-1,0}};

bool getDir(int i,int j,int k,int &ni,int &nj,int r,int c)
{
	ni=i+dir[k][0];
	nj=j+dir[k][1];
	return ni>=0 && ni<r && nj<c && nj>=0;
}
int main() {
	std::ios_base::sync_with_stdio(false);
#ifndef ONLINE_JUDGE
	freopen("crank.in", "rt", stdin);
	freopen("crank.out", "wt", stdout);
#endif
	int t,tt=1;
	cin >> t;

	while (t--) {
		cin>>r>>c;
		int x,y;
		cin>>x>>y;
		x--,y--;
		rep(i,r)
			rep(j,c)
				cin>>h[i][j];
		memset(vis,0,sizeof vis);
		queue<pair<int,int> > q;
		q.push(make_pair(x,y));
		vis[x][y]=1;
		while(q.size())
		{
			int i=q.front().first;
			int j=q.front().second;
			q.pop();
			rep(k,4)
			{
				int ni,nj;
				if(getDir(i,j,k,ni,nj,r,c) && !vis[ni][nj] && h[ni][nj]>=h[i][j])
				{
					vis[ni][nj]=1;
					q.push(make_pair(ni,nj));
				}
			}
		}
		int res=0;
		rep(i,r)
			rep(j,c)
				if(i==0 || j==0 || i==r-1 || j==c-1)
					if(vis[i][j])
						res++;
		cout<<"Case #"<<tt++<<": ";
		cout<<res<<endl;
	}
	return 0;
}
