#include<iostream>
using namespace std;

#define big long long
const int SIZE = 1000000;
big N, M, cnt[SIZE];

void factor(big n, big p){
	big a=1;
	for(big i = 2; i*i <= n; i+=a,a=2){
		if(n%i)continue;
		while(n%i==0){
			n/=i;
			cnt[i] += p;
		}
	}if(n > 1)
		cnt[n] += p;
}

int main(){

	freopen("division.in", "rt", stdin);
	freopen("division.out", "wt", stdout);

	int tt; cin >> tt;
	assert(1 <= tt && tt<= 200);
	for(int t = 1 ; t <= tt;  t++){

		memset(cnt, 0, sizeof cnt);

		cin >> N >> M;
		assert(1 <= N && N <= 110000);
		assert(1 <= M && M <= 110000);

		for(int i = 0 ; i < N ; i++){
			big x; cin >> x;
			assert(0 < x && x <= 1000000);
			factor(x, 1);
		}
		for(int i = 0 ; i < M ; i++){
			big x; cin >> x;
			assert(1 <= x && x <= 1000000);
			factor(x, -1);
		}

		big nom = 1, denom = 1;
		for(int i = 0 ; i < SIZE ; i++){
			if(!cnt[i])continue;
			if(cnt[i] > 0){
				while(cnt[i]--)
					nom *= i;
			}else{
				while(cnt[i]++)
					denom *= i;
			}
		}

		assert(1 <= nom <= INT_MAX);
		assert(1 <= denom <= INT_MAX);

		cout << "Case #" << t << ": " << nom << " / " << denom << endl;
	}

	return 0;
}
