#include<iostream>
#include<map>
#include<vector>
#include<set>
using namespace std;

int get(vector<int> v){

	int r = 0, i = 0;
	for(int i = 0 ; i < v.size() ; i++)
		r += abs(i+1-v[i]);
	return r/2;
}

int main(){

	freopen("sort.in", "rt", stdin);
	freopen("sort.out", "wt", stdout);

	int tt; cin >> tt;
	for(int t =1 ; t <= tt ; t++){
		int N;cin >> N;
		assert(1 <= N && N <= 30);
		vector<int> v(N);
		for(int i = 0 ; i < N ; i++){
			cin >> v[i];
			assert(INT_MIN <= v[i] && v[i] <= INT_MAX);
		}

		set<int> s(v.begin(), v.end());
		assert(s.size() == v.size());

		vector<int> sv = v;
		sort(sv.begin(), sv.end());
		map<int, int> m;
		for(int i = 0 ; i < N ; i++)
			m[sv[i]] = i+1;

		for(int i = 0 ; i < v.size() ; i++)
			v[i] = m[v[i]];

		int r = get(v);
		cout << "Case #" << t << ": " << r << endl;
	}

	return 0;
}
