import java.io.File;
import java.io.PrintStream;
import java.util.Scanner;

public class se7s
{
	public static String isTriangle(int a, int b, int c)
	{
		if( a <= 0 || b <= 0 || c <= 0 )
			return "invalid!";

		if( a+b <= c || a+c <= b || b+c <= a )
			return "invalid!";

		if( a != b && b != c && c != a )
			return "scalene";

		if( a == b && b == c )
			return "equilateral";

		return "isosceles";
	}

	public static void main(String[] args) throws Exception
	{
//		Scanner scan = new Scanner(new BufferedInputStream(System.in));
		Scanner scan = new Scanner(new File("triangle.in"));
		PrintStream out = new PrintStream(new File("triangle.out"));
		int test = scan.nextInt();

		for( int tt = 1 ; tt <= test ; tt++ )
		{
			int a = scan.nextInt();
			int b = scan.nextInt();
			int c = scan.nextInt();

			assert a >= 1 && a <= 1000000 : "wrong value for a = " + a +", (1 <= a <= 1000000)";
			assert b >= 1 && b <= 1000000 : "wrong value for b = " + b +", (1 <= b <= 1000000)";
			assert c >= 1 && c <= 1000000 : "wrong value for c = " + c +", (1 <= c <= 1000000)";

			out.printf("Case #%d: %s\n", tt, isTriangle(a, b, c));
		}
	}
}
