/*
 TASK:
 LANG: C++
 */
#include <algorithm>
#include <sstream>
#include <cstdio>
#include <cstdlib>
#include <cctype>
#include <cmath>
#include <iterator>
#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <list>
#include <bitset>
#include <cstring>
#include <climits>
#include <deque>
#include <utility>
#include <complex>
#include <numeric>
#include <functional>
#include <stack>
#include <iomanip>
#include <ctime>
#include <valarray>
//#include "vc.h"
#ifdef _MSC_VER
#include <hash_set>
#include <hash_map>
using namespace stdext;
#else
#if __GNUC__ > 2
#include <ext/hash_set>
#include <ext/hash_map>
using namespace __gnu_cxx;
#else
#include <hash_set>
#include <hash_map>
#endif
#endif

template<class key>
struct hashtemp {

	enum {
		bucket_size = 4, min_buckets = 8
	};
	virtual size_t operator()(const key &p) const=0;

};

using namespace std;
#ifndef M_PI
const long double M_PI = acos((long double) -1);
#endif
#define rep(i,n) for(int  i=0;i<(int)(n);++i)
long double ZERO = 0;
const long double INF = 1 / ZERO, EPSILON = 1e-12;
#define all(c) (c).begin(),(c).end()
#define rep2(i,a,b) for(int i=(a);i<=((int)b);++i)
#define foreach(it,c) for(__typeof((c).begin()) it=(c).begin();it!=(c).end();++it)

#define sz(v) ((int)((v).size()))
#define let(x,y) __typeof(y) x(y)

#define rrep(i,n) for(int  i=((int)n)-1;i>=0;--i)
#define rall(c) (c).rbegin(),(c).rend()
#define rrep2(i,a,b) for(int i=(a);i>=((int)b);--i)
#define rforeach(it,c) for(__typeof((c).rbegin()) it=(c).rbegin();it!=(c).rend();++it)
#define rep2d(i, j, v) rep(i, sz(v)) rep(j, sz(v[i]))
#define foreach2d(i, j, v) foreach(i,v) foreach(j,*i)
double mem[4][4][8][8][2], p[2];

double get(int s1, int s2, int p1, int p2, int t) {
	if (mem[s1][s2][p1][p2][t] == mem[s1][s2][p1][p2][t])
		return mem[s1][s2][p1][p2][t];
	double ret = 0;
	if (max(s1, s2) == 3)
		return 0;
	if (max(p1, p2) == 6 && abs(p1 - p2) > 1)
		return get(s1 + ((p1 == 6) ? 1 : 0), s2 + ((p2 == 6) ? 1 : 0), 0, 0, t);
	if (max(p1, p2) == 7)
		return get(s1 + ((p1 == 7) ? 1 : 0), s2 + ((p2 == 7) ? 1 : 0), 0, 0, t);
	double pp1 = t == 0 ? p[0] : 1 - p[1];
	double pp2 = t == 0 ? 1 - p[0] : p[1];
	ret = pp1 * (5 + get(s1, s2, p1 + 1, p2, 1 - t));
	ret += pp2 * (5 + get(s1, s2, p1, p2 + 1, 1 - t));
	return mem[s1][s2][p1][p2][t] = ret;
}
int main() {
	std::ios_base::sync_with_stdio(false);
#ifndef ONLINE_JUDGE
	freopen("wimbledon.in", "rt", stdin);
	freopen("1.out", "wt", stdout);
#endif
	int t, tt = 1;
	cin >> t;

	while (t--) {
		string str;
		memset(mem, -1, sizeof mem);
		rep(i,2)
			cin >> str >> str >> p[i], p[i] /= 100;
		printf("Case #%d: %.6f\n", tt++, get(0, 0, 0, 0, 0));
	}
	return 0;
}
