import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

public class Wimbledon {

	static double mem[][][][][] = new double[4][4][8][8][2],
			p[] = new double[2];

	public static void main(String[] args) throws Exception {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(
				new FileInputStream("wimbledon.in"))));
		PrintStream out = new PrintStream(new File("1.out"));
		int t = in.nextInt(), tt = 1;
		while (t-- > 0) {
			for (double[][][][] a : mem)
				for (double[][][] b : a)
					for (double[][] c : b)
						for (double[] d : c)
							Arrays.fill(d, Double.NaN);
			in.next();
			in.next();
			p[0] = in.nextInt() / 100.0;
			in.next();
			in.next();
			p[1] = in.nextInt() / 100.0;
			out.printf("Case #%d: %.6f\n", tt++, get(0, 0, 0, 0, 0));
		}

	}

	private static double get(int s1, int s2, int p1, int p2, int t) {
		if (mem[s1][s2][p1][p2][t] == mem[s1][s2][p1][p2][t])
			return mem[s1][s2][p1][p2][t];
		double ret = 0;
		if (Math.max(s1, s2) == 3)
			return 0;
		if (Math.max(p1, p2) == 6 && Math.abs(p1 - p2) > 1)
			return get(s1 + ((p1 == 6) ? 1 : 0), s2 + ((p2 == 6) ? 1 : 0), 0,
					0, t);
		if (Math.max(p1, p2) == 7)
			return get(s1 + ((p1 == 7) ? 1 : 0), s2 + ((p2 == 7) ? 1 : 0), 0,
					0, t);
		double pp1 = t == 0 ? p[0] : 1 - p[1];
		double pp2 = t == 0 ? 1 - p[0] : p[1];
		ret = pp1 *( 5 + get(s1, s2, p1 + 1, p2, 1 - t));
		ret += pp2 *( 5 + get(s1, s2, p1, p2 + 1, 1 - t));
		return mem[s1][s2][p1][p2][t] = ret;
	}

}
