#include <cstdio>
#include <algorithm>
#include <utility>

using namespace std;

void printnum(int nu)
{
    if (nu >= 0)
        printf("NUM %d\n", nu);
    else
        printf("NUM %d\nINV\n", -nu);
}

bool scase()
{
    unsigned n;
    scanf("%u", &n);
    if (n == 0) return false;
    pair<int,int> ps[100];
    for(int i=0;i<n;i++) {
        scanf("%d%d", &ps[i].first, &ps[i].second);
        ps[i].first++;
    }
    sort(ps, ps+n);
    int modr[100];
    int curr[100];
    for(int i=0;i<n;i++)
        curr[i] = 0;
    printf("NUM 1\nADD\n");
    for(int i=0;i<n;i++) {
        modr[i] = ps[i].second - curr[i];
        for(int j=0;j<n;j++)
            curr[j] += (ps[j].first/ps[i].first)*modr[i];
        printf("DUP\n");printnum(ps[i].first);printf("DIV\n");printnum(modr[i]);printf("MUL\nSWP\n");
    }
    printf("POP\n");
    for(int i=0;i<n-1;i++)
        printf("ADD\n");
    printf("END\n\n");
    return true;
}

int main()
{
    while (scase()) {}
    return 0;
}

