#include <iostream>
#include <sstream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cctype>
#include <string>
#include <vector>
#include <list>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>
using namespace std;

#define FOR(i,a,b) for (int i = (a); i < (b); ++i)
#define FOR2(i,a,b) for (int i = (a); i > (b); ++i)
#define DEBUG(x) cout << '>' << #x << ':' << x << endl;
inline bool EQ(double a, double b) { return fabs(a-b) < 1e-9; }

const int INF = 1<<29;
typedef long long ll;
//////////////////////////////////////////////////////////////////////////////

int main()
{
	while (1) {
		int X, Y, N;
		double r;
		scanf("%d%d%d%lf", &X, &Y, &N, &r);
		if (!X && !Y && !N && r == 0) break;
		double R = pow(1+r/100.0, 1.0/12);
		double Rn = pow(1+r/100.0, N);
		double res = X*Rn-Y*(Rn-1)/(R-1);
		printf("%lf %lf\n", X*Rn, Y*(Rn-1)/(R-1));
		printf("%lf\n", res);
		if (res <= 0) puts("YES");
		else puts("NO");
	}
	return 0;
}