#include <iostream>
#include <sstream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <cctype>
#include <string>
#include <vector>
#include <list>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>
using namespace std;

#define FOR(i,a,b) for (int i = (a); i < (b); ++i)
#define FOR2(i,a,b) for (int i = (a); i > (b); ++i)
#define DEBUG(x) cout << '>' << #x << ':' << x << endl;
inline bool EQ(double a, double b) { return fabs(a-b) < 1e-9; }

const int INF = 1<<29;
typedef long long ll;
//////////////////////////////////////////////////////////////////////////////

struct rec
{
	int num;
	char op;	
} input[147];

char text[147*5];

int main()
{
	while (1)
	{
		gets(text);
		int len = strlen(text);
		if (text[0] == 'E') break;
		
		int P = 0, index = 0, n = 0;
		char op = '+';
		while (index < len)
		{
			n = 0;
			while (index < len && isdigit(text[index]))
				n = n*10+text[index++]-'0';
			input[P].num = n;
			input[P].op = op;
			++P;
			if (index == len) break;
			op = text[index++];
		}
		
		//min
		ll add = 0, mul = 0;
		FOR(i, 0, P) {
			if (input[i].op == '+') {
				add += mul;
				mul = input[i].num;
			} else {
				if (input[i].num == 0) add = 0;
				if (mul == 0) {
					add = 0;
					break;
				}
				mul *= input[i].num;
			}
		}
		add += mul;
		printf("%lld\n", add);
		add = 0; mul = 0;
		FOR(i, 0, P) {
			if (input[i].op == '+') {
				add += input[i].num;
			}
		}
	}
	return 0;
}