/*
 * CTU Open Contest 2011
 *
 * Sample solution: encipher
 * Author: Martin Kacer
 */

import java.io.BufferedReader;
import java.io.InputStreamReader;

public class encipher {
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	public static void main(String[] args) throws Exception {
		encipher instance = new encipher();
		while (instance.run()) { /*repeat*/ }
	}

	boolean run() throws Exception {
		int step = Integer.parseInt(input.readLine());
		if (step == 0) return false;
		String line = input.readLine();
		if (line == null || line.length() == 0) return false;
		char[] norm = line.replaceAll("[^a-zA-Z]", "").toUpperCase().toCharArray();
		char[] enc = new char[norm.length];
		int p = 0;
		for (int i = 0; i < step; ++i)
			for (int j = i; j < norm.length; j += step)
				enc[j] = norm[p++];
		System.out.println(enc);
		return true;
	}
}
