#define _USE_MATH_DEFINES

#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include <vector>
#include <string>
#include <iostream>
#include <cmath>
#include <cctype>
#include <sstream>
#include <algorithm>
#include <iomanip>
#include <set>
#include <queue>
#include <cassert>

using namespace std;

typedef long double real;
typedef long long TT;

#define PB push_back
#define SQR(x) ((x)*(x))
#define PII pair<int, int>
#define VI vector<int>
#define VVI vector<VI >
#define VS vector<string>
#define VTT vector<TT>
#define VR vector<real>

const int maxn = 1010;

int n, m;
int a[maxn];
int d[5*maxn][maxn];

int main()
{
    freopen("input.txt" ,"rt", stdin); freopen("output.txt", "wt", stdout);
    
    int i, j, k;
    
    cin >> n >> m;
    assert(1 <= n && n <= 1000);
    assert(0 <= m && m <= 5000);
    for (i = 0; i < n; i++) {
        cin >> a[i];
        assert(0 <= a[i] && a[i] <= 1000);
    }
    
    memset(d, 0xff, sizeof(d));
    d[0][0] = a[0];
    for (i = 0; i < m; i++) {
        for (j = 0; j < n; j++) {
            if (d[i][j] < 0) continue;
            for (k = 1; k <= 6; k++) {
                int jj = (j+k)%n;
                int val = d[i][j] + a[jj];
                if (val > d[i+1][jj])
                    d[i+1][jj] = val;
            } 
        }
    }
    
    int ans = 0;
    for (i = 0; i < n; i++) {
        if (d[m][i] > ans) ans = d[m][i];
    }
    cout << ans;
    
    fclose(stdin); fclose(stdout);
    return 0;   
}