#include <iostream>
#include <queue>
#include <algorithm>

using namespace std;

const int maxn = 100;
const int inf = 1000000000;

int n, P[2];
queue<int> q[2];
int can_visit_2[maxn];
int t[maxn], kab[maxn], qnum[maxn], inq2[maxn];
int i, tt[2], frontman[2];

void add(int curt, int i, int j)
{
	q[j].push(i); 
	if (j == 1) inq2[i] = 1;
	if (tt[j] == inf && q[j].size() == 1) tt[j] = curt;
}

int main()
{
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);

	cin >> n >> P[0] >> P[1];
	for (i = 0; i < n; i++) {
		cin >> t[i] >> kab[i];
		if (kab[i] == 1) cin >> qnum[i];
		else can_visit_2[i] = 1;
	}

	tt[0] = inf; tt[1] = inf; t[n] = inf;
	frontman[0] = frontman[1] = -1;
	vector<int> ans(n);
	i = 0;
	while (1) {
		int tmin = inf;
		tmin = min(tmin, t[i]);
		tmin = min(tmin, tt[0]);
		tmin = min(tmin, tt[1]);
		if (tmin == inf) break;
		if (t[i] == tmin) {
			if (kab[i] == 1) {
				add(tmin, i, 0);
				if (qnum[i] == 2) add(tmin, i, 1);
			} else {
				add(tmin, i, 1);
			}
			i++;
		} else if (tt[1] == tmin) {
			if (frontman[1] != -1)
				ans[frontman[1]] = tmin;
			if (!q[1].empty()) {
				int k = q[1].front();
				q[1].pop();
				inq2[k] = 0;
				if (can_visit_2[k]) {
					tt[1] = tmin + P[1];
					frontman[1] = k;
				} else {
					if (!q[1].empty()) {
						tt[1] = tmin;
					} else {
						tt[1] = inf;
					}
					frontman[1] = -1;
				}
			} else {
				frontman[1] = -1;
				tt[1] = inf;
			}
		} else if (tt[0] == tmin) {
			if (frontman[0] != -1) {
				can_visit_2[frontman[0]] = 1;
				if (!inq2[frontman[0]]) add(tmin, frontman[0], 1);
			}
			if (!q[0].empty()) {
				int k = q[0].front();
				q[0].pop();
				tt[0] = tmin + P[0];
				frontman[0] = k;
			} else {
				frontman[0] = -1;
				tt[0] = inf;
			}
		}
	}

	for (i = 0; i < ans.size(); i++) {
		cout << ans[i]-t[i] << " ";
	}
	cout << endl;

	fclose(stdin); fclose(stdout);
}
