{$mode objfpc}{$assertions on}

const
  M = 100000000;

function Valid(a: Integer): boolean; inline;
begin
  Result := (-M <= a) and (a <= M);
end;

var
  T, H, V, L, R, U, D, s: Integer;
begin
  AssignFile(input, 'input.txt'); Reset(input);
  AssignFile(output, 'output.txt'); Rewrite(output);
  Read(T, H, V);
  s := (T - H - V) div 2;  // T - H - V = 2L+2D
  for L := - M to M do begin
    D := s - L;
    if not Valid(D) then continue;
    R := H + L;
    if not Valid(R) then continue;
    U := V + D;
    if not Valid(U) then continue;
    Write(L, ' ', R, ' ', U, ' ', D);
    Halt;
  end;
  Write('BAD');
end.
