{$mode objfpc}{$assertions on}

uses
  Types, Math;

var
  cnt: Integer = 0;
  ans: array [1..10] of TRect;

procedure T(x, y, u, v: Integer);
begin
  if (x < u) and (y < v) then begin
    cnt += 1;
    ans[cnt] := Rect(x, y, u, v);
  end;
end;

var
  a, b, c, d: TPoint;
  i: Integer;
begin
  AssignFile(input, 'input.txt'); Reset(input);
  AssignFile(output, 'output.txt'); Rewrite(output);
  Read(a.x, a.y, b.x, b.y, c.x, c.y, d.x, d.y);
  Assert(a.x < b.x); Assert(a.y < b.y);
  Assert(c.x < d.x); Assert(c.y < d.y);
  c.x := Max(c.x, a.x); c.y := Max(c.y, a.y);
  d.x := Min(d.x, b.x); d.y := Min(d.y, b.y);
  if (c.x < d.x) and (c.y < d.y) then begin
    T(a.x, a.y, b.x, c.y);
    T(a.x, c.y, c.x, d.y);
    T(d.x, c.y, b.x, d.y);
    T(a.x, d.y, b.x, b.y);
  end
  else
    T(a.x, a.y, b.x, b.y);
  Writeln(cnt);
  for i := 1 to cnt do
    with ans[i] do
      Writeln(Left, ' ', Top, ' ', Right, ' ', Bottom);
end.
