import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;


public class A {
	private static String problem = "ate";
	
	BufferedReader in;
	PrintWriter out;
	
	private StringTokenizer st = null;
	
	public String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = in.readLine();
			st = new StringTokenizer(line);
		}
		
		return st.nextToken();		
	}
	
	public int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(nextToken());
	}
	
	public void run() throws Exception {
		in = new BufferedReader(new FileReader(problem + ".in"));
		out = new PrintWriter(problem + ".out");
		solve();
		in.close();
		out.close();
	}
	
	public void solve() throws Exception {
		int n = nextInt();
		int r = 0;
		for (int i = 0; i < 100; ++i) {
			if (n - i < 100 && n - i >= 0) {
				++r;
			}
		}
		out.println(r);
	}
	
	public static void main(String[] args) throws Exception {
		new A().run();
	}
}
