import java.io.*;
import java.util.*;
import java.math.*;

public class H {
	Pass[] s;

	// static class State {
	// int L, R, pos, rem, mask;
	//
	// public State(int l, int r, int pos, int rem, int mask) {
	// super();
	// L = l;
	// R = r;
	// this.pos = pos;
	// this.rem = rem;
	// this.mask = mask;
	// }
	//
	// @Override
	// public int hashCode() {
	// final int prime = 31;
	// int result = 1;
	// result = prime * result + L;
	// result = prime * result + R;
	// result = prime * result + mask;
	// result = prime * result + pos;
	// result = prime * result + rem;
	// return result;
	// }
	//
	// @Override
	// public boolean equals(Object obj) {
	// if (this == obj)
	// return true;
	// if (obj == null)
	// return false;
	// if (getClass() != obj.getClass())
	// return false;
	// State other = (State) obj;
	// if (L != other.L)
	// return false;
	// if (R != other.R)
	// return false;
	// if (mask != other.mask)
	// return false;
	// if (pos != other.pos)
	// return false;
	// if (rem != other.rem)
	// return false;
	// return true;
	// }
	//
	// @Override
	// public String toString() {
	// return "State [L=" + L + ", R=" + R + ", pos=" + pos + ", rem="
	// + rem + ", mask=" + mask + "]";
	// }
	//
	// }

	long hash(long L, long pos, long rem, long mask) {
		return L + (pos << 20) + (rem << 25) + (mask << 30);
	}

	static int prefix = 0;

	static class Pass implements Comparable<Pass> {
		char[] c;

		public Pass(String ss) {
			c = ss.toCharArray();
		}

		@Override
		public int compareTo(Pass o) {
			for (int i = prefix; i < 5; i++) {
				if (c[i] < o.c[i]) {
					return -1;
				}
				if (c[i] > o.c[i]) {
					return 1;
				}
			}
			return 0;
		}
	}

	HashMap<Long, Long> hm = new HashMap<Long, Long>();
	int count = 0;

	long calc(int L, int R, int pos, int rem, int mask) {
		if (rem < 0) {
			return 0;
		}
		long ss = hash(L, pos, rem, mask);
		if (hm.containsKey(ss)) {
			return hm.get(ss);
		}
		count++;
		prefix = pos;
		if (pos == 5) {
			return (R - L) * (R - L - 1L) / 2;
		}
		Arrays.sort(s, L, R);
		long res = 0;
		int prev = L;
		for (int i = L; i < R; i++) {
			if (i > L && s[i].c[pos] != s[prev].c[pos]) {
				res += calc(prev, i, pos + 1, rem, mask);
				res -= calc(prev, i, pos + 1, rem - 1, mask);
				prev = i;
			}
		}
		res += calc(prev, R, pos + 1, rem, mask);
		res -= calc(prev, R, pos + 1, rem - 1, mask);
		res += calc(L, R, pos + 1, rem - 1, mask | (1 << pos));
		// Arrays.sort(s, L, R);
		// System.err.println(ss + " " + res);
		hm.put(ss, res);
		return res;
	}

	void solve() throws IOException {
		int n = nextInt();
		String[] a = new String[n];
		for (int i = 0; i < a.length; i++) {
			a[i] = next();
		}
		Arrays.sort(a);
		HashMap<String, Integer> cc = new HashMap<String, Integer>();
		for (String s : a) {
			if (cc.containsKey(s)) {
				cc.put(s, cc.get(s) + 1);
			} else {
				cc.put(s, 1);
			}
		}
		// System.err.println(Arrays.toString(a));
		s = new Pass[n];
		for (int i = 0; i < a.length; i++) {
			s[i] = new Pass(a[i]);
		}
		long[] res = new long[6];
		for (long x : cc.values()) {
			res[0] += x * (x - 1) / 2;
		}
		for (int i = 1; i < 5; i++) {
			res[i] = calc(0, n, 0, i, 0);
		}
		res[5] = n * (n - 1) / 2;
		for (int i = 5; i > 0; i--) {
			res[i] -= res[i - 1];
		}
		for (int i = 0; i < res.length; i++) {
			out.print(res[i] + " ");
		}
		System.err.println(count);
		// System.err.println(Arrays.toString(res));
	}

	static final String FILENAME = "high";

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	void run() throws IOException {
		br = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		solve();
		out.close();
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String s = br.readLine();
			if (s == null) {
				return null;
			}
			st = new StringTokenizer(s);
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	double parseDouble() throws IOException {
		return Double.parseDouble(next());
	}

	public static void main(String[] args) throws IOException {
		long time = System.currentTimeMillis();
		Locale.setDefault(Locale.US);
		new H().run();
		System.err.println(System.currentTimeMillis() - time);
	}
}
