#include<iostream>
#include<vector>
#include<algorithm>
#include<utility>
#include <set>
#include <string>
using namespace std;

typedef pair<int,int> pii;

struct Cube {
	char c[7];

	Cube rotate(Cube cube, int n1, int n2, int n3, int n4) {
		char t;

		t = cube.c[n1];
		cube.c[n1] = cube.c[n2];
		cube.c[n2] = cube.c[n3];
		cube.c[n3] = cube.c[n4];
		cube.c[n4] = t;

		return cube;
	}

	Cube rotate_0(const Cube& cube) {
		return rotate(cube, 1, 2, 3, 4);
	}

	Cube rotate_2(const Cube& cube) {
		return rotate(cube, 0, 3, 5, 1);
	}

	Cube rotate_1(const Cube& cube) {
		return rotate(cube, 0, 2, 5, 4);
	}

	void normalize() {
		Cube tc[64];
		int n2;
		Cube tc2[24];
		Cube ncube;

		for (int i = 0; i < 4; i++) {
			Cube temp = *this;
			for (int l = 0; l < i; l++) {
				temp = rotate_0(temp);
			}
			for (int j = 0; j < 4; j++) {
				Cube temp1 = temp;
				for (int l = 0; l < j; l++) {
					temp1 = rotate_1(temp1);
				}
				for (int k = 0; k < 4; k++) {
					Cube temp2 = temp1;
					for (int l = 0; l < k; l++) {
						temp2 = rotate_2(temp2);
					}
					tc[16 * i + 4 * j + k] = temp2;
				}
			}
		}
		sort(tc, tc + 64, str6_less);
		//tc2[0] = tc[0];
		//n2 = 1;
		//for (int i = 0; i < 64; i++) {
		//	for (int j = 0; j < 6; j++) {
		//		if (tc2[n2 - 1].c[j] != tc[i].c[j]) {
		//			tc2[n2] = tc[i];
		//			n2++;
		//			break;
		//		}
		//	}
		//}
		*this = tc[0];
	}

	bool operator <(Cube& cube){
		for (int i = 0; i < 6; i++) {
			if (c[i] < cube.c[i]) return true;
			if (c[i] > cube.c[i]) return false;
		}

		return false;
	}

	void write() {
		for (int i = 0; i < 6; i++) {
			cout << c[i];
		}
		cout << endl;
	}

	static bool str6_less(const Cube &c1, const Cube &c2) {
		for (int i = 0; i < 6; i++) {
			if (c1.c[i] < c2.c[i]) return true;
			if (c1.c[i] > c2.c[i]) return false;
		}

		return false;
	}

};

	struct cubeless
	{	// functor for operator<
	bool operator()(Cube _Left,Cube _Right)
		{	// apply operator< to operands
		return (_Left < _Right);
		}
	};


set<Cube,cubeless> cube;
vector<Cube> ans;
set<char> is;
Cube temp;
string p[6];
string tp[6];
int cn;
char st[6];

//inline bool cmp1(const pii& a,const pii& b)
//{
//	return a.first<b.first;
//}

void gen_cubes(int cn, char *st, int num) {
	if (num == 6) {
		Cube ttemp = temp;
		ttemp.normalize();
		cube.insert(ttemp);
		return;
	}
	for (int i = 0; i < cn; i++) {
		temp.c[num] = st[i];
		gen_cubes(cn, st, num + 1);
	}
}

string from_cube(Cube cube, int n1, int n2, int n3, int n4, int n5) {
	string res = "";

	res.push_back(cube.c[n1]);
	res.push_back(cube.c[n2]);
	res.push_back(cube.c[n3]);
	res.push_back(cube.c[n4]);
	res.push_back(cube.c[n5]);

	return res;
}

int main()
{
	int j = 0;

	freopen("cube.in","r",stdin);
	freopen("cube.out","w",stdout);

	for (int i = 0; i < 6; i++) {
		cin >> p[i];
		for (int j = 0; j < 5; j++) {
			is.insert(p[i][j]);
		}
	}
	if (is.size() > 6) {
		cout << "Impossible";
		return 0;
	}
	j = 0;
	cn = is.size();
	for (set<char>::iterator i = is.begin(); i != is.end(); i++, j++) {
		st[j] = *i;
	}
	gen_cubes(cn, st, 0);
	for (int i = 0; i < 6; i++) {
		sort(p[i].begin() + 1, p[i].end());
	}
	sort(p, p + 6);
	for (set<Cube,cubeless>::iterator i = cube.begin(); i != cube.end(); i++) {
		Cube cur = *i;
		bool ok;

		//string str = "ACEDFB";
		//for (int i = 0; i < 6; i++) {
		//	cur.c[i] = str[i];
		//}
		//cur.normalize();
		//if (str == "ACEDFB") {
		//	int a = 3;
		//}
		tp[0] = from_cube(cur, 0, 1, 2, 3, 4);
		tp[1] = from_cube(cur, 1, 0, 2, 5, 4);
		tp[2] = from_cube(cur, 2, 0, 3, 5, 1);
		tp[3] = from_cube(cur, 3, 5, 2, 0, 4);
		tp[4] = from_cube(cur, 4, 3, 0, 1, 5);
		tp[5] = from_cube(cur, 5, 1, 2, 3, 4);
		for (int j = 0; j < 6; j++) {
			sort(tp[j].begin() + 1, tp[j].end());
		}
		sort(tp, tp + 6);
		ok = true;
		for (int j = 0; j < 6; j++) {
			if (p[j] != tp[j]) ok = false;
		}
		if (!ok) continue;
		ans.push_back(cur);
	}
	if (ans.size() == 0) {
		cout << "Impossible";
	} else {
		for (int i = 0; i < min(ans.size(), (size_t)2); i++) {
			ans[i].normalize();
			ans[i].write();
		}
	}

	return 0;
}

