#include<iostream>
#include<vector>
#include<utility>
#include<algorithm>
#include<set>
#include<list>
using namespace std;

const int MAXN = 100010;
typedef long long LLL;

typedef pair<int,int> pii;

int n;
pii c[MAXN];
int mass[MAXN];
set<int> st;
list<int> ls;
int tree[300000];
const int S = (1 << 17) - 1;
pair<int, int> pr[MAXN];

inline bool cmp1(const pii& a,const pii& b)
{
	if(a.first!=b.first)
		return a.first<b.first;
	return a.second<b.second;
}

inline bool cmp2(const pii& a,const pii& b)
{
	if(a.second!=b.second)
		return a.second<b.second;
	return a.first<b.first;
}


long long inversion() {
	long long res = 0;

	for (int i = 0; i < 300000; i++) {
		tree[i] = 0;
	}
	for (int i = 0; i < n; i++) {
		pr[i].first = mass[i];
		pr[i].second = i;
	}
	sort(pr, pr + n);
	for (int i = 0; i < n; i++) {
		int num = pr[i].second;
		int t;

		t = S + num;
		tree[t] = 1;
		while (t > 0) {
			int tt = (t - 1) / 2;
			tree[tt] = tree[2 * tt + 1] + tree[2 * tt + 2];

			if (t % 2 == 1) {
				res += tree[t + 1];
			}

			t = tt;
		}
		t = S + num;
	}

	return res;
}

int main()
{
	freopen("john.in","r",stdin);
	freopen("john.out","w",stdout);
	scanf("%d",&n);
	for(int i=0;i<n;i++)
		scanf("%d %d",&c[i].first,&c[i].second);
	//1	
	sort(c,c+n,cmp1);
	for(int i=0;i<n;i++)
	{
		mass[i] = c[i].second;
	}
	LLL a1 = inversion();
	//2
	sort(c,c+n,cmp2);
	for(int i=0;i<n;i++)
	{
		mass[i] = c[i].first;
	}
	LLL a2 = inversion();
	cout<<(min(a1,a2));

	return 0;
}