import java.io.*;
import java.util.*;

public class Flat {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}

	void solve() throws Exception {
		int n = nextInt();
		long k = nextInt();
		long ans1 = 0;
		long ans2 = 0;
		long ans3 = 0;
		for (int i = 0; i < n; i++) {
			int s = nextInt();
			String g = next();
			ans1 += s;
			if (g.equals("bedroom")) {
				ans2 += s;
			}
			ans3 += 2 * s;
			if (g.equals("balcony")) {
				ans3 -= s;
			}
		}
		double a = ans3;
		a /= 2;
		a *= k;
		out.println(ans1);
		out.println(ans2);
		out.println(a);
	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("flat.in"));
			out = new PrintWriter("flat.out");

			solve();

			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new Flat().run();

	}

}
