#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cstring>
#include <ctime>
#include <cstdlib>
#include <cassert>
#include <cstdio>

using namespace std;

#define forn(i, n) for (int i = 0; i < (n); i++)
#define eprintf(...) {fprintf(stderr, __VA_ARGS__); fflush(stderr);}
#define sz(c) (int)(c).size()
#define pb push_back
#define all(c) (c).begin(),(c).end()
typedef long long LL;

#define TASK "dice"
const int maxn = 1<<10;
vector<int> res[maxn];
int a[maxn],p[maxn];

int cmpa(int o1,int o2){
	return a[o1]<a[o2];
}

int main() {
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
	int n,s=0;
	scanf("%d",&n);
	forn(i,n) scanf("%d",&a[i]),s+=a[i],p[i]=i;
	sort(p,p+n,cmpa);
	double ans = 0.;
	forn(i,n){
		forn(j,a[p[i]]){
			ans += (1.*s)/a[p[i]];
			res[p[i]].pb(s--);
		}
		sort(all(res[p[i]]));
	}
	printf("%.30lf\n",ans);
	forn(i,n){
		forn(j,sz(res[i])) printf("%d%c",res[i][j]," \n"[j+1==a[i]]);
	}

	return 0;
}
