#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cstring>
#include <ctime>
#include <cstdlib>
#include <cassert>
#include <cstdio>

using namespace std;

#define sz(v) ((int)((v).size()))
#define forn(i, n) for (int i = 0; i < (n); i++)
#define eprintf(...) {fprintf(stderr, __VA_ARGS__); fflush(stderr);}
typedef long long LL;
typedef pair<int, int> ii;

#define TASK "galaxy"

bool b[5002][1<<10];
bool can[10];
int bc[1<<10];
vector<int> a[5002];
int ans[5002];
int nc[5002];

int main() {
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
	int n, k, m;
	scanf("%d%d%d", &n, &k, &m);
	
	forn(i, m) {
		int x, y;
		scanf("%d%d", &x, &y);
		x--, y--;
		a[x].push_back(y);
		a[y].push_back(x);
	}
	
	forn(i, n) ans[i] = -1;
	forn(i, k) ans[i] = i;
	
	int kk = 1 << k;
	forn(mask, kk) if (mask) bc[mask] = bc[mask >> 1] + (mask & 1);
	
	vector<ii> mm;
	forn(mask, kk) mm.push_back(ii(bc[mask], mask));
	sort(mm.begin(), mm.end());
	
	forn(maski, kk) {
		int mask = mm[maski].second;
		forn(i, k) {
			if (bc[mask] == 0) continue;
			if (bc[mask] == 1) {
				b[i][mask] = (1 << ans[i]) == mask;
				continue;
			}
			if (!(mask & (1 << ans[i]))) continue;
			forn(j, sz(a[i])) {
				b[i][mask] |= (ans[a[i][j]] >= 0 && b[a[i][j]][mask ^ (1 << ans[i])]);
			}
		}
	}
	
//	forn(i, n) forn(mask, kk) printf("%d %d  %d\n", i, mask, b[i][mask]);
	
	
	set<ii> ss;
	forn(i, n) if (i >= k) {
		nc[i] = sz(a[i]);
		forn(j, sz(a[i])) {
			if (ans[a[i][j]] >= 0) nc[i]--;
		}
		nc[i] = (rand() & 255);
		ss.insert(ii(nc[i], i));
	}
	
	while (!ss.empty()) {
		int i = ss.begin()->second;
		ss.erase(ss.begin());
		memset(can, 1, sizeof can);
		forn(j, sz(a[i])) if (ans[a[i][j]] >= 0) can[ans[a[i][j]]] = 0;
		forn(l, k) if (can[l]) {
			forn(j, sz(a[i])) if (ans[a[i][j]] >= 0) {
				if (b[a[i][j]][(kk - 1) ^ (1 << l)]) {
					ans[i] = l;
					goto ok;
				}
			}
		}
		assert(0);
		
		ok:;
		b[i][1 << ans[i]] = 1;
		forn(mask, kk - 1) if (!(mask & (1 << ans[i]))) {
			forn(j, sz(a[i])) if (b[a[i][j]][mask]) {
				b[i][mask ^ (1 << ans[i])] = 1;
			}
		}
		
	}
	
	forn(i, n) printf("%d ", ans[i] + 1);
	printf("\n");
	
	return 0;
}
