#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cstring>
#include <ctime>
#include <cstdlib>
#include <cassert>
#include <cstdio>

using namespace std;

#define forn(i, n) for (int i = 0; i < (n); i++)
#define eprintf(...) {fprintf(stderr, __VA_ARGS__); fflush(stderr);}
typedef long long LL;

#define TASK "john"
const int maxn = 1<<20;
int a[maxn],b[maxn],c[maxn],p[maxn];
LL f[maxn];

int cmpa(int _a,int _b){
	if(a[_a]!=a[_b]) return a[_a]<a[_b];
	return b[_a] < b[_b];
}

int main() {
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
	int n; scanf("%d",&n);
	forn(i,n) scanf("%d%d",&a[i],&b[i]),p[i]=i;
	int nc = 0;
	forn(i,n){
		c[nc++] = a[i];
		c[nc++] = b[i];
	}
	sort(c,c+nc);
	nc = unique(c,c+nc)-c;
	LL res[2];
	res[0] = 0;
	res[1] = 0;
	forn(k,2){
		memset(f,0,sizeof f);
		sort(p,p+n,cmpa);
		forn(i,n){
			int ind = (lower_bound(c,c+nc,b[p[i]])-c)+1;
			for(int j = ind + 1 ; j < maxn ; j+=j&-j) res[k]+=f[j];
			for(int j = ind ; j > 0 ; j-=j&-j ) f[j]++;
		}
		forn(i,n) swap(a[i],b[i]);
	}
	printf("%I64d\n",min(res[0],res[1]));
	return 0;
}
