import java.io.*;
import java.util.*;

class high {
	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while ((in == null) || (!in.hasMoreTokens()))
			in = new StringTokenizer(br.readLine());
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public String get(String s, int mask) {
		String ans = "";
		for (int i = 0; i < 5; i++) {
			if (mask % 2 > 0)
				ans = ans + s.charAt(i);
			mask /= 2;
		}
		return ans;
	}
	
	public int getC(int t) {
		int ans = 0;
		for (int i = 0; i < 5; i++) {
			ans += t % 2;
			t /= 2;
		}
		return ans;
	}
	
	public void solve() throws IOException {
		int n = nextInt();
		String[] a = new String[n];
		for (int i = 0; i < n; i++) {
			a[i] = nextToken();
		}
		
		
		long[] c = new long[32];
		for (int mask = 0; mask < 32; mask++) {
			HashMap<String, Long> count = new HashMap<String, Long>();
			for (int i = 0; i < n; i++) {
				String s = get(a[i], mask);
				if (count.containsKey(s)) {
					count.put(s, count.get(s) + 1);
				} else {
					count.put(s, (long)1);
				}
			}
			for (int i = 0; i < n; i++) {
				String s = get(a[i], mask);
				if (count.containsKey(s)) {
					c[mask] += count.get(s) * (count.get(s) - 1) / 2;
					count.remove(s);
				}
			}
		}
		
		long[] d = new long[32];
		long[] ans = new long[6];
		for (int i = 0; i < 32; i++) {
			for (int j = 0; j < 32; j++) {
				if ((j | i) != j) 
					continue;
				if ((getC(j) - getC(i)) % 2 == 0)
					d[i] += c[j];
				else
					d[i] -= c[j];
			}
			ans[5 - getC(i)] += d[i];
		}
		
		for (int i = 0; i < 6; i++) {
			out.print(ans[i]);
			if (i < 5)
				out.print(' ');
			else
				out.println();
		}
		
	}

	public void run() {
		try {
			br = new BufferedReader(new FileReader("high.in"));
			out = new PrintWriter("high.out");

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new high().run();
	}
}