#include <cstdio>
#include <vector>
#include <algorithm>
#include <utility>
using namespace std;

int main()
{
  freopen("dice.in",  "rt", stdin);
  freopen("dice.out", "wt", stdout);

  int n;
  while (scanf("%d", &n) == 1)
  {
    vector<pair<int, int> > nums(n);
    int c= 0;
    for(int i = 0; i < n ; ++i) {
      scanf("%d", &nums[i].first);
      nums[i].second = i;
      c += nums[i].first;
    }
    sort(nums.begin(), nums.end());
    double ans = 0;
    vector<vector<int> > dices(n);
    vector<int> i2n(n);
    for (int i = 0; i < n; ++i) {
      i2n[nums[i].second] = i;
    }
    for (int i = 0; i < n; ++i) {
      for (int j = 0; j < nums[i].first; ++j) {
        ans += c / (double) nums[i].first;
        dices[i].push_back(c);
        --c;
      }
    }
    printf("%.16lf\n", ans);
    for (int i = 0; i < n; ++i) {
      for (int j = 0; j < nums[i2n[i]].first; ++j) {
        printf("%d ", dices[i2n[i]][j]);
      }
      printf("\n");
    }
  }
  return 0;
}