#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cstdio>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

string fname = "dice";
string fin = fname + ".in";
string fout = fname + ".out";

int main()
{
	freopen(fin.c_str(), "r", stdin);
	freopen(fout.c_str(), "w", stdout);
	
	int n, k;
	long long sum;
	cin >> n;
	vector<pair<int, int>> v;
	sum = 0;
	for (int i = 1; i <= n; i++)
	{
		cin >> k;
		sum += k;
		v.push_back(make_pair(k, i));
	}

	sort(v.begin(), v.end());
	double e = 0;
	vector<vector<long long>> result(n);
	int num;

	for (int i = 0; i < n; i++)
	{
		k = v[i].first;
		num = v[i].second;
		e += (1.0 / k) * (sum + sum - k + 1) * k / 2;
		for (int j = 0; j < k; j++)
		{
			result[i].push_back(sum);
			sum--;
		}
	}
	cout << std::fixed << e << endl;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < result[i].size(); j++)
			cout << result[i][j] << " ";
		cout << endl;
	}

	return 0;
}