#include <iostream>
#include <cstdio>
#include <vector>
#include <string>
#include <map>
#include <algorithm>
using namespace std;
typedef long long ll;
typedef map<string, int>::iterator it;
const int N=110000;
int n;
ll ans;
int a[N],b[N];
struct card {
	int r,b;
	bool operator < (const card &c2) {
		if (r<c2.r) return 1;
		if (r>c2.r) return 0;
		if (b<c2.b) return 1;
		return 0;
	}
}  c[N];
ll merge_sort (int l, int r) {
	if (r-l==1) return 0;
	ll res=0;
	int m=(l+r)/2;
	res+=merge_sort(l,m);
	res+=merge_sort(m,r);
	int pl=l, pr=m;
	int cnt=l;
	while (pl<m && pr<r) {
		if (a[pl]<a[pr]) b[cnt++]=a[pl++];
		else {
			res+=m-pl;
			b[cnt++]=a[pr++];
		}
	}
	while (pl<m) b[cnt++]=a[pl++];
	while (pr<r) b[cnt++]=a[pr++];
	for (int i=l; i<r; i++)
		a[i]=b[i];
	return res;
}
int main () {
	freopen("john.in","r",stdin);
	freopen("john.out","w",stdout);
	cin>>n;
	for (int i=0; i<n; i++) scanf("%d%d",&c[i].r,&c[i].b);
	sort(c,c+n);
	for (int i=0; i<n; i++) a[i]=c[i].b;
	cout<<merge_sort(0,n);
}