#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <cassert>
#include <ctime>
#include <stdarg.h>

#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define nextLine() {for(int c = getchar(); c != '\n' && c != EOF; c = getchar());}
#define sqr(a) ((a)*(a))
#define has(mask, i) (((mask) >> (i)) & (1))

using namespace std;

typedef long long LL;
typedef long double ldb;
typedef pair<int, int> pii;

int n;
char s[50005][7];

void Load()
{
	scanf("%d\n", &n);
	for (int i = 0; i < n; i++)
		gets(s[i]);
}

string ns[50005];

LL cnt[35];
LL ans[10];

void Solve()
{
	for (int mask = 0; mask < (1 << 5); mask++)
	{
		for (int i = 0; i < n; i++)
		{
			ns[i] = "";
			for (int j = 0; j < 5; j++)
			{
				if (!has(mask, j))
					ns[i] += s[i][j];
			}
		}

		sort(ns + 0, ns + n);
		//cerr << "mask = " << mask << " diff = " << diff << endl;
		//for (int i = 0; i < n; i++)
		//	cerr << ns[i] << endl;

		for (int i = 0; i < n; i++)
		{
			int j = i;
			while (j < n && ns[i] == ns[j])
				j++;
			LL cur = j - i;
			cnt[mask] += cur * (cur - 1) / 2;
			i = j - 1;
		}
	}
	
	for (int diff = 0; diff <= 5; diff++)
	{
		for (int mask = 0; mask < (1 << 5); mask++)
		{
			int cur = 0;
			for (int j = 0; j < 5; j++)
				if (has(mask, j)) cur++;
			if (cur != diff) continue;

			ans[diff] += cnt[mask];
			for (int mask2 = 0; mask2 < (1 << 5); mask2++)
				if (((mask & mask2) == mask2) && (mask != mask2))
				{
					ans[diff] -= cnt[mask2];
					cnt[mask] -= cnt[mask2];
				}
		}
	}
	for (int i = 0; i <= 5; i++)
		cout << ans[i] << " ";
}

#define task "high"
int main()
{
	freopen(task".in", "r", stdin);
	freopen(task".out", "w", stdout);
	Load();
	Solve();
	return 0;
}
