#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <cassert>
#include <ctime>
#include <stdarg.h>
#include <memory.h>

#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define nextLine() {for(int c = getchar(); c != '\n' && c != EOF; c = getchar());}
#define sqr(a) ((a)*(a))
using namespace std;

typedef long long LL;
typedef long double ldb;
typedef pair<int, int> pii;

int n;
pii ma[100005];

void Load()
{
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		scanf("%d%d", &ma[i].fi, &ma[i].se);
}

map <int, int> nx;

int b[100005];

LL s[(1 << 18) + 1];
int m;

inline void add(int pos)
{
	for (int i = pos; i <= m; i += i & (-i))
		s[i]++;
}

inline LL sum(int pos)
{
	LL res = 0;
	for (int i = pos; i > 0; i -= i & (-i))
		res += s[i];
	return res;	
}

pii a[100005];

inline LL count()
{
	for (int i = 0; i < n; i++)
		a[i] = ma[i];
	sort(a + 0, a + n);
	vector <int> all;
	for (int i = 0; i < n; i++)
		all.pb(a[i].se);
	sort(all.begin(), all.end());
	all.erase(unique(all.begin(), all.end()), all.end());
	m = all.size();
	for (int i = 0; i < m; i++)
		nx[all[i]] = i + 1;
	LL res = 0;
	memset(s, 0, sizeof(s));
	for (int i = n - 1; i >= 0; i--)
	{
		add(nx[a[i].se]);
		res += sum(nx[a[i].se] - 1);
	}
	return res;
}

void Solve()
{
	LL r1 = count();
	for (int i = 0; i < n; i++)
		swap(ma[i].fi, ma[i].se);
	LL r2 = count();
	cout << min(r1, r2);
}

#define task "john"
int main()
{
	freopen(task".in", "r", stdin);
	freopen(task".out", "w", stdout);
	Load();
	Solve();
	return 0;
}
