#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <cassert>
#include <cstdlib>

using namespace std;

#define TASKNAME "dice"
#define pb push_back
#define mp make_pair
#define fori(i,b,e) for(int i = (b); i < (e); ++i)
#define sz(a) (int)(a).size()


typedef long long int64;

const int maxn = 1000;
bool was[maxn];
int a[maxn];
vector<int> ans[maxn];

int main()
{
	assert(freopen(TASKNAME ".in", "rt", stdin));
	assert(freopen(TASKNAME ".out", "wt", stdout));
	int n, m;
	scanf ("%d", &n);
	fori(i,0,n) {
		scanf ("%d", a+i);
		m += a[i];
	}
	int cur = 1;
	fori(t,0,n) {
		int ind = -1;
		fori(i,0,n) {
			if (!was[i] && (ind == -1 || a[i] > a[ind])) {
				ind = i;
			}
		}
		was[ind] = true;
		fori(i,0,a[ind]) {
			ans[ind].pb(cur+i);
		}
		cur += a[ind];
	}
	double res = 0;
	fori(i,0,n) {
		double cur = 0;
		fori(j,0,sz(ans[i])) {
			cur += ans[i][j];
		}
		res += cur / sz(ans[i]);
	}
	printf ("%.10lf\n", res);
	fori(i,0,n) {
		fori(j,0,sz(ans[i])) {
			printf ("%d%c", ans[i][j], "\n "[j+1 < sz(ans[i])]);
		}
	}
	return 0;
}