import java.util.*;
import java.io.*;

public class B implements Runnable {
	private MyScanner in;
	private PrintWriter out;
	private final String fileName = "black";

	private void solve() {
		int m = in.nextInt();
		int n = in.nextInt();
		int s = in.nextInt();
		int k = in.nextInt() - 1;
		char[] str = in.next().toCharArray();
		int from = -1, to = -1;
		for (int i = 0; i < n; ++i) {
			if (str[i] == '*') {
				if (from == -1) {
					from = i;
				} else if (to != -1) {
					out.println("Impossible");
					return;
				}				
			} else if (from != -1) {
				to = i - 1;
			}
		}
		if (from != -1 && to == -1) {
			to = n - 1;
		}
		if (from != -1 && to - from + 1 != s) {
			out.println("Impossible");
			return;
		}
		if (from == -1) {
			if (k < s && m - 1 - k < s) {
				out.println("Impossible");
				return;
			}
			if (k >= s && m - 1 - k >= s || n > s) {
				out.println("Ambiguous");
				return;
			}
			out.println("Unique");
			return;
		}
		if (s != 1 && m > s && k != 0 && k != m - 1) {
			out.println("Ambiguous");
			return;
		}
		out.println("Unique");
	}

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			in = new MyScanner(fileName);
			out = new PrintWriter(new File(fileName + ".out"));
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		new B().run();
	}

	static class MyScanner {
		private BufferedReader br;
		private StringTokenizer st;

		public MyScanner(String fn) {
			try {
				br = new BufferedReader(new FileReader(fn + ".in"));
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

		private String nextToken() {
			try {
				while (st == null || !st.hasMoreTokens()) {
					st = new StringTokenizer(br.readLine());
				}
				return st.nextToken();
			} catch (IOException e) {
				e.printStackTrace();
				return null;
			}
		}

		public String next() {
			return nextToken();
		}

		public String nextLine() {
			try {
				return br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
				return null;
			}
		}

		public int nextInt() {
			return Integer.parseInt(nextToken());
		}

		public long nextLong() {
			return Long.parseLong(nextToken());
		}

		public double nextDouble() {
			return Double.parseDouble(nextToken());
		}
	}
}
