#include <fstream>
#include <string>
#include <algorithm>
#include <functional>
using namespace std;

string get_answer(int n) {
	switch(n) {
		case 1: return "Unique";
		case 2: return "Ambiguous";
		case 3: return "Impossible";
		default: return "Presentation error";
	}
	return "WTF??";
}

int main()
{
	ifstream in("black.in");
	ofstream out("black.out");

	int m, n, s, k, c = 0;
	in >> m >> n >> s >> k;
	string data;
	in >> data;
	int state = 0;
	int ans = 0;
	for(size_t i = 0; i < data.size(); ++i) {
		if(data[i] == '*') {
			if(state == 0) state = 1;
			else if(state == 2) {
				ans = 3;
				break;
			}
			++c;
		} else {
			if(state == 1) state = 2;
		}
	}
	if(ans == 3) {
		out << get_answer(ans);
		return 0;
	}

	// impossible
	if(c != s) {
		out << get_answer(3);
		return 0;
	}
	if(s > m || s > n) {
		out << get_answer(3);
		return 0;
	}
	if(c == 0 && (k < s || m - k < s)) {
		out << get_answer(3);
		return 0;
	}

	// unique
	if(s == m) {
		out << get_answer(1);
		return 0;
	}
	if(s == 1) {
		out << get_answer(1);
		return 0;
	}
	if(k == 1) {
		out << get_answer(1);
		return 0;
	}
	if(k == m) {
		out << get_answer(1);
		return 0;
	}

	// ambiguous
	out << get_answer(2);
	return 0;
}
