#include <fstream>
#include <string>
#include <vector>
#include <algorithm>
#include <functional>
#include <iterator>
using namespace std;

int main()
{
	ifstream in("dice.in");
	ofstream out("dice.out");

	int n;
	in >> n;
	vector< pair<int, int> > dice(n);
	vector<int> elems(n);
	int m = 0;
	for(int i = 0; i < n; ++i) {
		in >> dice[i].first;
		m += dice[i].first;
		dice[i].second = i;
		elems[i] = dice[i].first;
	}
	sort(dice.begin(), dice.end(), [](const pair<int, int>& lhs, const pair<int, int>& rhs) -> bool {
		return lhs.first < rhs.first;
	});
	
	double E = 0.0;
	vector< vector<int> > am(n);
	vector<int> sum(n);
	int cur = m;
	for(size_t i = 0; i < dice.size(); ++i) {
		int ror = 0;
		for(int j = 0; j < dice[i].first; ++j) {
			am[dice[i].second].push_back(cur--);
			ror += am[dice[i].second].back();
		}
		sum[dice[i].second] = ror;
	}

	double prod = 1.0;
	for(int i = 0; i < n; ++i)
		prod *= dice[i].first;

	double ans = 0.0;
	for(int i = 0; i < n; ++i) {
		ans += sum[i] * prod / elems[i];
	}
	ans /= prod;

	out.precision(10);
	out << fixed << ans << "\n";
	for(int i = 0; i < n; ++i) {
		copy(am[i].rbegin(), am[i].rend(), ostream_iterator<int>(out, " "));
		out << "\n";
	}
	return 0;
}
