#include <iostream>
#include <cstring>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <vector>
using namespace std;
#define ll long long
#define mp(a, b) make_pair(a, b)
#define pb(a) push_back(a)
#define ss second
#define ff first



int nxt[123123], end[123123], fst[5123];
int edgs;
int n, k, m;
int prv[123123];

void addEdge(int i, int j)
{
nxt[edgs] = fst[i];
fst[i] =edgs;
end[edgs] = j;
edgs++;

}

void load()
{
	cin  >> n >> k >> m;
	int a, b;
	memset(fst, -1, sizeof fst);
	for (int i = 0; i < m; i++)
	{
		scanf("%d%d", &a, &b);
		addEdge(a, b);
		addEdge(b, a);
	}
}

int color[123123];
int q[123123];
int usd[123123];
int qh, qt;

int was[11];
int cant[11];


void dfs(int ver, int k, int c)
{
	if (k == 0)
	{
		was[color[ver]] = c;
		return;
	}
	dfs(prv[ver], k - 1, c);
}

void solve()
{
	for (int i = 1; i <= k; i++)
		color[i] = i;
	for (int i = 1; i <= k; i++)
	{
		prv[i] = i + 1;
		for (int j = fst[i]; j != -1; j = nxt[j])
		{
			if (!usd[end[j]] && !color[end[j]])
			{
				usd[end[j]] = 1;
				q[qt++] = end[j];
			}	
		}
		if (prv[i] == k + 1) prv[i] = 1;
	}
	int v;
	while (qh < qt)
	{
		v = q[qh++];
		memset(was, 0, sizeof was);
		memset(cant, 0, sizeof cant);
		for (int u = fst[v]; u != -1; u = nxt[u])
		{
			if (color[end[u]])
			{
				cant[color[end[u]]] = 1;
				dfs(end[u], k - 1, end[u]);
			}
		}
		for (int j = 1; j <= k; j++)
		{
			if (was[j] && !cant[j])
			{
				color[v] = j;
				prv[v] = was[j];
				break;
			}
		}
		for (int u = fst[v]; u != -1; u = nxt[u])
		{
			if (!color[end[u]] && !usd[end[u]])
			{
				q[qt++] = end[u];
				usd[end[u]] = 1;
			}
		}
		if (color[v] == 0) throw 42;
	}
	for (int i = 1; i <= n; i++)
	{
		printf("%d ", color[i]);
	}
}
#define file "galaxy"
int main()
{
	freopen(file".in", "rt", stdin);
	freopen(file".out", "wt", stdout);
	load();
	solve();
	return 0;
}                   

