import java.io.*;
import java.util.StringTokenizer;

public class B {

	static void solve() throws Exception {
		int rows = nextInt();
		nextInt();
		int s = nextInt();
		int k = nextInt();
		String line = nextToken();
		out.println(get(rows, s, k, line));
	}

	static String get(int r, int s, int k, String line) {
		int first = line.indexOf('*');
		if (first < 0) {
			if (k - 1 < s && r - k < s) {
				return "Impossible";
			}
			if (line.length() != s) {
				return "Ambigous";
			}
			if (k - 1 == s && r - k < s) {
				return "Unique";
			}
			if (k - 1 < s && r - k == s) {
				return "Unique";
			}
			return "Ambigous";
		}
		int last = line.lastIndexOf('*');
		int stars = last - first + 1;
		if (stars != s) {
			return "Impossible";
		}
		for (int i = first; i <= last; i++) {
			if (line.charAt(i) != '*') {
				return "Impossible";
			}
		}
		if (s == 1) {
			return "Unique";
		}
		if (k == 1 || k == r || r == s) {
			return "Unique";
		} else {
			return "Ambigous";
		}
	}

	static int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	static String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = br.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}

	static BufferedReader br;
	static PrintWriter out;
	static StringTokenizer st;

	public static void main(String[] args) throws Exception {
		br = new BufferedReader(new FileReader("black.in"));
		out = new PrintWriter("black.out");
		solve();
		out.close();
	}
}
