import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Locale;
import java.util.Scanner;


public class D {

	/**
	 * @param args
	 * @throws FileNotFoundException 
	 */
		
	public static void main(String[] args) throws FileNotFoundException {
		Locale.setDefault(Locale.US);
		Scanner in = new Scanner(new File("dice.in"));
		int dNum = in.nextInt();
		List<Pair> list = new ArrayList<Pair>();
		int m = 0;
		for(int i = 0; i < dNum;i++){
			Pair p = new Pair(i, in.nextInt());
			list.add(p);
			m += p.count;			
		}
		Collections.sort(list, new Comparator());
		
		int tmp = 0;
		for(Pair p : list) {
			p.pr = tmp;
			tmp += p.count;
		}
		
		PrintWriter pw = new PrintWriter(new File("dice.out"));
		//pw.println(all);
		//for (int i = m; i > 0; i--) {
		double mo = 0;
		int cM = m;
		for(Pair p : list) {
			if(p.count > 1) mo += 1.0 / p.count * (2 * cM - p.count) * (cM - cM  + p.count + 1) / 2.0;
			else mo += cM;
			//System.out.println(mo);
			cM -= p.count;
		}		
		pw.printf("%.5f", mo);
		pw.println();
		//int mNext = m;
		for(int i = 0; i < dNum; i++) {	
			Pair next = null;
			for(Pair p : list) {
				if(p.index == i) {
					next = p;
					break;
				}
			}
			/*for(int j = mNext; j > mNext - next.count; j--) {
				pw.print(j + " ");
			}*/
			for (int j = m - next.pr; j > m -next.pr - next.count; j--) {
				pw.print(j + " ");
			}
			//mNext -= next.count;
			pw.println();
		}
		
		pw.flush();
		
		//pw.print(res);
		pw.close();

	}
	
	public static class Pair{
		
		int index;
		
		int count;
		
		int pr;

		public Pair(int index, int count) {
			super();
			this.index = index;
			this.count = count;
		}
		
		
		
		
		
	}
	
	public static class Comparator implements java.util.Comparator<Pair>{

		@Override
		public int compare(Pair o1, Pair o2) {
			return o1.count-o2.count;
		}
		
	}

}
