import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;



public class J {
	public static void main(String[] args) throws FileNotFoundException {
		Scanner in = new Scanner(new File("john.in"));
		int n = in.nextInt();
		List<Card> list = new ArrayList<Card>();
		for(int i=0; i<n; i++)
			list.add(new Card(in.nextInt(), in.nextInt()));
		
		Collections.sort(list, new Comparator());
		
		int min1 = 0;
		
		for(int i=0; i<n; i++){
			Card card = list.get(i);
			for(int j=0; j<i; j++){
				Card card1 = list.get(j);
				if(card.b<card1.b)
					min1++;
			}
		}
		
		
		Collections.sort(list, new Comparator2());
		
		int min2 = 0;
		
		for(int i=0; i<n; i++){
			Card card = list.get(i);
			for(int j=0; j<i; j++){
				Card card1 = list.get(j);
				if(card.r<card1.r)
					min2++;
			}
		}
		
		PrintWriter pw = new PrintWriter(new File("john.out"));
		pw.print(Math.min(min1, min2));
		pw.close();
	}
	
	public static class Card{
		int r;
		
		int b;

		public Card(int r, int b) {
			super();
			this.r = r;
			this.b = b;
		}
	}
	
	public static class Comparator implements java.util.Comparator<Card>{

		@Override
		public int compare(Card o1, Card o2) {
			if(o1.r!=o2.r)
				return o1.r-o2.r;
			else
				return o1.b-o2.b;
		}
		
	}
	
	public static class Comparator2 implements java.util.Comparator<Card>{

		@Override
		public int compare(Card o1, Card o2) {
			if(o1.b!=o2.b)
				return o1.b-o2.b;
			else
				return o1.r-o2.r;
		}
		
	}
}
