#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
using namespace std;
typedef multiset<char> ms;
pair <char, char> p1, p2, p3, p4, p5, p6;

bool eq(const ms &a, const ms &b) {
	ms c = b;
	for (multiset<char>::iterator it = a.begin(); it != a.end(); it++) {
		if (c.find(*it) == c.end()) {
			return false;
		}
		c.erase(c.find(*it));
	}
	return c.size() == 0;
}
//bool eqs(string s1, string s2) {
//	int k = s1.length();
//	s1 += s1;
//	string sl;
//	for (int i = 0; i < k; i++) {
//		sl = "";
//		for (int j = i; j < i + k; j++) {
//			sl += s1[j];
//		}
//		if (sl == s2) return true;
//	}
//	return false;
//}
//bool eqs(string s1, string s2) {
//	p1.first = min(s1[0], s1[5]);
//	p1.second = max(s1[0], s1[5]);
//	p3.first = min(s1[1], s1[3]);
//	p3.second = max(s1[1], s1[3]);
//	p2.first = min(s1[2], s1[4]);
//	p2.second = max(s1[2], s1[4]);
//
//	p4.first = min(s2[0], s2[5]);
//	p4.second = max(s2[0], s2[5]);
//	p6.first = min(s2[1], s2[3]);
//	p6.second = max(s2[1], s2[3]);
//	p5.first = min(s2[2], s2[4]);
//	p5.second = max(s2[2], s2[4]);
//
//	if ((p1 == p4 && p2 == p5 && p3 == p6) || (p1 == p4 && p2 == p6 && p3 == p5) ||
//		(p1 == p5 && p2 == p4 && p3 == p6) || (p1 == p5 && p2 == p6 && p3 == p4) ||
//		(p1 == p6 && p2 == p4 && p3 == p5) || (p1 == p6 && p2 == p5 && p3 == p4)) return true;
//
//
//
//	return false;
//}

bool eqs(string s1, string s2) {
	char c1, c2, c3, c4, c5, c6, q1, q2, q3, q4, q5, q6;
	c1 = s1[0];
	c2 = s1[1];
	c3 = s1[2];
	c4 = s1[3];
	c5 = s1[4];
	c6 = s1[5];
	q1 = s2[0];
	q2 = s2[1];
	q3 = s2[2];
	q4 = s2[3];
	q5 = s2[4];
	q6 = s2[5];
	return ((c1 == q1) && (c2 == q2) && (c3 == q3) && (c4 == q4) && (c5 == q5) && (c6 == q6)) || 
		   ((c1 == q1) && (c2 == q3) && (c3 == q4) && (c4 == q5) && (c5 == q2) && (c6 == q6)) || 
		   ((c1 == q1) && (c2 == q4) && (c3 == q5) && (c4 == q2) && (c5 == q3) && (c6 == q6)) || 
		   ((c1 == q1) && (c2 == q5) && (c3 == q2) && (c4 == q3) && (c5 == q4) && (c6 == q6)) || 

		   ((c1 == q2) && (c2 == q6) && (c3 == q3) && (c4 == q1) && (c5 == q5) && (c6 == q4)) || 
		   ((c1 == q2) && (c2 == q3) && (c3 == q1) && (c4 == q5) && (c5 == q6) && (c6 == q4)) ||
		   ((c1 == q2) && (c2 == q1) && (c3 == q5) && (c4 == q6) && (c5 == q3) && (c6 == q4)) ||
		   ((c1 == q2) && (c2 == q5) && (c3 == q6) && (c4 == q3) && (c5 == q1) && (c6 == q4)) ||

		   ((c1 == q3) && (c2 == q2) && (c3 == q6) && (c4 == q4) && (c5 == q1) && (c6 == q5)) ||
		   ((c1 == q3) && (c2 == q6) && (c3 == q4) && (c4 == q1) && (c5 == q2) && (c6 == q5)) ||
		   ((c1 == q3) && (c2 == q4) && (c3 == q1) && (c4 == q2) && (c5 == q6) && (c6 == q5)) ||
		   ((c1 == q3) && (c2 == q1) && (c3 == q2) && (c4 == q6) && (c5 == q4) && (c6 == q5)) ||

		   ((c1 == q4) && (c2 == q1) && (c3 == q3) && (c4 == q6) && (c5 == q5) && (c6 == q2)) ||
		   ((c1 == q4) && (c2 == q3) && (c3 == q6) && (c4 == q5) && (c5 == q1) && (c6 == q2)) ||
		   ((c1 == q4) && (c2 == q6) && (c3 == q5) && (c4 == q1) && (c5 == q3) && (c6 == q2)) ||
		   ((c1 == q4) && (c2 == q5) && (c3 == q1) && (c4 == q3) && (c5 == q6) && (c6 == q2)) ||

		   ((c1 == q5) && (c2 == q2) && (c3 == q1) && (c4 == q4) && (c5 == q6) && (c6 == q3)) ||
		   ((c1 == q5) && (c2 == q1) && (c3 == q4) && (c4 == q6) && (c5 == q2) && (c6 == q3)) ||
		   ((c1 == q5) && (c2 == q4) && (c3 == q6) && (c4 == q2) && (c5 == q1) && (c6 == q3)) ||
		   ((c1 == q5) && (c2 == q6) && (c3 == q2) && (c4 == q1) && (c5 == q4) && (c6 == q3)) ||

		   ((c1 == q6) && (c2 == q2) && (c3 == q5) && (c4 == q4) && (c5 == q3) && (c6 == q1)) ||
		   ((c1 == q6) && (c2 == q5) && (c3 == q4) && (c4 == q3) && (c5 == q2) && (c6 == q1)) ||
		   ((c1 == q6) && (c2 == q4) && (c3 == q3) && (c4 == q2) && (c5 == q5) && (c6 == q1)) ||
		   ((c1 == q6) && (c2 == q3) && (c3 == q2) && (c4 == q5) && (c5 == q4) && (c6 == q1));
}
/*

bool eqs(string s1, string s2) {
	for (int sc = 0; sc < 6; sc++) {
		char c;
		c = s1[0];
		for (int i = 0; i < 5; i++) {
			s1[i] = s1[i + 1];
		}
		s1[5] = c;
		if (!(s1[0] == s2[0] && s1[5] == s2[5]) && !(s1[0] == s2[5] && s1[5] == s2[0])) {
			continue;
		}
		string st1, st2;
		st1 = s1.substr(1, 4);
		st2 = s2.substr(1, 4);
		for (int i = 0; i < 4; i++) {
			if (st1 == st2) {
				return true;
			}
			c = st2[0];
			for (int i = 0; i < 3; i++) {
				st2[i] = st2[i + 1];
			}
			st2[3] = c;
		}
		reverse(st2.begin(), st2.end());
		for (int i = 0; i < 4; i++) {
			if (st1 == st2) {
				return true;
			}
			c = st2[0];
			for (int i = 0; i < 3; i++) {
				st2[i] = st2[i + 1];
			}
			st2[3] = c;
		}
		

	}
	return false;
}
*/

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	freopen("cube.in", "r", stdin);
	freopen("cube.out", "w", stdout);

	//cout << eqs("ABCDEF", "FDCBEA");
	//return 0;

	string data[6];
	ms let[6];
	int get[6];
	for (int i = 0; i < 6; i++) {
		cin >> data[i];
		//reverse(data[i].begin(), data[i].end());
		for (int j = 1; j < data[i].length(); j++) let[i].insert(data[i][j]);
	}
	string s = "123456", curs, ans = "";
	while (true) {
		curs = "";
		for (int i = 0; i < s.length(); i++) 
			for (int j = 0; j < s.length(); j++)
				if (i == s[j] - '1') {
					curs += data[j][0];
					get[j] = i + 1;
					break;
				}
		ms s1, s2, s3;
		s1.insert(curs[1]);
		s1.insert(curs[2]);
		s1.insert(curs[3]);
		s1.insert(curs[4]);

		s2.insert(curs[0]);
		s2.insert(curs[2]);
		s2.insert(curs[4]);
		s2.insert(curs[5]);

		s3.insert(curs[0]);
		s3.insert(curs[1]);
		s3.insert(curs[3]);
		s3.insert(curs[5]);
		bool f = true;
		for (int i = 0; i < 6; i++) {
			if (get[i] == 1 || get[i] == 6) {
				bool f1 = true;

				if (!eq(s1, let[i])) f = false;
			}
			if (get[i] == 2 || get[i] == 4) {
				if (!eq(s2, let[i])) f = false;
			}
			if (get[i] == 3 || get[i] == 5) {
				if (!eq(s3, let[i])) f = false;
			}
		}
		if (f && ans != "" && eqs(ans, curs) ) {
			int kk = 0;
		}
		if (f && ans != "" && !eqs(ans, curs)) {
			cout << ans << endl << curs;
			return 0;
		}
		if (f) ans = curs;
		if (!next_permutation(s.begin(), s.end())) {
			break;
		}

	}
	if (ans != "") cout << ans; else cout << "Impossible";


	return 0;
}