#include <iostream>
#include <cstdio>
#include <string>
#include <cassert>

using namespace std;

int main() {
	freopen("black.in", "r", stdin);
	freopen("black.out", "w", stdout);
	const string BAD = "Impossible";
	const string AMB = "Ambiguous";
	const string UNQ = "Unique";
	int m, n, s, k;
	string t;
	cin >> m >> n >> s >> k >> t;
	int j = 0;
	while (j < t.size() && t[j] != '*') j++;
	int len = 0;
	while (j < t.size() && t[j] == '*') ++len, ++j;
	if (len == 0) {
		int up = k - 1, down = m - k;
		if (up < s && down < s) {
			cout << BAD;
		} else if (up >= s && down >= s) {
			cout << AMB;
		} else if (up >= s && down < s) {
			if (s < up) {
				cout << AMB;
			} else if (s == up) {
				if (s == n) {
					cout << UNQ;
				} else {
					cout << AMB;
				}
			} else {
				assert(0);
			}
		} else if (up < s && down >= s) {
			if (s < down) {
				cout << AMB;
			} else if (s == down) {
				if (s == n) {
					cout << UNQ;
				} else {
					cout << AMB;
				}
			} else {
				assert(0);
			}
		} else {
			assert(0);
		}
	} else if (len != s) {
		cout << BAD;		
	} else {
		for (int i = j; i < t.size(); i++) {
			if (t[i] == '*') {
				cout << BAD;
				return 0;
			}
		}
		if (s == 1 || k == 1 || k == m || s == m) {
			cout << UNQ;
		} else {
			cout << AMB;
		}
	}
	return 0;
}