#include <iostream>
#include <cstdio>
#include <string>
#include <algorithm>
#include <vector>
#include <cassert>
#include <set>

#define px first
#define py second
#define mp make_pair

using namespace std;

vector <char> A;
vector <string> B;
vector <char> C;
string can;
vector <string> ans;
int near[6][4] = {
	{1, 2, 3, 4},
	{0, 2, 4, 5},
	{0, 1, 3, 5},
	{0, 2, 4, 5},
	{0, 1, 3, 5},
	{1, 2, 3, 4}
};

bool found = false;

void gen(int n) {
	//if (found) return;
	if (n == 6) {
		vector <int> p;
		for (int i = 0; i < 6; i++) {
			p.push_back(i);
		}
		/*
		string cur;		
		for (int i = 0; i < C.size(); i++) {
			cur += C[i];
		}
		
		if (cur == "ACBOOO") {
			cout<<-1;
		}
		*/
		do {
			/*
			if (p[0] == 0 && p[1] == 1 && p[2] == 2 && p[3] == 5 && p[4] == 3 && p[5] == 4) {
				cout<<-1;
			}
			*/
			bool ok = true;
			for (int i = 0; i < 6; i++) {
				if (A[p[i]] == C[i]) { //first ones are equal
					string s;
					for (int j = 0; j < 4; j++) {
						s += C[near[i][j]];
						//assert(C[near[i][j]] != C[0]);
						/*if (near[i][j] == i) {
							cout<<-1;
						}*/
					}
					sort(s.begin(), s.end());
					if (s != B[p[i]]) {
						ok = false;
					}
				} else {
					ok = false;
				}
				if (!ok) break;
			}
			if (ok) {		
				string cur = "";
				for (int i = 0; i < C.size(); i++) {
					cur += C[i];
				}
				ans.push_back(cur);
				/*if (ans.size() == 2) {
					found = true;					
				}*/
				//return;
			}
		} while (next_permutation(p.begin(), p.end()));
		return;
	}
	for (int i = 0; i < can.size(); i++) {
		C.push_back(can[i]);
		gen(n + 1);
		//if (found) return;
		C.pop_back();
	}
}

vector <int> rot1(vector <int> w) {
	vector <int> v(6);
	v[0] = w[0];
	v[5] = w[5];
	for (int i = 1; i < 4; i++) {
		v[i + 1] = w[i];
	}
	v[1] = w[4];
	return v;
}

vector <int> rot2(vector <int> w) {
	vector <int> v(6);
	v[1] = w[1];
	v[3] = w[3];
	v[0] = w[2];
	v[2] = w[5];
	v[5] = w[4];
	v[4] = w[0];
	return v;
}

vector <int> rot3(vector <int> w) {
	vector <int> v(6);
	v[2] = w[2];
	v[4] = w[4];
	v[0] = w[1];
	v[1] = w[5];
	v[5] = w[3];
	v[3] = w[0];
	return v;
}

set <vector <int> > used;

void dfs(vector <int> v) {
	used.insert(v);
	vector <int> w;
	w = rot1(v);
	if (!used.count(w)) dfs(w);
	w = rot2(v);
	if (!used.count(w)) dfs(w);
	w = rot3(v);
	if (!used.count(w)) dfs(w);
}

int main() {
	freopen("cube.in", "r", stdin);
	freopen("cube.out", "w", stdout);	
	vector <int> GEN;
	for (int i = 0; i < 6; i++)
		GEN.push_back(i);
	dfs(GEN);
	vector <vector <int> > perm(used.begin(), used.end());
	//cout << used.size();		
	const string BAD = "Impossible";
	vector <bool> color(26);
	for (int i = 0; i < 6; i++) {
		string s;
		cin >> s;
		assert(s.size() == 5);
		for (int j = 0; j < 5; j++) {
			color[s[j] - 'A'] = true;
		}
		A.push_back(s[0]);
		s = s.substr(1);
		sort(s.begin(), s.end());
		B.push_back(s);
	}	
	for (int i = 0; i < color.size(); i++) {
		if (color[i]) {
			can += (char)('A' + i);
		}
	}
	if (can.size() > 6) {
		cout << BAD;
		return 0;
	}	
	gen(0);
	//assert(ans.size() <= 2);
	if (ans.empty()) cout << BAD;
	else {
		set <string> dbg(ans.begin(), ans.end());		
		//cout << dbg.size() << "\n";
		/*for (int i = 0; i < ans.size(); i++)
			cout << ans[i] << "\n";			*/
		set <string> U;
		vector <string> res;
		for (set<string>::iterator it = dbg.begin(); it != dbg.end(); ++it) {
			string s = *it;
			if (U.count(s)) continue;
			res.push_back(s);
			U.insert(s);
			for (int i = 0; i < perm.size(); i++) {
				string t;
				for (int j = 0; j < perm[i].size(); j++) {
					t += s[perm[i][j]];
				}
				U.insert(t);
			}
		}		
		//cout << res.size() << "\n";
		cout << res[0] << "\n";
		if (res.size() > 1) cout << res[1] << "\n";
	}
	return 0;
}