#include <iostream>
#include <cstdio>
#include <string>
#include <algorithm>
#include <vector>
#include <cassert>
#include <set>

using namespace std;

#define REP(i, n) for (int (i) = 0; (i) < (n); (i)++)

vector <vector <int> > v;
vector <int> c;
int n, k;
bool found;
int cnt;

void dfs(int x) {
	if (found) return;	
	bool OK = true;
	REP(i, n) {
		if (c[i] == -1) {
			OK = false;
		}
	}
	if (OK) {
		found = true;
		return;
	}
	vector <bool> used(k);
	REP(i, v[x].size()) {
		int to = v[x][i];
		if (c[to] != -1) used[c[to] - 1] = true;
	}
	//bool OK = false;
	REP(i, k) {
		if (!used[i]) {
			c[x] = i + 1;		
			/*if (c[5] == 1) {
				cout<<-1;
			}*/
			OK = true;
			REP(j, n) {
				if (c[j] == -1) {
					OK = false;
				}
			}
			if (OK) {
				found = true;
				return;
			}
			//bool foo = false;
			REP(j, v[x].size()) {
				int to = v[x][j];
				if (c[to] == -1) {
					//foo = true;
					dfs(to);
					if (found) {
						return;
					}
				}
			}
			//OK = true;
			//break;
		}
	}
	/*
	if (OK) {
		REP(i, v[x].size()) {
			int to = v[x][i];
			if (c[to] == -1) {
				dfs(to);
			}
		}
	}
	*/
}

void paint() {
	REP(i, n) c[i] = -1;	
	found = false;
	cnt = 0;
	dfs(0);
}

vector <bool> used;

bool DFS(int x, int mask) {
	if (mask == (1 << k) - 1) return true;
	if (mask & (1 << (c[x] - 1))) return false;
	mask += (1 << (c[x] - 1));
	used[x] = true;	
	REP(i, v[x].size()) {
		int to = v[x][i];
		if (!used[to]) {
			DFS(to, mask);
		}
	}
}

bool check() {
	REP(i, n) {
		used.assign(n, false);
		if (!DFS(i, 0)) {
			return false;
		}
	}
	return true;
}

int main() {
	freopen("galaxy.in", "r", stdin);
	freopen("galaxy.out", "w", stdout);
	int m;
	scanf("%d %d %d", &n, &k, &m);
	v.resize(n);
	c.resize(n);
	REP(i, m) {
		int x, y;
		scanf("%d %d", &x, &y);
		--x, --y;
		v[x].push_back(y);
		v[y].push_back(x);
	}
	for(;;) {
		paint();
		//break;
		if (check()) break;
	}
	//cout << found << "\n";
	REP(i, n) printf("%d ", c[i]);
	return 0;
}