import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Locale;
import java.util.Scanner;
import java.util.Stack;


public class D {


	private static int[] faces;
	
	private static int m = 0;	
	private static void sort(){
		for(int i = 0; i < faces.length; i++){
			for(int j = i+1; j < faces.length; j++){
				if(faces[i] < faces[j]){				
					int tmp = faces[i];
					faces[i] = faces[j];
					faces[j] = tmp;
				}
			}
		}
	}
	
	private static Object[] results;

	private static int[] faces2;
	public static void main(String[] args) throws FileNotFoundException {
		Locale.setDefault(Locale.US);
				
		m = 1;	
		double totalE = 0;
		Scanner sc = new Scanner(new File("dice.in"));		
		int n = sc.nextInt();		
		faces = new int[n];	
		faces2 = new int[n];
		results = new Object[n];
		for(int i = 0; i < n; i++){
			faces[i] = sc.nextInt();
			faces2[i] = faces[i];
		}
		sort();	

		for(int face:faces){
			totalE += E(face);			
		}		
		PrintWriter pw = new PrintWriter(new File("dice.out"));
		pw.println(String.format("%.5f", totalE));
		for(Object o:results){
			pw.println((String)o);
		}
		pw.close();
	}

	private static double E(int face){
		double sum = 0;
		double pr = 1.0/face;
		String res = "";
		for(int i = 0; i < face; i++){
			res += m + " ";
			sum += pr * m++;
		}		
		for(int i = 0; i < faces2.length; i++){
			if(faces2[i] == face){
				results[i] = res;
			}
		}		
		return sum;
	}
}
