#include <cstdio>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <iostream>
#include <queue>
#include <algorithm>
#include <ctime>
#include <cassert>

using namespace std;

#define pb push_back
#define mp make_pair
#define x first
#define y second
#define fs x
#define sc y
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
vector <int> vi;

#define FILENAME "cube"

int opp[6] = {5, 3, 4, 1, 2, 0};

const char* rots[6] = {"1234", "4520", "0153", "0254", "3510", "4321"};

char s[6][10];

int used[30];
char cur[10];
char test[10];
char ans[10];
char test2[10];

int p[6], p2[6];


// true is distinct
bool check() {
    for (int i = 0; i < 6; i++) {
        test2[i] = cur[p[i]];
    }

    for (int i = 0; i < 6; i++) {
        p2[0] = i;
        p2[5] = opp[i];
        for (int rot = 0; rot < 4; rot++) {
            for (int j = 0; j < 4; j++) {
                p2[j + 1] = rots[i][(rot + j) & 3] - '0';
            }

            // and now check
            int eq = 1;
            for (int j = 0; j < 6; j++) {
                if (test2[p2[j]] != ans[j]) {
                    eq = 0;
                    break;
                }
            }
            if (eq) {
                return false;
            }
        }
    }
    return true;
}

int main() {
    freopen(FILENAME".in", "r", stdin);
    freopen(FILENAME".out", "w", stdout);

    for (int i = 0; i < 6; i++) {
        scanf("%s", s[i]);
        cur[i] = s[i][0];
        sort(s[i] + 1, s[i] + 5);
    }

    for (int i = 0; i < 6; i++) {
        p[i] = i;
    }

    int num_was_out = 0;

    do {
        memset(used, 0, sizeof(used));

        int correct = 1;
        for (int i = 0; i < 6; i++) {
            test[0] = cur[p[i]];
            int Q = 1;
            for (int j = 0; j < 6; j++) {
                if (j != i && j != opp[i]) {
                    test[Q++] = cur[p[j]];
                }
            }
            sort(test + 1, test + 5);

            int fnd = 0;
            for (int j = 0; j < 6; j++) {
                if (used[j]) continue;

                int good = 1;
                for (int k = 0; k < 5; k++) {
                    if (test[k] != s[j][k]) {
                        good = 0;
                    }
                }
                if (good) {
                    used[j] = 1;
                    fnd = 1;
                    break;
                }
            }

            if (!fnd) {
                correct = 0;
            }
        }

        if (correct) {
            if (num_was_out == 1) {
                if (!check()) {
                    continue;
                }

                ans[6] = 0;
                puts(ans);
                
                for (int i = 0; i < 6; i++) {
                    putchar(cur[p[i]]);
                }
                puts("");
                return 0;
            } else {
                for (int i = 0; i < 6; i++) {
                    ans[i] = cur[p[i]];
                }
                num_was_out++;
            }
        }
    } while (next_permutation(p, p + 6));

    if (num_was_out == 0) {
        puts("Impossible");
    } else {
        ans[6] = 0;
        puts(ans);
    }   

    return 0;
}
