#include <cstdio>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <iostream>
#include <queue>
#include <algorithm>
#include <ctime>
#include <cassert>

using namespace std;

#define pb push_back
#define mp make_pair
#define x first
#define y second
#define fs x
#define sc y
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
typedef vector <int> vi;

#define FILENAME "galaxy"
int n,k,m,x,y;
int cnt=0;
int gg[1000];
vi g[1000000];
int b[1000000];
int cl[1000000];

void add(int x,int y){
    g[x].pb(y);
}
void dfs(int v){
    if (b[v]==1) return;
    b[v]=1;
    if (cl[v]==-1){
        cnt++;
        for (int i=0;i<sz(g[v]);i++){
            int e=g[v][i];
            if (cl[e]!=-1){
                gg[cl[e]]=cnt;
            }
        }
        for (int i=0;i<k;i++){
            if (gg[(i+1)%k]==cnt && gg[(i)%k]!=cnt){
                cl[v]=i;
            }
        }
    }
    assert(cl[v]!=-1);
    for (int i=0;i<sz(g[v]);i++){
        int e=g[v][i];
        dfs(e);
    }
}
int main() {
    freopen(FILENAME".in", "r", stdin);
    freopen(FILENAME".out", "w", stdout);
    scanf("%d%d%d",&n,&k,&m);
    for (int i=0;i<m;i++){
        scanf("%d%d",&x,&y);
        x--;
        y--;
        add(x,y);
        add(y,x);
    }
    for (int i=0;i<n;i++){
        cl[i]=-1;
    }
    for (int i=0;i<k;i++){
        cl[i]=i;
    }
    dfs(0);
    for (int i=0;i<n;i++){
        assert(cl[i]!=-1);
        printf("%d ",cl[i]+1);
    }
    return 0;
}