#include <cstdio>
#include <cmath>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <iostream>
#include <queue>
#include <algorithm>
#include <ctime>
#include <cassert>

using namespace std;

#define pb push_back
#define mp make_pair
#define x first
#define y second
#define fs x
#define sc y
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;
typedef pair <int, int> pii;
vector <int> vi;

#define FILENAME "john"


#define maxn 100010

int n;
pii inits[maxn];
int ps[maxn];
int tmp[maxn];


ll merge_sort(int l, int r) {
    if (l + 1 == r) {
        return 0;
    }
    if (l + 2 == r) {
        if (ps[l] > ps[l + 1]) {
            swap(ps[l], ps[l + 1]);
            return 1;
        }
        return 0;
    }

    int m = (l + r) / 2;

    ll ans = merge_sort(l, m) + merge_sort(m, r);
    for (int i = l; i < r; i++) {
        tmp[i] = ps[i];
    }

    int i = l, j = m;

    for (int ptr = l; ptr < r; ptr++) {
        if (i == m) {
            ps[ptr] = tmp[j++];
        } else if (j == r) {
            ps[ptr] = tmp[i++];
        } else if (tmp[i] < tmp[j]) {
            ps[ptr] = tmp[i++];
        } else {
            ps[ptr] = tmp[j++];
            ans += m - i;
        }
    }

    return ans;
}

int main() {
    freopen(FILENAME".in", "r", stdin);
    freopen(FILENAME".out", "w", stdout);

    scanf("%d", &n);
    for (int i = 0; i < n; i++) {
        scanf("%d %d", &inits[i].x, &inits[i].y);
    }
    sort(inits, inits + n);

    for (int i = 0; i < n; i++) {
        ps[i] = inits[i].y;
    }

    printf("%I64d\n", merge_sort(0, n));

    return 0;
}