#include <iostream>
#include <fstream>
#include <cmath>
#include <string>

using namespace std;

#define IN_FILE  "dice.in"
#define OUT_FILE "dice.out"
/**/
#ifdef IN_FILE
	ifstream in;
	FILE *out;
#else
#define in cin
#define out stdout
#endif

int main() {
#ifdef IN_FILE
	in.open(IN_FILE);
	out = fopen(OUT_FILE, "w");
#endif

	int n;
	in >> n;
	int *bones = new int[n];
	long m = 0;
	for(int i = 0; i < n; i++) { in >> bones[i]; m += bones[i]; }

	double me = (m+m*m)/4.0*0;

	long sm = m;
	for(int k = 0; k < n; k++) {
		double sum = 0;
		for(int i = sm-bones[k]+1; i <= sm; i++) {
			sum += i;
		}

		me += sum/bones[k];
		sm -= bones[k];
	}

	fprintf(out, "%05f\n", me);
	
	int mm = (m+m*m)/(2*n);
	for(int k = 0; k < n; k++) {
		for(int i = m-bones[k]+1; i <= m; i++) {
			fprintf(out, "%d ", i);
		}
		fprintf(out, "\n");
		m -= bones[k];
	}


#ifdef IN_FILE
	in.close();
	fclose(out);
#else
	char hsvgsdvbsd;
	in >> hsvgsdvbsd;
#endif
	return 0;
}