#include <iostream>
#include <fstream>
#include <cmath>
#include <string>

using namespace std;

#define IN_FILE  "flat.in"
#define OUT_FILE "flat.out"
/**/
#ifdef IN_FILE
	ifstream in;
	FILE *out;
#else
#define in cin
#define out stdout
#endif

int main() {
#ifdef IN_FILE
	in.open(IN_FILE);
	out = fopen(OUT_FILE, "w");
#endif

	long n, c;
	in >> n >> c;
	
	long sq = 0;
	long balk = 0;
	long bed = 0;

	char type[16];
	for(int i = 0; i < n; i++) {
		long a;
		in >> a >> type;
		sq += a;
		if(strcmp(type, "bedroom") == 0) bed += a;
		else if(strcmp(type, "balcony") == 0) balk += a;
	}

	fprintf(out, "%d\n%d\n%06f", sq, bed, (sq - balk/2.0)*c);

#ifdef IN_FILE
	in.close();
	fclose(out);
#else
	char hsvgsdvbsd;
	in >> hsvgsdvbsd;
#endif
	return 0;
}