#include <fstream>
#include <cstdio>
#include <iostream>
using namespace std;

struct Group
{
	int count;
	int start;
	int end;
	bool run;
};

int main()
{
	ifstream fin("dice.in");
	int count;
	fin>>count;

	Group * gr = new Group[count];
	int sum = 0;

	for (int i = 0; i<count; i++)
	{
		fin>>gr[i].count;
		sum += gr[i].count;
		gr[i].run = false;
	}

//	cout<<sum<<endl;
	fin.close();

	bool flag = true;
	while (flag)
	{
		int imin = 0;
		while (gr[imin].run)
			imin++;
		for (int i = 0; i<count; i++)
			if (gr[imin].count > gr[i].count && !gr[i].run)
				imin = i;
		if (imin >= count)
		{
			flag = false;
		}
		else
		{
			gr[imin].start = sum - gr[imin].count + 1;
			gr[imin].end   = sum;//gr[imin].count;
//			cout<<"GR["<<imin<<"] start = "<<gr[imin].start<<endl;
//			cout<<"GR["<<imin<<"] end   = "<<gr[imin].end  <<endl;
			sum =sum - gr[imin].count;
		}
		gr[imin].run = true;
	}

	int vmin = 0;
	int vmax = 0;

	for (int i = 0; i<count; i++)
	{
		vmin += gr[i].start;
		vmax += gr[i].end;
	}

//	cout<<vmin<<endl;
//	cout<<vmax<<endl;

	double e = ((double)vmin + vmax)/2;

	FILE * f = fopen("dice.out","w");
	fprintf(f,"%1.5lf\n",e);

	for (int i = 0; i<count; i++)
	{
		for (int k = gr[i].start; k<= gr[i].end; k++)
			fprintf(f,"%d ",k);
		fprintf(f,"\n");
	}

//	char ch;
//	cin>>ch;
	return 0;
}