#include <cstdio>
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

/*bool byFirst(const pair<int, int> &a, const pair<int, int> &b){
	return (a.first < b.first || (a.first == b.first && a.second < b.second));
}*/
const int maxN = 100 * 1000 + 10;
pair <int, int> A[maxN];
int a[maxN], Left[maxN], Right[maxN];
long long inv, ans;

void marge(int l, int r) {
	if (l == r) {
		return;
	}
	int i, j, k, l1, l2, m = (l + r) / 2;
	marge(l, m);
	marge(m + 1, r);
	for (i = l; i <= m; ++i) {
		Left[i - l] = a[i];
	}
	for (i = m + 1; i <= r; ++i) {
		Right[i - m - 1] = a[i];
	}
	i = j = 0;
	l1 = m - l + 1;
	l2 = r - m;
	k = l;
	while (i < l1 && j < l2) {
		if (Left[i] <= Right[j]) {
			a[k] = Left[i];
			++i;
		} else {
			inv += l1 - i;
			//cout << l2 << " " << i + l1 << endl;
			a[k] = Right[j];
			++j;
		}
		++k;
	}
	for (; i < l1; ++i) {
		a[k] = Left[i];
		++k;
	}
	for (; j < l2; ++j) {
		a[k] = Right[j];
		++k;
	}
}


int main() {
	freopen("john.in", "r", stdin); freopen("john.out", "w", stdout);
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	
	int n, i;
	cin >> n;
	vector < pair <int,int> > A(n);
	for( i=0; i<n; ++i)
		cin >> A[i].first >> A[i].second;

	sort(A.begin(), A.end());
	for (i = 0; i < n; ++i) {
		a[i] = A[i].second;
	}
	inv = 0;
	marge(0, n - 1);	
	ans = inv;
	for (i = 0; i < n; ++i) cout << a[i] << " "; cout << endl;

	for (i = 0 ; i < n; ++i)
		swap(A[i].first, A[i].second);

	sort(A.begin(), A.end());
	for (i = 0; i < n; ++i) {
		a[i] = A[i].second;
	}
	inv = 0;
	marge(0, n - 1);	
	for (i = 0; i < n; ++i) cout << a[i] << " "; cout << endl;

	cout << min(ans, inv);

	return 0;
}