#include <stdio.h>
#include <stdlib.h>

int main(void) {
	int dice_counts;
	FILE *in = fopen("dice.in", "r");
	fscanf(in, "%d\n", &dice_counts);


	int *gran_count = (int*)malloc(dice_counts * sizeof(int));
	int m = 0;
	for (int i = 0; i < dice_counts; i++) {
		fscanf(in, "%d ", &gran_count[i]);
		m += gran_count[i];
	}

	// 2)
	
	int tmp;
	for (int i = 0; i < dice_counts; i ++ ) {
		for (int j = i; j < dice_counts; j ++ ) {
			if (gran_count[i] > gran_count[j]) {
				tmp = gran_count[i];
				gran_count[i] = gran_count[j];
				gran_count[j] = tmp;
			}
		}
	}

	// 3)

	int **digits = (int**)malloc(dice_counts * sizeof(int*));
	for (int i = 0; i < dice_counts; i++) {
		digits[i] = (int*)malloc(gran_count[i]*(sizeof(int)));
	}
	int *mas = (int*)malloc(dice_counts*sizeof(int));
	

	
		
		for (int i=0; i < dice_counts; i++) {
			digits[i][0] = m - i;
			mas[i] = digits[i][0];
			for (int j = 1; j < gran_count[0]; j++) {
				digits[i][j] = digits[i][j-1] - dice_counts;
				mas[i] += digits[i][j];
			}
		}

		int p=1;
		while(p< dice_counts){
		for (int i=p; i < dice_counts; i++) {
			for (int j = gran_count[p-1]; j < gran_count[p]; j++) {
				digits[i][j] = digits[i][j-1] - dice_counts+1*p;
				mas[i] += digits[i][j];
			}
		}
		p++;
		}


	// E:
	double e = 0;
	for (int i = 0; i < dice_counts; i++) {
		e += mas[i]/(1.0*gran_count[i]);
	}
	//---

	FILE *out = fopen("dice.out", "w");
	fprintf(out, "%0.5lf\n", e);
	for (int i = 0; i < dice_counts; i++) {
		for (int j = gran_count[i] - 1; j >= 0 ; j--) {
			fprintf(out, "%d ", digits[i][j]);
		}
		fprintf(out, "\n");
	}
	fclose(out);
	// ---
	for (int i = 0; i < dice_counts; i++) {
		free(digits[i]);
	}
	free(mas);
	free(digits);
	free(gran_count);
	return 0;
}