#include <stdio.h>
#include <algorithm>
#include <vector>

using namespace std;

#define NMAX 200100

vector<int> va, vb;
int x[NMAX], y[NMAX];
int N, i, ax, ay, bx, by, q, r1, r2, cnta, cntb, te;

int CountInside(int distance, const vector<int>& v) {
	int li, ls, mid, answer = -1;
	li = 0; ls = v.size() - 1;
	while (li <= ls) {
		mid = (li + ls) / 2;
		if (v[mid] <= distance) {
			answer = mid;
			li = mid + 1;
		} else
			ls = mid - 1;
	}
	
	return answer + 1;
}

int main() {
	//freopen("x.txt", "r", stdin);
	
	te = 0;
	while (1) {
		scanf("%d", &N);
		if (!N)
			break;
		for (i = 1; i <= N; i++)
			scanf("%d %d", &x[i], &y[i]);
		scanf("%d %d %d %d %d", &ax, &ay, &bx, &by, &q);

		va.clear();
		for (i = 1; i <= N; i++) {
			va.push_back((x[i] - ax) * (x[i] - ax) + (y[i] - ay) * (y[i] - ay));
		}
		sort(va.begin(), va.end());

		vb.clear();
		for (i = 1; i <= N; i++) {
			vb.push_back((x[i] - bx) * (x[i] - bx) + (y[i] - by) * (y[i] - by));
		}
		sort(vb.begin(), vb.end());

		te++;
		printf("Case %d:\n", te);

		while (q--) {
			scanf("%d %d", &r1, &r2);
			r1 *= r1;
			r2 *= r2;
			cnta = CountInside(r1, va);
			cntb = CountInside(r2, vb);

			if (cnta + cntb >= N)
				printf("0\n");
			else
				printf("%d\n", N - (cnta + cntb));
		}
	}
	
	return 0;
}
