#include <stdio.h>
#include <string.h>

#define NMAX 111
#define HMAX 1111
#define INF 1000000000

int N, H, i, j, k, L, S, poz, cnt, C;
int EN[NMAX][NMAX], EH[NMAX][HMAX];
int s[HMAX], Emin[HMAX][NMAX], next[HMAX][NMAX];

#define LMAX 100000
char line[LMAX];

int main() {
	//freopen("x.txt", "r", stdin);
	scanf("%d %d ", &N, &H);
	for (i = 0; i < N; i++)
		for (j = 0; j < N; j++)
			scanf("%d ", &EN[i][j]);
	
	for (i = 0; i < N; i++)
		for (j = 0; j < H; j++)
			scanf("%d ", &EH[i][j]);

	while (1) {
		line[0] = 0;
		fgets(line, LMAX - 3, stdin);
		L = strlen(line);
		while (L > 0 && (line[L - 1] < '0' || line[L - 1] > '9'))
			L--;
		line[L] = 0;
		if (L == 0)
			break;
		
		poz = 0;
		S = 0;
	
		//fprintf(stderr, "L=%d line=|%s|\n", L, line);
		while (poz < L) {
			sscanf(line + poz, "%d%n", &s[S], &cnt);
			S++;
			poz += cnt;
		}
		
		for (i = 1; i < N; i++) {
			Emin[S - 1][i] = EH[i][s[S - 1]] + EN[i][0];
			next[S - 1][i] = -1;
		}
		
		for (i = S - 2; i >= 0; i--)
			for (j = 1; j < N; j++) {
				Emin[i][j] = INF;
				for (k = 1; k < N; k++) {
					C = EH[j][s[i]] + EN[j][k] + Emin[i + 1][k];
					if (C < Emin[i][j]) {
						Emin[i][j] = C;
						next[i][j] = k;
					}
				}
			}

		C = INF;
		for (j = 1; j < N; j++)
			if (EN[0][j] + Emin[0][j] < C) {
				C = EN[0][j] + Emin[0][j];
				i = j;
			}
		
		printf("%d\n", C);
		for (j = 0; j < S; j++) {
			printf("%d", i);
			if (j < S - 1)
				printf(" ");
			i = next[j][i];
		}
		printf("\n");
	}

	return 0;
}
