#include <stdio.h>
#include <string.h>

#define PMAX 100000
#define MAXPRIMES 100000

char is_not_prime[PMAX];

void FindPrimes() {
	for (int i = 2; i < PMAX; i++) {
		if (is_not_prime[i])
			continue;
		for (int j = 2 * i; j < PMAX; j += i)
			is_not_prime[j] = 1;
	}
}

#define NMAX 1000

int p10[5] = {1, 10, 100, 1000, 10000};
char line[NMAX];
int N, i, j, num, pmax;

int main() {
	FindPrimes();

	//freopen("x.txt", "r", stdin);

	while (1) {
		scanf("%s", line);
		N = strlen(line);
		if (N == 1 && line[0] == '0')
			break;
		pmax = 0;
		for (i = 0; i < N; i++) {
			num = 0;
			for (j = 0; j <= 4 && i - j >= 0; j++) {
				num += (line[i - j] - '0') * p10[j];
				if (!is_not_prime[num] && num > pmax)
					pmax = num;
			}
		}
		
		printf("%d\n", pmax);
	}
	
	return 0;
}
